#ifndef __APM2D_ADAPTIVE_H__
#define __APM2D_ADAPTIVE_H__

#include "apm2d.h"

//////////////////////////////////////////////////////////////////////
// APM2D Private Methods 
//   implemented as //static functions to keep them out of the apm2d.h file

//static 
BOOL IntersectionEEAdaptive(DOUBLE *pdV_x, DOUBLE *pdV_y,
			    DOUBLE dE00_x, DOUBLE dE00_y, 
			    DOUBLE dE01_x, DOUBLE dE01_y,
			    DOUBLE dE10_x, DOUBLE dE10_y, 
			    DOUBLE dE11_x, DOUBLE dE11_y);
//static 
APM2D::EdgeZoneType EdgeZoneAdaptive(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dE10_x, DOUBLE dE10_y, 
				     DOUBLE dE11_x, DOUBLE dE11_y);

//static 
INT_32 DistanceCompareV_VVAdaptive(DOUBLE dV0_x, DOUBLE dV0_y,
				   DOUBLE dV1_x, DOUBLE dV1_y, 
				   DOUBLE dV2_x, DOUBLE dV2_y);

//static 
INT_32 DistanceCompareV_VLAdaptive(DOUBLE dV0_x, DOUBLE dV0_y,
				   DOUBLE dV1_x, DOUBLE dV1_y, 
				   DOUBLE dE20_x, DOUBLE dE20_y, 
				   DOUBLE dE21_x, DOUBLE dE21_y);

//////////////////////////////////////////////////////////////////////
// EE Orientation Functions

//static
DOUBLE OrientationExEAdaptive(DOUBLE dE00_x, DOUBLE dE00_y,
			      DOUBLE dE01_x, DOUBLE dE01_y,
			      DOUBLE dE10_x, DOUBLE dE10_y,
			      DOUBLE dE11_x, DOUBLE dE11_y);
  
//static
DOUBLE OrientationEdotEAdaptive(DOUBLE dE00_x, DOUBLE dE00_y,
				DOUBLE dE01_x, DOUBLE dE01_y,
				DOUBLE dE10_x, DOUBLE dE10_y,
				DOUBLE dE11_x, DOUBLE dE11_y);

//////////////////////////////////////////////////////////////////////
// VVV Functions

//static
DOUBLE OrientationVVVValueAdaptive(DOUBLE dV0_x, DOUBLE dV0_y,
				   DOUBLE dV1_x, DOUBLE dV1_y,
				   DOUBLE dV2_x, DOUBLE dV2_y);

#endif // __APM2D_ADAPTIVE_H__
