#ifndef __APM2D_MPFUN_H__
#define __APM2D_MPFUN_H__

#include "apm2d.h"

//////////////////////////////////////////////////////////////////////
// APM2D Private Methods 
//   implemented as //static functions to keep them out of the apm2d.h file

//static 
inline
BOOL IntersectionEEMPFUN(DOUBLE *pdV_x, DOUBLE *pdV_y,
			 DOUBLE dE00_x, DOUBLE dE00_y, 
			 DOUBLE dE01_x, DOUBLE dE01_y,
			 DOUBLE dE10_x, DOUBLE dE10_y, 
			 DOUBLE dE11_x, DOUBLE dE11_y){return 0;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
				  DOUBLE dE10_x, DOUBLE dE10_y, 
				  DOUBLE dE11_x, DOUBLE dE11_y){return APM2D::eztStart;}

//static 
inline
INT_32 DistanceCompareV_VVMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
				DOUBLE dV1_x, DOUBLE dV1_y, 
				DOUBLE dV2_x, DOUBLE dV2_y){return 0;}

//static 
inline
INT_32 DistanceCompareV_VLMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
				DOUBLE dV1_x, DOUBLE dV1_y, 
				DOUBLE dE20_x, DOUBLE dE20_y, 
				DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareV_LLMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
				DOUBLE dE10_x, DOUBLE dE10_y, 
				DOUBLE dE11_x, DOUBLE dE11_y,
				DOUBLE dE20_x, DOUBLE dE20_y, 
				DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareEvv_VVMPFUN(DOUBLE dE0A_x, DOUBLE dE0A_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dV1_x, DOUBLE dV1_y, 
				  DOUBLE dV2_x, DOUBLE dV2_y){return 0;}

//static 
inline
INT_32 DistanceCompareEvv_VLMPFUN(DOUBLE dE0A_x, DOUBLE dE0A_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dV1_x, DOUBLE dV1_y, 
				  DOUBLE dE20_x, DOUBLE dE20_y, 
				  DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareEvv_LLMPFUN(DOUBLE dE0A_x, DOUBLE dE0A_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dE10_x, DOUBLE dE10_y, 
				  DOUBLE dE11_x, DOUBLE dE11_y,
				  DOUBLE dE20_x, DOUBLE dE20_y, 
				  DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareElv_VVMPFUN(DOUBLE dE00_x, DOUBLE dE00_y,
				  DOUBLE dE01_x, DOUBLE dE01_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dV1_x, DOUBLE dV1_y, 
				  DOUBLE dV2_x, DOUBLE dV2_y){return 0;}

//static 
inline
INT_32 DistanceCompareElv_VLMPFUN(DOUBLE dE00_x, DOUBLE dE00_y,
				  DOUBLE dE01_x, DOUBLE dE01_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dV1_x, DOUBLE dV1_y, 
				  DOUBLE dE20_x, DOUBLE dE20_y, 
				  DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareL_VVMPFUN(DOUBLE dE00_x, DOUBLE dE00_y,
				DOUBLE dE01_x, DOUBLE dE01_y,
				DOUBLE dV1_x, DOUBLE dV1_y, 
				DOUBLE dV2_x, DOUBLE dV2_y){return 0;}

//////////////////////////////////////////////////////////////////////
// EE Orientation Functions

//static
inline
INT_32 OrientationExEMPFUN(DOUBLE dE00_x, DOUBLE dE00_y,
			   DOUBLE dE01_x, DOUBLE dE01_y,
			   DOUBLE dE10_x, DOUBLE dE10_y,
			   DOUBLE dE11_x, DOUBLE dE11_y){return 0;}
  
//static
inline
INT_32 OrientationEdotEMPFUN(DOUBLE dE00_x, DOUBLE dE00_y,
			     DOUBLE dE01_x, DOUBLE dE01_y,
			     DOUBLE dE10_x, DOUBLE dE10_y,
			     DOUBLE dE11_x, DOUBLE dE11_y){return 0;}

//////////////////////////////////////////////////
// Inscribed Circle Center Functions
//
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVVVMPFUN(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dV00_x, DOUBLE dV00_y,
			      DOUBLE dV0_x, DOUBLE dV0_y,
			      DOUBLE dV01_x, DOUBLE dV01_y,
			      DOUBLE dV10_x, DOUBLE dV10_y,
			      DOUBLE dV1_x, DOUBLE dV1_y,
			      DOUBLE dV11_x, DOUBLE dV11_y,
			      DOUBLE dV20_x, DOUBLE dV20_y,
			      DOUBLE dV2_x, DOUBLE dV2_y,
			      DOUBLE dV21_x, DOUBLE dV21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVVVMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dV1_x, DOUBLE dV1_y,
				     DOUBLE dV2_x, DOUBLE dV2_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVVV_VMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_x, DOUBLE dV1_y,
					 DOUBLE dV2_x, DOUBLE dV2_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVVV_EMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_x, DOUBLE dV1_y,
					 DOUBLE dV2_x, DOUBLE dV2_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}

//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVVEMPFUN(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dV00_x, DOUBLE dV00_y,
			      DOUBLE dV0_x, DOUBLE dV0_y,
			      DOUBLE dV01_x, DOUBLE dV01_y,
			      DOUBLE dV10_x, DOUBLE dV10_y,
			      DOUBLE dV1_x, DOUBLE dV1_y,
			      DOUBLE dV11_x, DOUBLE dV11_y,
			      DOUBLE dE20_x, DOUBLE dE20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVVEMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dV1_x, DOUBLE dV1_y,
				     DOUBLE dE20_x, DOUBLE dE20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVVE_VMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_x, DOUBLE dV1_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVVE_EMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_x, DOUBLE dV1_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVVEAntiparallelMPFUN(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
					  DOUBLE dV00_x, DOUBLE dV00_y,
					  DOUBLE dV0_x, DOUBLE dV0_y,
					  DOUBLE dV01_x, DOUBLE dV01_y,
					  DOUBLE dV10_x, DOUBLE dV10_y,
					  DOUBLE dV1_x, DOUBLE dV1_y,
					  DOUBLE dV11_x, DOUBLE dV11_y,
					  DOUBLE dE20_x, DOUBLE dE20_y, 
					  DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVVEAntiparallelMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
						 DOUBLE dV1_x, DOUBLE dV1_y,
						 DOUBLE dE20_x, DOUBLE dE20_y, 
						 DOUBLE dE21_x, DOUBLE dE21_y,
						 DOUBLE dE30_x, DOUBLE dE30_y,
						 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVVE_VAntiparallelMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
						     DOUBLE dV1_x, DOUBLE dV1_y,
						     DOUBLE dE20_x, DOUBLE dE20_y, 
						     DOUBLE dE21_x, DOUBLE dE21_y,
						     DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVVE_EAntiparallelMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
						     DOUBLE dV1_x, DOUBLE dV1_y,
						     DOUBLE dE20_x, DOUBLE dE20_y, 
						     DOUBLE dE21_x, DOUBLE dE21_y,
						     DOUBLE dE30_x, DOUBLE dE30_y,
						     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVvEMPFUN(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dV00_x, DOUBLE dV00_y,
			      DOUBLE dV0_x, DOUBLE dV0_y,
			      DOUBLE dV01_x, DOUBLE dV01_y,
			      DOUBLE dV1_E20_x, DOUBLE dV1_E20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVvEMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dV1_E20_x, DOUBLE dV1_E20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVvE_VMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_E20_x, DOUBLE dV1_E20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVvE_EMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_E20_x, DOUBLE dV1_E20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterEvVMPFUN(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dE00_x, DOUBLE dE00_y,
			      DOUBLE dE01_V1_x, DOUBLE dE01_V1_y, 
			      DOUBLE dV20_x, DOUBLE dV20_y,
			      DOUBLE dV2_x, DOUBLE dV2_y,
			      DOUBLE dV21_x, DOUBLE dV21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneEvVMPFUN(DOUBLE dE00_x, DOUBLE dE00_y,
				     DOUBLE dE01_V1_x, DOUBLE dE01_V1_y, 
				     DOUBLE dV2_x, DOUBLE dV2_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleEvV_VMPFUN(DOUBLE dE00_x, DOUBLE dE00_y,
					 DOUBLE dE01_V1_x, DOUBLE dE01_V1_y, 
					 DOUBLE dV2_x, DOUBLE dV2_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleEvV_EMPFUN(DOUBLE dE00_x, DOUBLE dE00_y,
					 DOUBLE dE01_V1_x, DOUBLE dE01_V1_y, 
					 DOUBLE dV2_x, DOUBLE dV2_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVEEMPFUN(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dV00_x, DOUBLE dV00_y,
			      DOUBLE dV0_x, DOUBLE dV0_y,
			      DOUBLE dV01_x, DOUBLE dV01_y,
			      DOUBLE dE10_x, DOUBLE dE10_y, 
			      DOUBLE dE11_x, DOUBLE dE11_y,
			      DOUBLE dE20_x, DOUBLE dE20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVEEMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dE10_x, DOUBLE dE10_y, 
				     DOUBLE dE11_x, DOUBLE dE11_y,
				     DOUBLE dE20_x, DOUBLE dE20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVEE_VMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVEE_EMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVEEAntiparallelMPFUN(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
					  DOUBLE dV00_x, DOUBLE dV00_y,
					  DOUBLE dV0_x, DOUBLE dV0_y,
					  DOUBLE dV01_x, DOUBLE dV01_y,
					  DOUBLE dE10_x, DOUBLE dE10_y, 
					  DOUBLE dE11_x, DOUBLE dE11_y,
					  DOUBLE dE20_x, DOUBLE dE20_y, 
					  DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVEEAntiparallelMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
						 DOUBLE dE10_x, DOUBLE dE10_y, 
						 DOUBLE dE11_x, DOUBLE dE11_y,
						 DOUBLE dE20_x, DOUBLE dE20_y, 
						 DOUBLE dE21_x, DOUBLE dE21_y,
						 DOUBLE dE30_x, DOUBLE dE30_y,
						 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVEE_VAntiparallelMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
						     DOUBLE dE10_x, DOUBLE dE10_y, 
						     DOUBLE dE11_x, DOUBLE dE11_y,
						     DOUBLE dE20_x, DOUBLE dE20_y, 
						     DOUBLE dE21_x, DOUBLE dE21_y,
						     DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVEE_EAntiparallelMPFUN(DOUBLE dV0_x, DOUBLE dV0_y,
						     DOUBLE dE10_x, DOUBLE dE10_y, 
						     DOUBLE dE11_x, DOUBLE dE11_y,
						     DOUBLE dE20_x, DOUBLE dE20_y, 
						     DOUBLE dE21_x, DOUBLE dE21_y,
						     DOUBLE dE30_x, DOUBLE dE30_y,
						     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCentervEEMPFUN(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dv0_E10_x, DOUBLE dV0_E10_y, 
			      DOUBLE dE11_x, DOUBLE dE11_y,
			      DOUBLE dE20_x, DOUBLE dE20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZonevEEMPFUN(DOUBLE dv0_E10_x, DOUBLE dV0_E10_y, 
				     DOUBLE dE11_x, DOUBLE dE11_y,
				     DOUBLE dE20_x, DOUBLE dE20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCirclevEE_VMPFUN(DOUBLE dv0_E10_x, DOUBLE dV0_E10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCirclevEE_EMPFUN(DOUBLE dv0_E10_x, DOUBLE dV0_E10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterEEvMPFUN(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dE00_x, DOUBLE dE00_y, 
			      DOUBLE dE01_x, DOUBLE dE01_y,
			      DOUBLE dE10_x, DOUBLE dE10_y, 
			      DOUBLE dE11_V2_x, DOUBLE dE11_V2_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneEEvMPFUN(DOUBLE dE00_x, DOUBLE dE00_y, 
				     DOUBLE dE01_x, DOUBLE dE01_y,
				     DOUBLE dE10_x, DOUBLE dE10_y, 
				     DOUBLE dE11_V2_x, DOUBLE dE11_V2_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleEEv_VMPFUN(DOUBLE dE00_x, DOUBLE dE00_y, 
					 DOUBLE dE01_x, DOUBLE dE01_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_V2_x, DOUBLE dE11_V2_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleEEv_EMPFUN(DOUBLE dE00_x, DOUBLE dE00_y, 
					 DOUBLE dE01_x, DOUBLE dE01_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_V2_x, DOUBLE dE11_V2_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterEEEMPFUN(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dE00_x, DOUBLE dE00_y, 
			      DOUBLE dE01_x, DOUBLE dE01_y,
			      DOUBLE dE10_x, DOUBLE dE10_y, 
			      DOUBLE dE11_x, DOUBLE dE11_y,
			      DOUBLE dE20_x, DOUBLE dE20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneEEEMPFUN(DOUBLE dE00_x, DOUBLE dE00_y, 
				     DOUBLE dE01_x, DOUBLE dE01_y,
				     DOUBLE dE10_x, DOUBLE dE10_y, 
				     DOUBLE dE11_x, DOUBLE dE11_y,
				     DOUBLE dE20_x, DOUBLE dE20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleEEE_VMPFUN(DOUBLE dE00_x, DOUBLE dE00_y, 
					 DOUBLE dE01_x, DOUBLE dE01_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleEEE_EMPFUN(DOUBLE dE00_x, DOUBLE dE00_y, 
					 DOUBLE dE01_x, DOUBLE dE01_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}

#endif // __APM2D_MPFUN_H__
