#ifndef __APM2D_MPFUNFILTER_H__
#define __APM2D_MPFUNFILTER_H__

#include "apm2d.h"

//////////////////////////////////////////////////////////////////////
// APM2D Private Methods 
//   implemented as //static functions to keep them out of the apm2d.h file

//static 
inline
BOOL IntersectionEEMPFUNFilter(DOUBLE *pdV_x, DOUBLE *pdV_y,
			 DOUBLE dE00_x, DOUBLE dE00_y, 
			 DOUBLE dE01_x, DOUBLE dE01_y,
			 DOUBLE dE10_x, DOUBLE dE10_y, 
			 DOUBLE dE11_x, DOUBLE dE11_y){return 0;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
				  DOUBLE dE10_x, DOUBLE dE10_y, 
				  DOUBLE dE11_x, DOUBLE dE11_y){return APM2D::eztStart;}

//static 
inline
INT_32 DistanceCompareV_VVMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
				DOUBLE dV1_x, DOUBLE dV1_y, 
				DOUBLE dV2_x, DOUBLE dV2_y){return 0;}

//static 
inline
INT_32 DistanceCompareV_VLMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
				DOUBLE dV1_x, DOUBLE dV1_y, 
				DOUBLE dE20_x, DOUBLE dE20_y, 
				DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareV_LLMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
				DOUBLE dE10_x, DOUBLE dE10_y, 
				DOUBLE dE11_x, DOUBLE dE11_y,
				DOUBLE dE20_x, DOUBLE dE20_y, 
				DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareEvv_VVMPFUNFilter(DOUBLE dE0A_x, DOUBLE dE0A_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dV1_x, DOUBLE dV1_y, 
				  DOUBLE dV2_x, DOUBLE dV2_y){return 0;}

//static 
inline
INT_32 DistanceCompareEvv_VLMPFUNFilter(DOUBLE dE0A_x, DOUBLE dE0A_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dV1_x, DOUBLE dV1_y, 
				  DOUBLE dE20_x, DOUBLE dE20_y, 
				  DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareEvv_LLMPFUNFilter(DOUBLE dE0A_x, DOUBLE dE0A_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dE10_x, DOUBLE dE10_y, 
				  DOUBLE dE11_x, DOUBLE dE11_y,
				  DOUBLE dE20_x, DOUBLE dE20_y, 
				  DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareElv_VVMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y,
				  DOUBLE dE01_x, DOUBLE dE01_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dV1_x, DOUBLE dV1_y, 
				  DOUBLE dV2_x, DOUBLE dV2_y){return 0;}

//static 
inline
INT_32 DistanceCompareElv_VLMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y,
				  DOUBLE dE01_x, DOUBLE dE01_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dV1_x, DOUBLE dV1_y, 
				  DOUBLE dE20_x, DOUBLE dE20_y, 
				  DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareL_VVMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y,
				DOUBLE dE01_x, DOUBLE dE01_y,
				DOUBLE dV1_x, DOUBLE dV1_y, 
				DOUBLE dV2_x, DOUBLE dV2_y){return 0;}

//////////////////////////////////////////////////////////////////////
// EE Orientation Functions

//static
inline
INT_32 OrientationExEMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y,
			   DOUBLE dE01_x, DOUBLE dE01_y,
			   DOUBLE dE10_x, DOUBLE dE10_y,
			   DOUBLE dE11_x, DOUBLE dE11_y){return 0;}
  
//static
inline
INT_32 OrientationEdotEMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y,
			     DOUBLE dE01_x, DOUBLE dE01_y,
			     DOUBLE dE10_x, DOUBLE dE10_y,
			     DOUBLE dE11_x, DOUBLE dE11_y){return 0;}

//////////////////////////////////////////////////
// Inscribed Circle Center Functions
//
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVVVMPFUNFilter(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dV00_x, DOUBLE dV00_y,
			      DOUBLE dV0_x, DOUBLE dV0_y,
			      DOUBLE dV01_x, DOUBLE dV01_y,
			      DOUBLE dV10_x, DOUBLE dV10_y,
			      DOUBLE dV1_x, DOUBLE dV1_y,
			      DOUBLE dV11_x, DOUBLE dV11_y,
			      DOUBLE dV20_x, DOUBLE dV20_y,
			      DOUBLE dV2_x, DOUBLE dV2_y,
			      DOUBLE dV21_x, DOUBLE dV21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVVVMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dV1_x, DOUBLE dV1_y,
				     DOUBLE dV2_x, DOUBLE dV2_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVVV_VMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_x, DOUBLE dV1_y,
					 DOUBLE dV2_x, DOUBLE dV2_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVVV_EMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_x, DOUBLE dV1_y,
					 DOUBLE dV2_x, DOUBLE dV2_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}

//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVVEMPFUNFilter(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dV00_x, DOUBLE dV00_y,
			      DOUBLE dV0_x, DOUBLE dV0_y,
			      DOUBLE dV01_x, DOUBLE dV01_y,
			      DOUBLE dV10_x, DOUBLE dV10_y,
			      DOUBLE dV1_x, DOUBLE dV1_y,
			      DOUBLE dV11_x, DOUBLE dV11_y,
			      DOUBLE dE20_x, DOUBLE dE20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVVEMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dV1_x, DOUBLE dV1_y,
				     DOUBLE dE20_x, DOUBLE dE20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVVE_VMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_x, DOUBLE dV1_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVVE_EMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_x, DOUBLE dV1_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVVEAntiparallelMPFUNFilter(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
					  DOUBLE dV00_x, DOUBLE dV00_y,
					  DOUBLE dV0_x, DOUBLE dV0_y,
					  DOUBLE dV01_x, DOUBLE dV01_y,
					  DOUBLE dV10_x, DOUBLE dV10_y,
					  DOUBLE dV1_x, DOUBLE dV1_y,
					  DOUBLE dV11_x, DOUBLE dV11_y,
					  DOUBLE dE20_x, DOUBLE dE20_y, 
					  DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVVEAntiparallelMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
						 DOUBLE dV1_x, DOUBLE dV1_y,
						 DOUBLE dE20_x, DOUBLE dE20_y, 
						 DOUBLE dE21_x, DOUBLE dE21_y,
						 DOUBLE dE30_x, DOUBLE dE30_y,
						 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVVE_VAntiparallelMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
						     DOUBLE dV1_x, DOUBLE dV1_y,
						     DOUBLE dE20_x, DOUBLE dE20_y, 
						     DOUBLE dE21_x, DOUBLE dE21_y,
						     DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVVE_EAntiparallelMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
						     DOUBLE dV1_x, DOUBLE dV1_y,
						     DOUBLE dE20_x, DOUBLE dE20_y, 
						     DOUBLE dE21_x, DOUBLE dE21_y,
						     DOUBLE dE30_x, DOUBLE dE30_y,
						     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVvEMPFUNFilter(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dV00_x, DOUBLE dV00_y,
			      DOUBLE dV0_x, DOUBLE dV0_y,
			      DOUBLE dV01_x, DOUBLE dV01_y,
			      DOUBLE dV1_E20_x, DOUBLE dV1_E20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVvEMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dV1_E20_x, DOUBLE dV1_E20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVvE_VMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_E20_x, DOUBLE dV1_E20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVvE_EMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_E20_x, DOUBLE dV1_E20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterEvVMPFUNFilter(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dE00_x, DOUBLE dE00_y,
			      DOUBLE dE01_V1_x, DOUBLE dE01_V1_y, 
			      DOUBLE dV20_x, DOUBLE dV20_y,
			      DOUBLE dV2_x, DOUBLE dV2_y,
			      DOUBLE dV21_x, DOUBLE dV21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneEvVMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y,
				     DOUBLE dE01_V1_x, DOUBLE dE01_V1_y, 
				     DOUBLE dV2_x, DOUBLE dV2_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleEvV_VMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y,
					 DOUBLE dE01_V1_x, DOUBLE dE01_V1_y, 
					 DOUBLE dV2_x, DOUBLE dV2_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleEvV_EMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y,
					 DOUBLE dE01_V1_x, DOUBLE dE01_V1_y, 
					 DOUBLE dV2_x, DOUBLE dV2_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVEEMPFUNFilter(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dV00_x, DOUBLE dV00_y,
			      DOUBLE dV0_x, DOUBLE dV0_y,
			      DOUBLE dV01_x, DOUBLE dV01_y,
			      DOUBLE dE10_x, DOUBLE dE10_y, 
			      DOUBLE dE11_x, DOUBLE dE11_y,
			      DOUBLE dE20_x, DOUBLE dE20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVEEMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dE10_x, DOUBLE dE10_y, 
				     DOUBLE dE11_x, DOUBLE dE11_y,
				     DOUBLE dE20_x, DOUBLE dE20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVEE_VMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVEE_EMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVEEAntiparallelMPFUNFilter(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
					  DOUBLE dV00_x, DOUBLE dV00_y,
					  DOUBLE dV0_x, DOUBLE dV0_y,
					  DOUBLE dV01_x, DOUBLE dV01_y,
					  DOUBLE dE10_x, DOUBLE dE10_y, 
					  DOUBLE dE11_x, DOUBLE dE11_y,
					  DOUBLE dE20_x, DOUBLE dE20_y, 
					  DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVEEAntiparallelMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
						 DOUBLE dE10_x, DOUBLE dE10_y, 
						 DOUBLE dE11_x, DOUBLE dE11_y,
						 DOUBLE dE20_x, DOUBLE dE20_y, 
						 DOUBLE dE21_x, DOUBLE dE21_y,
						 DOUBLE dE30_x, DOUBLE dE30_y,
						 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVEE_VAntiparallelMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
						     DOUBLE dE10_x, DOUBLE dE10_y, 
						     DOUBLE dE11_x, DOUBLE dE11_y,
						     DOUBLE dE20_x, DOUBLE dE20_y, 
						     DOUBLE dE21_x, DOUBLE dE21_y,
						     DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVEE_EAntiparallelMPFUNFilter(DOUBLE dV0_x, DOUBLE dV0_y,
						     DOUBLE dE10_x, DOUBLE dE10_y, 
						     DOUBLE dE11_x, DOUBLE dE11_y,
						     DOUBLE dE20_x, DOUBLE dE20_y, 
						     DOUBLE dE21_x, DOUBLE dE21_y,
						     DOUBLE dE30_x, DOUBLE dE30_y,
						     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCentervEEMPFUNFilter(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dv0_E10_x, DOUBLE dV0_E10_y, 
			      DOUBLE dE11_x, DOUBLE dE11_y,
			      DOUBLE dE20_x, DOUBLE dE20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZonevEEMPFUNFilter(DOUBLE dv0_E10_x, DOUBLE dV0_E10_y, 
				     DOUBLE dE11_x, DOUBLE dE11_y,
				     DOUBLE dE20_x, DOUBLE dE20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCirclevEE_VMPFUNFilter(DOUBLE dv0_E10_x, DOUBLE dV0_E10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCirclevEE_EMPFUNFilter(DOUBLE dv0_E10_x, DOUBLE dV0_E10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterEEvMPFUNFilter(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dE00_x, DOUBLE dE00_y, 
			      DOUBLE dE01_x, DOUBLE dE01_y,
			      DOUBLE dE10_x, DOUBLE dE10_y, 
			      DOUBLE dE11_V2_x, DOUBLE dE11_V2_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneEEvMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y, 
				     DOUBLE dE01_x, DOUBLE dE01_y,
				     DOUBLE dE10_x, DOUBLE dE10_y, 
				     DOUBLE dE11_V2_x, DOUBLE dE11_V2_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleEEv_VMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y, 
					 DOUBLE dE01_x, DOUBLE dE01_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_V2_x, DOUBLE dE11_V2_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleEEv_EMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y, 
					 DOUBLE dE01_x, DOUBLE dE01_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_V2_x, DOUBLE dE11_V2_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterEEEMPFUNFilter(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dE00_x, DOUBLE dE00_y, 
			      DOUBLE dE01_x, DOUBLE dE01_y,
			      DOUBLE dE10_x, DOUBLE dE10_y, 
			      DOUBLE dE11_x, DOUBLE dE11_y,
			      DOUBLE dE20_x, DOUBLE dE20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneEEEMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y, 
				     DOUBLE dE01_x, DOUBLE dE01_y,
				     DOUBLE dE10_x, DOUBLE dE10_y, 
				     DOUBLE dE11_x, DOUBLE dE11_y,
				     DOUBLE dE20_x, DOUBLE dE20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleEEE_VMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y, 
					 DOUBLE dE01_x, DOUBLE dE01_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleEEE_EMPFUNFilter(DOUBLE dE00_x, DOUBLE dE00_y, 
					 DOUBLE dE01_x, DOUBLE dE01_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}

#endif // __APM2D_MPFUNFILTER_H__
