#ifndef __APM2D_MPFUNNORM_H__
#define __APM2D_MPFUNNORM_H__

#include "apm2d.h"

//////////////////////////////////////////////////////////////////////
// APM2D Private Methods 
//   implemented as //static functions to keep them out of the apm2d.h file

//static 
inline
BOOL IntersectionEEMPFUNNormalized(DOUBLE *pdV_x, DOUBLE *pdV_y,
			 DOUBLE dE00_x, DOUBLE dE00_y, 
			 DOUBLE dE01_x, DOUBLE dE01_y,
			 DOUBLE dE10_x, DOUBLE dE10_y, 
			 DOUBLE dE11_x, DOUBLE dE11_y){return 0;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
				  DOUBLE dE10_x, DOUBLE dE10_y, 
				  DOUBLE dE11_x, DOUBLE dE11_y){return APM2D::eztStart;}

//static 
inline
INT_32 DistanceCompareV_VVMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
				DOUBLE dV1_x, DOUBLE dV1_y, 
				DOUBLE dV2_x, DOUBLE dV2_y){return 0;}

//static 
inline
INT_32 DistanceCompareV_VLMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
				DOUBLE dV1_x, DOUBLE dV1_y, 
				       DOUBLE dE20_x, DOUBLE dE20_y, 
				DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareV_LLMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
				DOUBLE dE10_x, DOUBLE dE10_y, 
				DOUBLE dE11_x, DOUBLE dE11_y,
				DOUBLE dE20_x, DOUBLE dE20_y, 
				DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareEvv_VVMPFUNNormalized(DOUBLE dE0A_x, DOUBLE dE0A_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dV1_x, DOUBLE dV1_y, 
				  DOUBLE dV2_x, DOUBLE dV2_y){return 0;}

//static 
inline
INT_32 DistanceCompareEvv_VLMPFUNNormalized(DOUBLE dE0A_x, DOUBLE dE0A_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dV1_x, DOUBLE dV1_y, 
				  DOUBLE dE20_x, DOUBLE dE20_y, 
				  DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareEvv_LLMPFUNNormalized(DOUBLE dE0A_x, DOUBLE dE0A_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dE10_x, DOUBLE dE10_y, 
				  DOUBLE dE11_x, DOUBLE dE11_y,
				  DOUBLE dE20_x, DOUBLE dE20_y, 
				  DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareElv_VVMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y,
				  DOUBLE dE01_x, DOUBLE dE01_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dV1_x, DOUBLE dV1_y, 
				  DOUBLE dV2_x, DOUBLE dV2_y){return 0;}

//static 
inline
INT_32 DistanceCompareElv_VLMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y,
				  DOUBLE dE01_x, DOUBLE dE01_y,
				  DOUBLE dE0B_x, DOUBLE dE0B_y,
				  DOUBLE dV1_x, DOUBLE dV1_y, 
				  DOUBLE dE20_x, DOUBLE dE20_y, 
				  DOUBLE dE21_x, DOUBLE dE21_y){return 0;}

//static 
inline
INT_32 DistanceCompareL_VVMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y,
				DOUBLE dE01_x, DOUBLE dE01_y,
				DOUBLE dV1_x, DOUBLE dV1_y, 
				DOUBLE dV2_x, DOUBLE dV2_y){return 0;}

//////////////////////////////////////////////////////////////////////
// EE Orientation Functions

//static
inline
INT_32 OrientationExEMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y,
			   DOUBLE dE01_x, DOUBLE dE01_y,
			   DOUBLE dE10_x, DOUBLE dE10_y,
			   DOUBLE dE11_x, DOUBLE dE11_y){return 0;}
  
//static
inline
INT_32 OrientationEdotEMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y,
			     DOUBLE dE01_x, DOUBLE dE01_y,
			     DOUBLE dE10_x, DOUBLE dE10_y,
			     DOUBLE dE11_x, DOUBLE dE11_y){return 0;}

//////////////////////////////////////////////////
// Inscribed Circle Center Functions
//
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVVVMPFUNNormalized(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dV00_x, DOUBLE dV00_y,
			      DOUBLE dV0_x, DOUBLE dV0_y,
			      DOUBLE dV01_x, DOUBLE dV01_y,
			      DOUBLE dV10_x, DOUBLE dV10_y,
			      DOUBLE dV1_x, DOUBLE dV1_y,
			      DOUBLE dV11_x, DOUBLE dV11_y,
			      DOUBLE dV20_x, DOUBLE dV20_y,
			      DOUBLE dV2_x, DOUBLE dV2_y,
			      DOUBLE dV21_x, DOUBLE dV21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVVVMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dV1_x, DOUBLE dV1_y,
				     DOUBLE dV2_x, DOUBLE dV2_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVVV_VMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_x, DOUBLE dV1_y,
					 DOUBLE dV2_x, DOUBLE dV2_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVVV_EMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_x, DOUBLE dV1_y,
					 DOUBLE dV2_x, DOUBLE dV2_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}

//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVVEMPFUNNormalized(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dV00_x, DOUBLE dV00_y,
			      DOUBLE dV0_x, DOUBLE dV0_y,
			      DOUBLE dV01_x, DOUBLE dV01_y,
			      DOUBLE dV10_x, DOUBLE dV10_y,
			      DOUBLE dV1_x, DOUBLE dV1_y,
			      DOUBLE dV11_x, DOUBLE dV11_y,
			      DOUBLE dE20_x, DOUBLE dE20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVVEMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dV1_x, DOUBLE dV1_y,
				     DOUBLE dE20_x, DOUBLE dE20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVVE_VMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_x, DOUBLE dV1_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVVE_EMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_x, DOUBLE dV1_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVVEAntiparallelMPFUNNormalized(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
					  DOUBLE dV00_x, DOUBLE dV00_y,
					  DOUBLE dV0_x, DOUBLE dV0_y,
					  DOUBLE dV01_x, DOUBLE dV01_y,
					  DOUBLE dV10_x, DOUBLE dV10_y,
					  DOUBLE dV1_x, DOUBLE dV1_y,
					  DOUBLE dV11_x, DOUBLE dV11_y,
					  DOUBLE dE20_x, DOUBLE dE20_y, 
					  DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVVEAntiparallelMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
						 DOUBLE dV1_x, DOUBLE dV1_y,
						 DOUBLE dE20_x, DOUBLE dE20_y, 
						 DOUBLE dE21_x, DOUBLE dE21_y,
						 DOUBLE dE30_x, DOUBLE dE30_y,
						 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVVE_VAntiparallelMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
						     DOUBLE dV1_x, DOUBLE dV1_y,
						     DOUBLE dE20_x, DOUBLE dE20_y, 
						     DOUBLE dE21_x, DOUBLE dE21_y,
						     DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVVE_EAntiparallelMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
						     DOUBLE dV1_x, DOUBLE dV1_y,
						     DOUBLE dE20_x, DOUBLE dE20_y, 
						     DOUBLE dE21_x, DOUBLE dE21_y,
						     DOUBLE dE30_x, DOUBLE dE30_y,
						     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVvEMPFUNNormalized(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dV00_x, DOUBLE dV00_y,
			      DOUBLE dV0_x, DOUBLE dV0_y,
			      DOUBLE dV01_x, DOUBLE dV01_y,
			      DOUBLE dV1_E20_x, DOUBLE dV1_E20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVvEMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dV1_E20_x, DOUBLE dV1_E20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVvE_VMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_E20_x, DOUBLE dV1_E20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVvE_EMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dV1_E20_x, DOUBLE dV1_E20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterEvVMPFUNNormalized(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dE00_x, DOUBLE dE00_y,
			      DOUBLE dE01_V1_x, DOUBLE dE01_V1_y, 
			      DOUBLE dV20_x, DOUBLE dV20_y,
			      DOUBLE dV2_x, DOUBLE dV2_y,
			      DOUBLE dV21_x, DOUBLE dV21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneEvVMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y,
				     DOUBLE dE01_V1_x, DOUBLE dE01_V1_y, 
				     DOUBLE dV2_x, DOUBLE dV2_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleEvV_VMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y,
					 DOUBLE dE01_V1_x, DOUBLE dE01_V1_y, 
					 DOUBLE dV2_x, DOUBLE dV2_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleEvV_EMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y,
					 DOUBLE dE01_V1_x, DOUBLE dE01_V1_y, 
					 DOUBLE dV2_x, DOUBLE dV2_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVEEMPFUNNormalized(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dV00_x, DOUBLE dV00_y,
			      DOUBLE dV0_x, DOUBLE dV0_y,
			      DOUBLE dV01_x, DOUBLE dV01_y,
			      DOUBLE dE10_x, DOUBLE dE10_y, 
			      DOUBLE dE11_x, DOUBLE dE11_y,
			      DOUBLE dE20_x, DOUBLE dE20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVEEMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
				     DOUBLE dE10_x, DOUBLE dE10_y, 
				     DOUBLE dE11_x, DOUBLE dE11_y,
				     DOUBLE dE20_x, DOUBLE dE20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVEE_VMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVEE_EMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterVEEAntiparallelMPFUNNormalized(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
					  DOUBLE dV00_x, DOUBLE dV00_y,
					  DOUBLE dV0_x, DOUBLE dV0_y,
					  DOUBLE dV01_x, DOUBLE dV01_y,
					  DOUBLE dE10_x, DOUBLE dE10_y, 
					  DOUBLE dE11_x, DOUBLE dE11_y,
					  DOUBLE dE20_x, DOUBLE dE20_y, 
					  DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneVEEAntiparallelMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
						 DOUBLE dE10_x, DOUBLE dE10_y, 
						 DOUBLE dE11_x, DOUBLE dE11_y,
						 DOUBLE dE20_x, DOUBLE dE20_y, 
						 DOUBLE dE21_x, DOUBLE dE21_y,
						 DOUBLE dE30_x, DOUBLE dE30_y,
						 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleVEE_VAntiparallelMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
						     DOUBLE dE10_x, DOUBLE dE10_y, 
						     DOUBLE dE11_x, DOUBLE dE11_y,
						     DOUBLE dE20_x, DOUBLE dE20_y, 
						     DOUBLE dE21_x, DOUBLE dE21_y,
						     DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleVEE_EAntiparallelMPFUNNormalized(DOUBLE dV0_x, DOUBLE dV0_y,
						     DOUBLE dE10_x, DOUBLE dE10_y, 
						     DOUBLE dE11_x, DOUBLE dE11_y,
						     DOUBLE dE20_x, DOUBLE dE20_y, 
						     DOUBLE dE21_x, DOUBLE dE21_y,
						     DOUBLE dE30_x, DOUBLE dE30_y,
						     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCentervEEMPFUNNormalized(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dv0_E10_x, DOUBLE dV0_E10_y, 
			      DOUBLE dE11_x, DOUBLE dE11_y,
			      DOUBLE dE20_x, DOUBLE dE20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZonevEEMPFUNNormalized(DOUBLE dv0_E10_x, DOUBLE dV0_E10_y, 
				     DOUBLE dE11_x, DOUBLE dE11_y,
				     DOUBLE dE20_x, DOUBLE dE20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCirclevEE_VMPFUNNormalized(DOUBLE dv0_E10_x, DOUBLE dV0_E10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCirclevEE_EMPFUNNormalized(DOUBLE dv0_E10_x, DOUBLE dV0_E10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterEEvMPFUNNormalized(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dE00_x, DOUBLE dE00_y, 
			      DOUBLE dE01_x, DOUBLE dE01_y,
			      DOUBLE dE10_x, DOUBLE dE10_y, 
			      DOUBLE dE11_V2_x, DOUBLE dE11_V2_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneEEvMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y, 
				     DOUBLE dE01_x, DOUBLE dE01_y,
				     DOUBLE dE10_x, DOUBLE dE10_y, 
				     DOUBLE dE11_V2_x, DOUBLE dE11_V2_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleEEv_VMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y, 
					 DOUBLE dE01_x, DOUBLE dE01_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_V2_x, DOUBLE dE11_V2_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleEEv_EMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y, 
					 DOUBLE dE01_x, DOUBLE dE01_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_V2_x, DOUBLE dE11_V2_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::InscribedCircleCenterType 
InscribedCircleCenterEEEMPFUNNormalized(DOUBLE *pdC_x, DOUBLE *pdC_y, DOUBLE *pdR, 
			      DOUBLE dE00_x, DOUBLE dE00_y, 
			      DOUBLE dE01_x, DOUBLE dE01_y,
			      DOUBLE dE10_x, DOUBLE dE10_y, 
			      DOUBLE dE11_x, DOUBLE dE11_y,
			      DOUBLE dE20_x, DOUBLE dE20_y, 
			      DOUBLE dE21_x, DOUBLE dE21_y){return APM2D::icctNull;}
//static 
inline
APM2D::EdgeZoneType EdgeZoneEEEMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y, 
				     DOUBLE dE01_x, DOUBLE dE01_y,
				     DOUBLE dE10_x, DOUBLE dE10_y, 
				     DOUBLE dE11_x, DOUBLE dE11_y,
				     DOUBLE dE20_x, DOUBLE dE20_y, 
				     DOUBLE dE21_x, DOUBLE dE21_y,
				     DOUBLE dE30_x, DOUBLE dE30_y,
				     DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::eztStart;}
//static 
inline
APM2D::CircleTestType InCircleEEE_VMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y, 
					 DOUBLE dE01_x, DOUBLE dE01_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dV3_x, DOUBLE dV3_y){return APM2D::cttOnCircle;}
//static 
inline
APM2D::CircleTestType InCircleEEE_EMPFUNNormalized(DOUBLE dE00_x, DOUBLE dE00_y, 
					 DOUBLE dE01_x, DOUBLE dE01_y,
					 DOUBLE dE10_x, DOUBLE dE10_y, 
					 DOUBLE dE11_x, DOUBLE dE11_y,
					 DOUBLE dE20_x, DOUBLE dE20_y, 
					 DOUBLE dE21_x, DOUBLE dE21_y,
					 DOUBLE dE30_x, DOUBLE dE30_y,
					 DOUBLE dE31_x, DOUBLE dE31_y){return APM2D::cttOnCircle;}

#endif // __APM2D_MPFUNNORM_H__
