#ifndef __BITMAP_H__
#define __BITMAP_H__
//remove definition if you do NOT want to use 
// TIFF and JPEG formats for bitmaps
#ifndef WIN32
#define TIFFANDJPEG
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef WIN32
#include <strings.h>
#endif

#include <assert.h>

#ifndef VOID
typedef void VOID;
#endif // VOID

#ifndef BOOL
#ifndef WIN32
typedef unsigned char BOOL;
#else
typedef int BOOL;
#endif
#endif // BOOL

#ifndef BYTE
typedef unsigned char BYTE;
#endif // BYTE

#ifndef FALSE
#define FALSE 0
#endif // FALSE

#ifndef TRUE
#define TRUE 1
#endif // TRUE

#define R 0
#define G 1
#define B 2


//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


/* strings in the INFOBOX (used in SetISTR and GetISTR) */
#define NISTR         10    /* number of ISTRs */
#define ISTR_INFO     0
#define ISTR_WARNING  1
#define ISTR_FILENAME 2
#define ISTR_FORMAT   3
#define ISTR_RES      4
#define ISTR_CROP     5
#define ISTR_EXPAND   6
#define ISTR_SELECT   7
#define ISTR_COLOR    8
#define ISTR_COLOR2   9

#if defined(__STDC__) && !defined(NOSTDHDRS)
void  SetISTR(int, char *pcFormat, ...);
#else
void  SetISTR();
#endif

// return values from ReadFileType()
// positive values are *definitely* readable formats (HAVE_*** is defined)
// negative values are random files that XV can't read, but display as
//   different icons in the visual browser 

#define FT_ERROR    -1    // couldn't open file, or whatever...
#define FT_UNKNOWN   0
#define FT_GIF       1
#define FT_PM        2
#define FT_PBM       3
#define FT_XBM       4
#define FT_SUNRAS    5
#define FT_BMP       6
#define FT_UTAHRLE   7
#define FT_IRIS      8
#define FT_PCX       9
#define FT_JFIF     10
#define FT_TIFF     11
#define FT_PDSVICAR 12
#define FT_COMPRESS 13
#define FT_PS       14
#define FT_IFF      15
#define FT_TARGA    16
#define FT_XPM      17
#define FT_XWD      18
#define FT_FITS     19

typedef struct _ColorEntry
{
  BYTE pbComp[3];
} ColorEntry;

typedef struct _BitMap 
{
  VOID *pvBuffer;
  int iWidth;
  int iHeight;
  int iBitsPerComp;
  int iComps;

  char *pcComment;
  BYTE  r[256],g[256],b[256];
  ColorEntry pColorMap[256];

} BitMap;

int LoadBitMap(char *pcFile, char *pcTextureFile, BitMap *pBitMap);

char *BaseName(char *fname);

#endif // __BITMAP_H__





