#ifndef __BSPLINEMATH_H__
#define __BSPLINEMATH_H__

#include "mathlib_defs.h"
#include "genlib.h"
#include "point.h"
#include "vector.h"

////////////////////////////////////////////////////////////////////////////////////
// Curves

VOID BlossomAt(Point &pt, UINT_32 uiOrder, const Point *pDeBoorPoint, 
	       const FLOAT *pfKnot, const FLOAT t);
VOID BlossomAt(Point &pt, UINT_32 uiOrder, const Point *pDeBoorPoint, 
	       const FLOAT *pfKnot, const FLOAT *cpfBlossomLabel);

VOID DerivativeAt(Vector &v, UINT_32 uiOrder, 
		  Point **ppDerivativeTable, FLOAT **ppfDeBoorTable,
		  UINT_32 uiDerivative, FLOAT t, UINT_32 uiDelta);
VOID DerivativesAt(Vector *pv, UINT_32 uiOrder, Point **ppDerivativeTable,
		   FLOAT **ppfDeBoorTable, UINT_32 uiStart, UINT_32 uiEnd,
		   FLOAT /*t*/, UINT_32 uiDelta);
VOID WDerivativesAt(FLOAT *pf, UINT_32 uiOrder, FLOAT **ppfDerivativeTable,
		    FLOAT **ppfDeBoorTable, UINT_32 uiStart, UINT_32 uiEnd,
		    FLOAT /*t*/, UINT_32 uiDelta);

VOID CalculateDeBoorTable(UINT_32 uiOrder, FLOAT *pfKnot, FLOAT **&ppfDeBoorTable,
			  FLOAT t, UINT_32 uiDelta);
VOID CalculateDerivativeTable(UINT_32 uiControlPoints, UINT_32 uiDerivatives, 
			      UINT_32 uiOrder, FLOAT *pfKnot, Point *pControlPoint,
			      Point **&ppDerivativeTable);
VOID CalculateWDerivativeTable(UINT_32 uiControlPoints, UINT_32 uiDerivatives, 
			       UINT_32 uiOrder, FLOAT *pfKnot, FLOAT *pfWeight,
			       FLOAT **&ppDerivativeTable);


#endif // __BSPLINEMATH_H__
