#ifndef __CDA_H__
#define __CDA_H__

#include "cdamem.h"

class CDACell;

//////////////////////////////////////////////////////////////////////
// CDA Class
//

class CDA
{
//////////////////////////////////////////////////
// Friends
//
public:

//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CDA();
  virtual ~CDA();
  virtual VOID Init();
  virtual VOID Init(CListInt *plistCDAVertex);
  virtual VOID Uninit();

  virtual BOOL Initialized();
  virtual BOOL Valid();

//////////////////////////////////////////////////
// Iteration Functions
//
public:

//////////////////////////////////////////////////
// Geometric Computations
//
public:
  CDA *Copy();
  VOID Transform(const Matrix &mGroot_obj, const Matrix &mGobj_root);

  CDA *Union(CDA *pCDA);
  CDA *Intersect(CDA *pCDA);
  CDA *Minus(CDA *pCDA);

protected:
  virtual VOID CalculateBound();

//////////////////////////////////////////////////
// Rendering
//
public:
  virtual VOID Render();
  virtual VOID RenderNormals();

//////////////////////////////////////////////////
// Output Functions
//
public:
  VOID Display();

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  inline VOID AddCell(CDACell *pCDACell);

//////////////////////////////////////////////////
// Class Variables
//
protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  CListInt m_listCDACell;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline VOID CDA::AddCell(CDACell *pCDACell)
{
  ASSERT( pCDACell != NULL );
  m_listCDACell.InsertLast(pCDACell, 0);
}

#endif // __CDA_H__
