#include "cdaedge.h"

//////////////////////////////////////////////////////////////////////
// CDAEdge Class
//

CDAEdge::CDAEdge()
{
  m_ppCDAVertex[0] = NULL;
  m_ppCDAVertex[1] = NULL;
  m_ppCDAFace[0] = NULL;
  m_ppCDAFace[1] = NULL;

  m_bOnHull = TRUE;

  m_pCDAEdgeCopy = NULL;
}

CDAEdge::~CDAEdge()
{
  Uninit();
}

VOID CDAEdge::Init(CDAVertex *pCDAVertex0, CDAVertex *pCDAVertex1)
{

  ASSERT( pCDAVertex0 != NULL );
  ASSERT( pCDAVertex1 != NULL );

  m_ppCDAVertex[0] = pCDAVertex0;
  m_ppCDAVertex[1] = pCDAVertex1;
  m_ppCDAFace[0] = NULL;
  m_ppCDAFace[1] = NULL;

  m_bOnHull = TRUE;

  m_pCDAEdgeCopy = NULL;
}

VOID CDAEdge::Uninit()
{
  m_ppCDAVertex[0] = NULL;
  m_ppCDAVertex[1] = NULL;
  m_ppCDAFace[0] = NULL;
  m_ppCDAFace[1] = NULL;

  m_bOnHull = TRUE;

  m_pCDAEdgeCopy = NULL;
}

BOOL CDAEdge::Initialized()
{
  return TRUE;
}

BOOL CDAEdge::Valid()
{
  return TRUE;
}

CDAEdge *CDAEdge::Copy()
{
  m_pCDAEdgeCopy = AllocateCDAEdge();
  ASSERT( m_pCDAEdgeCopy != NULL );
  m_pCDAEdgeCopy->Init(m_ppCDAVertex[0]->GetCopy(),
		       m_ppCDAVertex[1]->GetCopy());

  return m_pCDAEdgeCopy;
}

VOID CDAEdge::Preprocess()
{
}

VOID CDAEdge::Display()
{
  printf("V[0] = %p  <==>  V[1] = %p\n", m_ppCDAVertex[0], m_ppCDAVertex[1]);
}
