#include "cdavertex.h"

//////////////////////////////////////////////////////////////////////
// CDAVertex Class
//

CDAVertex::CDAVertex()
{
  m_ppCDAFaceDual[0] = NULL;
  m_ppCDAFaceDual[1] = NULL;

  m_bOnHull = TRUE;

  m_pCDAVertexCopy = NULL;
}

CDAVertex::~CDAVertex()
{
  Uninit();
}

VOID CDAVertex::Init(const Point &pt)
{
  m_pt = pt;

  m_ppCDAFaceDual[0] = NULL;
  m_ppCDAFaceDual[1] = NULL;

  m_bOnHull = TRUE;

  m_pCDAVertexCopy = NULL;
}

VOID CDAVertex::Uninit()
{
  m_ppCDAFaceDual[0] = NULL;
  m_ppCDAFaceDual[1] = NULL;

  m_bOnHull = TRUE;

  m_pCDAVertexCopy = NULL;
}

BOOL CDAVertex::Initialized()
{
  return TRUE;
}

BOOL CDAVertex::Valid()
{
  return TRUE;
}

CDAVertex *CDAVertex::Copy()
{
  m_pCDAVertexCopy = AllocateCDAVertex();
  ASSERT( m_pCDAVertexCopy != NULL );
  m_pCDAVertexCopy->Init(m_pt);

  return m_pCDAVertexCopy;
}

VOID CDAVertex::Transform(const Matrix &mGroot_obj, const Matrix &/*mGobj_root*/)
{
  m_pt = mGroot_obj * m_pt;
}

VOID CDAVertex::Preprocess()
{
}

VOID CDAVertex::Render()
{
  gilVertex3fv(m_pt.Get());
}

VOID CDAVertex::Display()
{
  printf("    Vertex %p: ", this);
  m_pt.Display();
}
