#ifndef __DYNAMICS_H__
#define __DYNAMICS_H__

#include "genlib.h"

struct Tcl_Obj;
//class Tcl_Obj;

BOOL DynEval(FLOAT *pf, CHAR **ppc, UINT_32 uiComponents);
BOOL DynEvalInt(INT_32 *pi, CHAR **ppc, UINT_32 uiComponents);
BOOL DynEvalObj(FLOAT *pf, CHAR **ppc, Tcl_Obj **ppto, UINT_32 uiComponents);
BOOL DynEvalObjInt(INT_32 *pi, CHAR **ppc, Tcl_Obj **ppto, UINT_32 uiComponents);

//////////////////////////////////////////////////////////////////////
// DynFloat Class
//

class DynFloat
{
public:
  DynFloat();
  ~DynFloat();

public:
  BOOL Update();

public:
  inline VOID Set(DynFloat *pdynf);
  inline FLOAT GetValue() const;
  inline VOID SetValue(FLOAT fValue);
  inline CHAR *GetDynExpr();
  inline VOID SetDynExpr(CHAR *pcDynExpr);
  inline BOOL GetDynamic();
  inline VOID SetIsMacro();
  inline BOOL GetIsMacro();

protected:
  BOOL m_bIsMacro;
  FLOAT m_fValue;
  CHAR *m_pcDynExpr;
  Tcl_Obj *m_ptoDynExpr;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline VOID DynFloat::Set(DynFloat *pdynf)
{
  ASSERT( pdynf != NULL );

  memcpy(this, pdynf, sizeof(DynFloat));
}

inline FLOAT DynFloat::GetValue() const
{
  return m_fValue;
}

inline VOID DynFloat::SetValue(FLOAT fValue)
{
  m_fValue = fValue;
}

inline CHAR *DynFloat::GetDynExpr()
{
  return m_pcDynExpr;
}

inline VOID DynFloat::SetDynExpr(CHAR *pcDynExpr)
{
  m_pcDynExpr = pcDynExpr;
}

inline BOOL DynFloat::GetDynamic()
{
  return m_pcDynExpr != NULL;
}

inline VOID DynFloat::SetIsMacro()
{
  m_bIsMacro = TRUE;
}

inline BOOL DynFloat::GetIsMacro()
{
  return m_bIsMacro;
}

//////////////////////////////////////////////////////////////////////
// DynInt Class
//

class DynInt
{
public:
  DynInt();
  ~DynInt();

public:
  BOOL Update();

public:
  inline VOID Set(DynInt *pdyni);
  inline INT_32 GetValue() const;
  inline VOID SetValue(INT_32 iValue);
  inline CHAR *GetDynExpr();
  inline VOID SetDynExpr(CHAR *pcDynExpr);
  inline BOOL GetDynamic();
  inline VOID SetIsMacro();
  inline BOOL GetIsMacro();

protected:
  BOOL m_bIsMacro;
  INT_32 m_iValue;
  CHAR *m_pcDynExpr;
  Tcl_Obj *m_ptoDynExpr;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline VOID DynInt::Set(DynInt *pdyni)
{
  ASSERT( pdyni != NULL );

  memcpy(this, pdyni, sizeof(DynInt));
}

inline INT_32 DynInt::GetValue() const
{
  return m_iValue;
}

inline VOID DynInt::SetValue(INT_32 iValue)
{
  m_iValue = iValue;
}

inline CHAR *DynInt::GetDynExpr()
{
  return m_pcDynExpr;
}

inline VOID DynInt::SetDynExpr(CHAR *pcDynExpr)
{
  m_pcDynExpr = pcDynExpr;
}

inline BOOL DynInt::GetDynamic()
{
  return m_pcDynExpr != NULL;
}

inline VOID DynInt::SetIsMacro()
{
  m_bIsMacro = TRUE;
}

inline BOOL DynInt::GetIsMacro()
{
  return m_bIsMacro;
}



#endif __DYNAMICS_H__


