#include "dynpoint.h"

#include <tcl.h>

//////////////////////////////////////////////////////////////////////
// DynPoint Class
//

DynPoint::DynPoint()
{
  Null();

  memset(m_ppcDynExpr, 0, 4*sizeof(CHAR*));
  memset(m_pptoDynExpr, 0, 4*sizeof(Tcl_Obj*));
  memset(m_pbIsMacro, 0, 4*sizeof(BOOL));
}

DynPoint::DynPoint(FLOAT x, FLOAT y, FLOAT z, FLOAT w/* = 0.0f*/)
{
  m_pt[0] = x;
  m_pt[1] = y;
  m_pt[2] = z;
  m_pt[3] = w;

  memset(m_ppcDynExpr, 0, 4*sizeof(CHAR*));
  memset(m_pptoDynExpr, 0, 4*sizeof(Tcl_Obj*));
}

DynPoint::~DynPoint()
{
  UINT_32 i;

  memset(m_ppcDynExpr, 0, 4*sizeof(CHAR*));

  for ( i = 0; i < 4; i++ )
    {
      if ( m_pptoDynExpr[i] != NULL )
	{
	  Tcl_DecrRefCount(m_pptoDynExpr[i]);
	  m_pptoDynExpr[i] = NULL;
	}
    }
}

BOOL DynPoint::Update()
{
  BOOL bChanged;

  bChanged = DynEvalObj(m_pt, m_ppcDynExpr, m_pptoDynExpr, 4);

  for (int i=0; i<4; i++)
    {
      if (m_pbIsMacro[i])
	{
	  m_ppcDynExpr[i]=NULL;
	}
    }

  return bChanged;
}
