#include "dynvector.h"

#include <tcl.h>

//////////////////////////////////////////////////////////////////////
// DynVector Class
//

DynVector::DynVector()
{
  Null();

  memset(m_ppcDynExpr, 0, 4*sizeof(CHAR*));
  memset(m_pptoDynExpr, 0, 4*sizeof(Tcl_Obj*));
}

DynVector::DynVector(FLOAT x, FLOAT y, FLOAT z, FLOAT w/* = 0.0f*/)
{
  m_v[0] = x;
  m_v[1] = y;
  m_v[2] = z;
  m_v[3] = w;

  memset(m_ppcDynExpr, 0, 4*sizeof(CHAR*));
  memset(m_pptoDynExpr, 0, 4*sizeof(Tcl_Obj*));
}

DynVector::~DynVector()
{
  UINT_32 i;

  memset(m_ppcDynExpr, 0, 4*sizeof(CHAR*));

  for ( i = 0; i < 4; i++ )
    {
      if ( m_pptoDynExpr[i] != NULL )
	{
	  Tcl_DecrRefCount(m_pptoDynExpr[i]);
	  m_pptoDynExpr[i] = NULL;
	}
    }
}

BOOL DynVector::Update()
{
  BOOL bChanged;

  bChanged = DynEvalObj(m_v, m_ppcDynExpr, m_pptoDynExpr, 4);

  for (int i=0; i<4; i++)
    {
      if (m_pbIsMacro[i])
	{
	  m_ppcDynExpr[i]=NULL;
	}
    }

  return bChanged;
}

DynVector &DynVector::operator=(const Vector &v)
{
  m_v[0] = v(0);
  m_v[1] = v(1);
  m_v[2] = v(2);
  m_v[3] = v(3);

  return *this;
}
