#include "hashint.h"
#include "hashtable.h"
#include "listint.h"
#include "list.h"

//////////////////////////////////////////////////////////////////////////////
// CHashInt Class
//

CHashInt::CHashInt()
{
  m_pCHashTable = NULL;
}

CHashInt::~CHashInt()
{
  Uninit();
}

BOOL CHashInt::Init(INT_32 uiBuckets/* = 127*/)
{
  ASSERT( m_pCHashTable == NULL );

  m_pCHashTable = new CHashTable<CList<VOID*, INT_32>, VOID*, INT_32>;
  ASSERT( m_pCHashTable != NULL );

  return ((CHashTable<CList<VOID*, INT_32>, VOID*, INT_32>*)m_pCHashTable)->Init(uiBuckets);
}

VOID CHashInt::Uninit()
{
  if ( m_pCHashTable != NULL )
    {
      delete ((CHashTable<CList<VOID*, INT_32>, VOID*, INT_32>*)m_pCHashTable);
      m_pCHashTable = NULL;
    }
}

VOID *CHashInt::Insert(VOID *pvData, const INT_32 iKey)
{
  ASSERT( m_pCHashTable != NULL );

  return ((CHashTable<CList<VOID*, INT_32>, VOID*, INT_32>*)m_pCHashTable)->Insert(pvData, iKey);
}

VOID *CHashInt::Peek(const INT_32 iKey)
{
  ASSERT( m_pCHashTable != NULL );

  return ((CHashTable<CList<VOID*, INT_32>, VOID*, INT_32>*)m_pCHashTable)->Peek(iKey);
}

VOID *CHashInt::Remove(const INT_32 iKey)
{
  ASSERT( m_pCHashTable != NULL );

  return ((CHashTable<CList<VOID*, INT_32>, VOID*, INT_32>*)m_pCHashTable)->Remove(iKey);
}

VOID *CHashInt::RemoveFirst()
{
  ASSERT( m_pCHashTable != NULL );

  return ((CHashTable<CList<VOID*, INT_32>, VOID*, INT_32>*)m_pCHashTable)->RemoveFirst();
}

VOID CHashInt::Display()
{
  ASSERT( m_pCHashTable != NULL );

  ((CHashTable<CList<VOID*, INT_32>, VOID*, INT_32>*)m_pCHashTable)->Display();
}

//////////////////////////////////////////////////////////////////////////////
// CListInt Class
//

CListInt::CListInt()
{
  m_pCList = NULL;
}

CListInt::~CListInt()
{
  Uninit();
}

BOOL CListInt::Init()
{
  ASSERT( m_pCList == NULL );

  m_pCList = new CList<VOID*, INT_32>;
  ASSERT( m_pCList != NULL );

  return ((CList<VOID*, INT_32>*)m_pCList)->Init();
}

VOID CListInt::Uninit()
{
  if ( m_pCList != NULL )
    {
      delete ((CList<VOID*, INT_32>*)m_pCList);
      m_pCList = NULL;
    }
}

VOID *CListInt::InsertForward(VOID *pvData, INT_32 iKey)
{
  ASSERT( m_pCList != NULL );

  return ((CList<VOID*, INT_32>*)m_pCList)->InsertForward(pvData, iKey);
}

VOID *CListInt::InsertBackward(VOID *pvData, INT_32 iKey)
{
  ASSERT( m_pCList != NULL );

  return ((CList<VOID*, INT_32>*)m_pCList)->InsertBackward(pvData, iKey);
}

VOID *CListInt::InsertFirst(VOID *pvData, INT_32 iKey)
{
  ASSERT( m_pCList != NULL );

  return ((CList<VOID*, INT_32>*)m_pCList)->InsertFirst(pvData, iKey);
}

VOID *CListInt::InsertLast(VOID *pvData, INT_32 iKey)
{
  ASSERT( m_pCList != NULL );

  return ((CList<VOID*, INT_32>*)m_pCList)->InsertLast(pvData, iKey);
}

VOID *CListInt::RemoveForward(INT_32 iKey)
{
  ASSERT( m_pCList != NULL );

  return ((CList<VOID*, INT_32>*)m_pCList)->RemoveForward(iKey);
}

VOID *CListInt::RemoveBackward(INT_32 iKey)
{
  ASSERT( m_pCList != NULL );

  return ((CList<VOID*, INT_32>*)m_pCList)->RemoveBackward(iKey);
}

VOID *CListInt::RemoveFirst(INT_32 *piKey/* = NULL*/)
{
  VOID *pvData;

  ASSERT( m_pCList != NULL );

  pvData = ((CList<VOID*, INT_32>*)m_pCList)->RemoveFirst(piKey);

  return pvData;
}

VOID *CListInt::RemoveLast(INT_32 *piKey/* = NULL*/)
{
  VOID *pvData;

  ASSERT( m_pCList != NULL );

  pvData = ((CList<VOID*, INT_32>*)m_pCList)->RemoveLast(piKey);

  return pvData;
}

VOID CListInt::RemoveAll()
{
  ASSERT( m_pCList != NULL );

  ((CList<VOID*, INT_32>*)m_pCList)->RemoveAll();
}

VOID *CListInt::RemoveUnordered(INT_32 iKey)
{
  ASSERT( m_pCList != NULL );
  
  return ((CList<VOID*, INT_32>*)m_pCList)->RemoveUnordered(iKey);
}

VOID *CListInt::PeekForward(INT_32 iKey) const
{
  ASSERT( m_pCList != NULL );

  return ((CList<VOID*, INT_32>*)m_pCList)->PeekForward(iKey);
}

VOID *CListInt::PeekBackward(INT_32 iKey) const
{
  ASSERT( m_pCList != NULL );

  return ((CList<VOID*, INT_32>*)m_pCList)->PeekBackward(iKey);
}

VOID *CListInt::PeekFirst(INT_32 *piKey/* = NULL*/) const
{
  VOID *pvData;

  ASSERT( m_pCList != NULL );

  pvData = ((CList<VOID*, INT_32>*)m_pCList)->PeekFirst(piKey);

  return pvData;
}

VOID *CListInt::PeekLast(INT_32 *piKey/* = NULL*/) const
{
  VOID *pvData;

  ASSERT( m_pCList != NULL );

  pvData = ((CList<VOID*, INT_32>*)m_pCList)->PeekLast(piKey);

  return pvData;
}

VOID *CListInt::PeekUnordered(INT_32 iKey)
{
  ASSERT( m_pCList != NULL );
  
  return ((CList<VOID*, INT_32>*)m_pCList)->PeekUnordered(iKey);
}

VOID CListInt::Display()
{
  ASSERT( m_pCList != NULL );

  ((CList<VOID*, INT_32>*)m_pCList)->Display();
}

#ifdef SORT_ENABLED

BOOL CListInt::Sort()
{
  ASSERT( m_pCList != NULL );

  return ((CList<VOID*, INT_32>*)m_pCList)->Sort();
}

#endif // SORT_ENABLED

UINT_32 CListInt::GetLength()
{
  ASSERT( m_pCList != NULL );

  return ((CList<VOID*, INT_32>*)m_pCList)->GetLength();
}

//////////////////////////////////////////////////////////////////////////////
// CListIterInt Class
//

CListIterInt::CListIterInt()
{
  m_pCListIter = NULL;
}

CListIterInt::~CListIterInt()
{
  Uninit();
}

BOOL CListIterInt::Init(CListInt *pCListInt)
{
  ASSERT( pCListInt != NULL );

  if ( m_pCListIter == NULL )
    {      
      m_pCListIter = new CListIter<VOID*, INT_32>;
      ASSERT( m_pCListIter != NULL );
    }

  return ((CListIter<VOID*, INT_32>*)m_pCListIter)->
           Init((CList<VOID*, INT_32>*)(pCListInt->m_pCList));
}

VOID CListIterInt::Uninit()
{
  if ( m_pCListIter != NULL )
    {
      delete ((CListIter<VOID*, INT_32>*)m_pCListIter);
      m_pCListIter = NULL;
    }
}

VOID *CListIterInt::PeekForward(INT_32 iKey)
{
  ASSERT( m_pCListIter != NULL );

  return ((CListIter<VOID*, INT_32>*)m_pCListIter)->PeekForward(iKey);
}

VOID *CListIterInt::PeekBackward(INT_32 iKey)
{
  ASSERT( m_pCListIter != NULL );

  return ((CListIter<VOID*, INT_32>*)m_pCListIter)->PeekBackward(iKey);
}

VOID *CListIterInt::PeekFirst(INT_32 *piKey/* = NULL */)
{
  VOID *pvData;

  ASSERT( m_pCListIter != NULL );

  pvData = ((CListIter<VOID*, INT_32>*)m_pCListIter)->PeekFirst(piKey);

  return pvData;
}

VOID *CListIterInt::PeekNext(INT_32 *piKey/* = NULL*/)
{
  VOID *pvData;

  ASSERT( m_pCListIter != NULL );

  pvData = ((CListIter<VOID*, INT_32>*)m_pCListIter)->PeekNext(piKey);

  return pvData;
}

VOID *CListIterInt::PeekLast(INT_32 *piKey/* = NULL */)
{
  VOID *pvData;

  ASSERT( m_pCListIter != NULL );

  pvData = ((CListIter<VOID*, INT_32>*)m_pCListIter)->PeekLast(piKey);

  return pvData;
}

VOID *CListIterInt::PeekPrev(INT_32 *piKey/* = NULL*/)
{
  VOID *pvData;

  ASSERT( m_pCListIter != NULL );

  pvData = ((CListIter<VOID*, INT_32>*)m_pCListIter)->PeekPrev(piKey);

  return pvData;
}

VOID *CListIterInt::PeekNextRemoveCurr(VOID **ppDataRemoved/* = NULL*/,
				       INT_32 *piKeyRemoved/* = NULL*/,
				       INT_32 *piKey/* = NULL*/)
{
  VOID *pvData;

  ASSERT( m_pCListIter != NULL );

  pvData = ((CListIter<VOID*, INT_32>*)m_pCListIter)->PeekNextRemoveCurr(ppDataRemoved, 
									 piKeyRemoved, 
									 piKey);
  return pvData;
}

VOID *CListIterInt::PeekPrevRemoveCurr(VOID **ppDataRemoved/* = NULL*/,
				       INT_32 *piKeyRemoved/* = NULL*/,
				       INT_32 *piKey/* = NULL*/)
{
  VOID *pvData;

  ASSERT( m_pCListIter != NULL );

  pvData = ((CListIter<VOID*, INT_32>*)m_pCListIter)->PeekPrevRemoveCurr(ppDataRemoved, 
									  piKeyRemoved, 
									  piKey);

  return pvData;
}

VOID *CListIterInt::InsertNext(VOID *pvData, INT_32 iKey)
{
  ASSERT( m_pCListIter != NULL );

  return ((CListIter<VOID*, INT_32>*)m_pCListIter)->InsertNext(pvData, iKey);
}

VOID *CListIterInt::InsertPrev(VOID *pvData, INT_32 iKey)
{
  ASSERT( m_pCListIter != NULL );

  return ((CListIter<VOID*, INT_32>*)m_pCListIter)->InsertPrev(pvData, iKey);
}

VOID *CListIterInt::PeekNextWrap(INT_32 *piKey/* = NULL*/)
{
  VOID *pvData;

  ASSERT( m_pCListIter != NULL );

  pvData = ((CListIter<VOID*, INT_32>*)m_pCListIter)->PeekNextWrap(piKey);

  return pvData;
}

VOID *CListIterInt::PeekPrevWrap(INT_32 *piKey/* = NULL*/)
{
  VOID *pvData;

  ASSERT( m_pCListIter != NULL );

  pvData = ((CListIter<VOID*, INT_32>*)m_pCListIter)->PeekPrevWrap(piKey);

  return pvData;
}

VOID *CListIterInt::PeekNextWrapRemoveCurr(VOID **ppDataRemoved/* = NULL*/,
					   INT_32 *piKeyRemoved/* = NULL*/,
					   INT_32 *piKey/* = NULL*/)
{
  VOID *pvData;

  ASSERT( m_pCListIter != NULL );

  pvData = ((CListIter<VOID*, INT_32>*)m_pCListIter)->PeekNextWrapRemoveCurr(ppDataRemoved, 
									 piKeyRemoved, 
									 piKey);
  return pvData;
}

VOID *CListIterInt::PeekPrevWrapRemoveCurr(VOID **ppDataRemoved/* = NULL*/,
					   INT_32 *piKeyRemoved/* = NULL*/,
					   INT_32 *piKey/* = NULL*/)
{
  VOID *pvData;

  ASSERT( m_pCListIter != NULL );

  pvData = ((CListIter<VOID*, INT_32>*)m_pCListIter)->PeekPrevWrapRemoveCurr(ppDataRemoved, 
									  piKeyRemoved, 
									  piKey);

  return pvData;
}

