#include "interval.h"

int Interval::m_iRM = ROUND_TO_PLUS_INFINITY; // swap space for current rounding mode
int Interval::m_iRMTmp = 0; // swap space for current rounding mode

//////////////////////////////////////////////////////////////////////
// Interval Class Implementation

// From Shewchuk's predicates.c
extern double epsilon;

void Interval::ConservativeBound(double d)
{
  PUSH_ROUND_DOWN();
  m_dMin = d - epsilon;
  SET_ROUND_UP();
  m_dMax = d + epsilon;
  POP_ROUND();
}

void Interval::Display(FILE *fpOutput/* = stdout*/)
{
  fprintf(fpOutput, "[%.20f, %.20f]", m_dMin, m_dMax);
}

//////////////////////////////////////////////////////////////////////
// friends of Interval
//


