#include "lpsolver.h"
#ifdef __INTEGRATED_WITH_CDA__
#include "cdaface.h"
#endif // __INTEGRATED_WITH_CDA__

// For debugging it resets the memory to zeroes after the call is over
//#define CLEAN_UP_AFTER

#define __2D_LP_EXAMPLE__
#ifdef __2D_LP_EXAMPLE__

/*
// Unit Square
const UINT_32 s_cuiDim = 2;
const UINT_32 s_cuiHalfSpaces = 4;
const FLOAT s_cpfConstraints[s_cuiHalfSpaces*(s_cuiDim+1)] = 
{
  1, 0, -1,
  0, 1, -1,
  -1, 0, -1,
  0, -1, -1
};
*/

/*
// Triangle
const UINT_32 s_cuiDim = 2;
const UINT_32 s_cuiHalfSpaces = 3;
const FLOAT s_cpfConstraints[s_cuiHalfSpaces*(s_cuiDim+1)] = 
{
  0.70710678, 0.70710678, 0,
  -1, 0, -1,
  0, -1, -1
};
*/

/*
// 1 unit Square and 1.5 units Diamond
const UINT_32 s_cuiDim = 2;
const UINT_32 s_cuiHalfSpaces = 8;
const FLOAT s_cpfConstraints[s_cuiHalfSpaces*(s_cuiDim+1)] = 
{
  1, 0, -1,
  0, 1, -1,
  -1, 0, -1,
  0, -1, -1,
  1, 1, -1.5,
  1, -1, -1.5,
  -1, 1, -1.5,
  -1, -1, -1.5
};
*/

// 1 unit Square and 1.5 units Diamond
const UINT_32 s_cuiDim = 2;
const UINT_32 s_cuiHalfSpaces = 8;
const FLOAT s_cpfConstraints[s_cuiHalfSpaces*(s_cuiDim+1)] = 
{
  1, 0, -1,
  0, 1, -1,
  -1, 0, -1,
  0, -1, -1,
  1, 1, -1.5,
  -1, 1, -1.5,
  1, -1, -0.5,
  -1, -1, -0.5
//  -1, -1, 0.0
//  -1, -1, 2.0
};


//const FLOAT s_cpfObjective[s_cuiDim] = { 1, 1 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { -1, -1 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 1, -1 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { -1, 1 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 1, 0 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { -1, 0 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 0, 1 }; 
const FLOAT s_cpfObjective[s_cuiDim] = { 0, -1 }; 

#else // __2D_LP_EXAMPLE__

// 3D Instead

const UINT_32 s_cuiDim = 3;
const UINT_32 s_cuiHalfSpaces = 6;
const FLOAT s_cpfConstraints[s_cuiHalfSpaces*(s_cuiDim+1)] = 
{
  1, 0, 0, -1,
  0, 1, 0, -1,
  0, 0, 1, -1,
  -1, 0, 0, -1,
  0, -1, 0, -1,
  0, 0, -1, -1
};

/*
const UINT_32 s_cuiDim = 2;
const UINT_32 s_cuiHalfSpaces = 3;
const FLOAT s_cpfConstraints[s_cuiHalfSpaces*(s_cuiDim+1)] = 
{
  0.70710678, 0.70710678, 0,
  -1, 0, -1,
  0, -1, -1
};
*/

// These Work :)
//const FLOAT s_cpfObjective[s_cuiDim] = { 1, 1, 1 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 1, 1, -1 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 1, -1, 1 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 1, -1, -1 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { -1, 1, 1 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { -1, 1, -1 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { -1, -1, 1 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { -1, -1, -1 }; 

// These Work :) 

//const FLOAT s_cpfObjective[s_cuiDim] = { 1, 1, 0 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 1, -1, 0 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { -1, 1, 0 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { -1, -1, 0 }; 

//const FLOAT s_cpfObjective[s_cuiDim] = { 1, 0, 1}; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 1, 0, -1}; 
//const FLOAT s_cpfObjective[s_cuiDim] = { -1, 0, 1}; 
//const FLOAT s_cpfObjective[s_cuiDim] = { -1, 0, -1}; 

//const FLOAT s_cpfObjective[s_cuiDim] = { 0, 1, 1}; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 0, 1, -1}; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 0, -1, 1}; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 0, -1, -1}; 

// These Don't Work :( 
const FLOAT s_cpfObjective[s_cuiDim] = { 1, 0, 0 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { -1, 0, 0 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 0, 1, 0 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 0, -1, 0 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 0, 0, 1 }; 
//const FLOAT s_cpfObjective[s_cuiDim] = { 0, 0, -1 }; 

#endif // __2D_LP_EXAMPLE__


//////////////////////////////////////////////////////////////////////
// LPSolver Class
//

LPSolver::LPSolver()
{
  m_uiDimMax = 0;
  m_uiHalfSpacesMax = 0;

  m_uiWorkSpaceSize = 0;
  m_pfWorkSpace = NULL;
  m_uiSwapSpaceSize = 0;
  m_pfSwapSpace = NULL;
  m_pfCSpace = NULL;
  m_uiDimSpaceSize = 0;
  m_pfNormalNeg = NULL;
  m_pfSolution = NULL;
  m_uiHalfSpacesSize = 0;
  m_puiRandomPermutation = NULL;
}

LPSolver::~LPSolver()
{
  Uninit();
}

VOID LPSolver::Init()
{
  m_uiDimMax = 0;
  m_uiHalfSpacesMax = 0;

  m_uiWorkSpaceSize = 0;
  m_pfWorkSpace = NULL;
  m_uiSwapSpaceSize = 0;
  m_pfSwapSpace = NULL;
  m_pfCSpace = NULL;
  m_uiDimSpaceSize = 0;
  m_pfNormalNeg = NULL;
  m_pfSolution = NULL;
  m_uiHalfSpacesSize = 0;
  m_puiRandomPermutation = NULL;
}

VOID LPSolver::Uninit()
{
  DeallocateWorkSpace();
}

BOOL LPSolver::Initialized()
{
  return TRUE;
}

BOOL LPSolver::Valid()
{
  return TRUE;
}

VOID LPSolver::Run()
{
  UINT_32 i, j;
  FLOAT fMag;
  LPVector vNormal;
  LPVector vC;
  LPVector vSolution;

  AllocateWorkSpace(s_cuiDim, s_cuiHalfSpaces);

  for ( i = 0; i < s_cuiHalfSpaces; i++ )
    {
      memcpy(&(m_pfWorkSpace[GetIndex(s_cuiDim, i)]), 
	     &(s_cpfConstraints[i*(s_cuiDim+1)]), 
	     (s_cuiDim+1)*sizeof(FLOAT));
      
      vNormal.Init(s_cuiDim, &(m_pfWorkSpace[GetIndex(s_cuiDim, i)]));
      fMag = vNormal.Magnitude();
      ASSERT( fMag != 0.0 );
      
      for ( j = 0; j <= s_cuiDim; j++ )
	{
	  m_pfWorkSpace[GetIndex(s_cuiDim, i) + j] /= fMag; 
	}
    }

  memcpy(GetC(s_cuiDim), s_cpfObjective, s_cuiDim*sizeof(FLOAT));

  vC.Init(s_cuiDim, GetC(s_cuiDim));
  VERIFY( vC.Normalize() );
  vSolution.Init(s_cuiDim+1, m_pfSolution);

  if ( BoundedLP(s_cuiDim, s_cuiHalfSpaces, vC, vSolution) )
    {
      printf("\nSOLUTION: ");
      vSolution.Display();
    }
  else
    {
      printf("\nThe problem is INFEASIBLE!\n");
    }
}

#ifdef __INTEGRATED_WITH_CDA__
BOOL LPSolver::SolveCDAIntersection(CListInt *plistCDAFace0, 
				    CListInt *plistCDAFace1, 
				    Vector &vSolution)
{
  CListIterInt iterCDAFace;
  CDAFace *pCDAFace;

  UINT_32 i, j, uiMask, uiBit, uiSetSize;
  UINT_32 uiDim, uiHalfSpaces;
  FLOAT fMag;
  LPVector vNormal;
  LPVector vC;
  LPVector vSol;
  LPVector vIn;
  UINT_32 uiCoincidences;
  BOOL bInterior;
  FLOAT fTMin, fT;

  printf("START: SolveCDAIntersection\n");

  uiDim = 3;

  ASSERT( plistCDAFace0 != NULL );
  ASSERT( plistCDAFace1 != NULL );
  ASSERT( plistCDAFace0->GetLength() > 3 );
  ASSERT( plistCDAFace1->GetLength() > 3 );

  uiHalfSpaces = plistCDAFace0->GetLength() + plistCDAFace1->GetLength();

  AllocateWorkSpace(uiDim, uiHalfSpaces);

  i = 0;
  iterCDAFace.Init(plistCDAFace0);
  for ( pCDAFace = (CDAFace*)(iterCDAFace.PeekFirst());
	pCDAFace != NULL;
	pCDAFace = (CDAFace*)(iterCDAFace.PeekNext()) )
    {
      memcpy(&(m_pfWorkSpace[GetIndex(uiDim, i)]), 
	     pCDAFace->GetNormal().Get(),
	     (uiDim+1)*sizeof(FLOAT));
      
      vNormal.Init(uiDim, &(m_pfWorkSpace[GetIndex(uiDim, i)]));
      fMag = vNormal.Magnitude();
      ASSERT( fMag != 0.0 );

      vNormal.Init(uiDim+1, &(m_pfWorkSpace[GetIndex(uiDim, i)]));
      vNormal /= fMag;
//      vNormal.Display();

      i++;
    }

  iterCDAFace.Init(plistCDAFace1);
  for ( pCDAFace = (CDAFace*)(iterCDAFace.PeekFirst());
	pCDAFace != NULL;
	pCDAFace = (CDAFace*)(iterCDAFace.PeekNext()) )
    {
      memcpy(&(m_pfWorkSpace[GetIndex(uiDim, i)]), 
	     pCDAFace->GetNormal().Get(),
	     (uiDim+1)*sizeof(FLOAT));
      
      vNormal.Init(uiDim, &(m_pfWorkSpace[GetIndex(uiDim, i)]));
      fMag = vNormal.Magnitude();
      ASSERT( fMag != 0.0 );
      
      vNormal.Init(uiDim+1, &(m_pfWorkSpace[GetIndex(uiDim, i)]));
      vNormal /= fMag;
//      vNormal.Display();

      i++;
    }
  ASSERT( i == uiHalfSpaces );

  vC.Init(uiDim, GetC(uiDim));
  vC.Null();
  vC[0] = 1.0; // X axis direction
  //vC[2] = 1.0; // Z axis direction
  vSol.Init(uiDim+1, m_pfSolution);

  if ( !BoundedLP(uiDim, uiHalfSpaces, vC, vSol) )
    {
      printf("\nThe problem is INFEASIBLE!\n");
      return FALSE;
    }

  ASSERT( vSol[3] == 1.0 );

  printf("\nSOLUTION: ");
  vSol.Display();

  ///////////////////////////////////////////////////
  // This needs intellectual work!!!!!!!!!!!!!
  //
  // We are going to exhaustively search through all sets of 3
  // planes which go through our LP Solution Point to find a
  // vector pointing in to the feasible region.  We will use a 
  // stab line to find the point on the opposite side and take the
  // midpoint as the interior point.  
  // THIS IS THE BAD PART: Then we will have to test our possible 
  // interior point against all of the constraint planes to see if
  // it really worked.  If not we will have to calculate a new 
  // interior vector and interior point and try again.
  // If all attempts fail then we have a degenerate intersection.

  // Move all planes that go through the solution to the front of the
  // list
  uiCoincidences = uiDim;
  for ( i = uiDim; i < uiHalfSpaces; i++ )
    {
      vNormal.Init(uiDim+1, GetValues(uiDim, i));      
      if ( vSol.Dot(vNormal) >= 0.0 - CDA_EPSILON && 
	   vSol.Dot(vNormal) <= 0.0 + CDA_EPSILON )
	{
	  Swap(uiDim, uiCoincidences, i);
	  uiCoincidences++;
	}
    }
/*
  printf("Searching for point in the intersection\n");
  Display();
*/
  // Search through all sets of three planes through the solution to
  // try to find a vector into the middle of the feasible region and
  // a point in the feasible region.
  bInterior = FALSE;
  for ( uiMask = (0x1 << uiDim) - 1; 
	uiMask < (UINT_32)(0x1 << uiCoincidences) && !bInterior; 
	uiMask++ )
    {
      // Build the inward facing vector
      vIn.Init(uiDim, m_pfNormalNeg);
      vIn.Null();
      uiBit = 0x1;
      uiSetSize = 0;
      for ( i = 0; i < uiCoincidences; i++ )
	{
	  if ( uiBit & uiMask )
	    {
	      // Add on to the vector
	      vNormal.Init(uiDim, GetValues(uiDim, i));
	      vIn += vNormal;
	      uiSetSize++;
	    }
	  uiBit = (uiBit << 1);
	}

      if ( uiSetSize >= uiDim )
	{
	  // We have the minimum number of half planes necessary so
	  // try to find an interior point
	  if ( !vIn.Normalize() )
	    {
	      continue;
	    }
	  vIn *= -1.0;
	  vIn.Init(uiDim+1, m_pfNormalNeg);
	  vIn[uiDim] = 0.0;
	  
/*
	  printf("vIn = ");
	  vIn.Display();
*/	  
	  // So now shoot a stabbing line from the solution point 
	  // along vIn and find the first intersection with a 
	  // Hyperplane 
	  
	  fTMin = INFINITY;
	  for ( j = uiCoincidences; j < uiHalfSpaces; j++ )
	    {
	      vNormal.Init(uiDim+1, GetValues(uiDim, j));      
	      ASSERT( vSol.Dot(vNormal) != 0.0 );
	      fT = vNormal.Dot(vIn);
	      if ( fT != 0.0 )
		{
		  fT = -vNormal.Dot(vSol) / fT;
		  if ( fT > 0.0 && fT < fTMin )
		    {
		      fTMin = fT;
		    }
		}
	    }
	  
	  if ( fTMin == INFINITY )
	    {
	      continue;
	    }
	  
	  // Compute the interior point as the midpoint from 
	  // the line equation
	  fTMin = fTMin / (FLOAT)2.0;
	  for ( j = 0; j < uiDim; j++ )
	    {
	      vIn[j] = vSol[j] + fTMin*vIn[j];
	    }
	  vIn[3] = 1.0;
/*	  
	  printf("Interior Point = ");
	  vIn.Display();
*/	  
	  // Verify that the Interior point really lies within 
	  // all of the half spaces, and not on them
	  bInterior = TRUE;
	  for ( j = 0; j < uiHalfSpaces; j++ )
	    {
	      vNormal.Init(uiDim+1, GetValues(uiDim, j));
	      if ( vIn.Dot(vNormal) >= 0.0 )
		{
		  bInterior = FALSE;
		  break;
		}
	    }
	}
    }
/*
  // the old way which only did groups of 3 -- BAD!!!!
  bInterior = FALSE;
  for ( i = 0; i < uiCoincidences - 2 && !bInterior; i++ )
    {
      for ( j = i+1; j < uiCoincidences - 1 && !bInterior; j++ )
	{
	  for ( k = j+1; k < uiCoincidences && !bInterior; k++ )
	    {
	      // Compute a first guess of the inside vector vIn
	      // This may not actually be a vector which points into our
	      // volume because the 3 planes which defined the solution 
	      // point may not be the only planes which this point 
	      // lies on.

	      vIn.Init(uiDim, m_pfNormalNeg);
	      vNormal.Init(uiDim, GetValues(uiDim, i));
	      vIn = vNormal;
	      vNormal.Init(uiDim, GetValues(uiDim, j));
	      vIn += vNormal;
	      vNormal.Init(uiDim, GetValues(uiDim, k));
	      vIn += vNormal;
	      if ( !vIn.Normalize() )
		{
		  continue;
		}
	      vIn *= -1.0;
	      vIn.Init(uiDim+1, m_pfNormalNeg);
	      vIn[uiDim] = 0.0;

	      //printf("vIn = ");
	      //vIn.Display();

	      // So now shoot a stabbing line from the solution point 
	      // along vIn and find the first intersection with a 
	      // Hyperplane 

	      fTMin = INFINITY;
	      for ( m = uiCoincidences; m < uiHalfSpaces; m++ )
		{
		  vNormal.Init(uiDim+1, GetValues(uiDim, m));      
		  ASSERT( vSol.Dot(vNormal) != 0.0 );
		  fT = vNormal.Dot(vIn);
		  if ( fT != 0.0 )
		    {
		      fT = -vNormal.Dot(vSol) / fT;
		      if ( fT > 0.0 && fT < fTMin )
			{
			  fTMin = fT;
			}
		    }
		}

	      if ( fTMin == INFINITY )
		{
		  continue;
		}

	      // Compute the interior point as the midpoint from 
	      // the line equation
	      fTMin = fTMin / 2.0;
	      for ( m = 0; m < uiDim; m++ )
		{
		  vIn[m] = vSol[m] + fTMin*vIn[m];
		}
	      vIn[3] = 1.0;

	      //printf("Interior Point = ");
	      //vIn.Display();
	      
	      // Verify that the Interior point really lies within 
	      // all of the half spaces, and not on them
	      bInterior = TRUE;
	      for ( m = 0; m < uiHalfSpaces; m++ )
		{
		  vNormal.Init(uiDim+1, GetValues(uiDim, m));
		  if ( vIn.Dot(vNormal) >= 0.0 )
		    {
		      bInterior = FALSE;
		      break;
		    }
		}
	    }
	}
    }
*/
  if ( !bInterior )
    {
      printf("ERROR: The Linear Programming code got an answer, but my interior finding code failed to find an interior point.\nThe intersection is degenerate.\n");
      return FALSE;
    }

  vSol = vIn;
  printf("The Interior Point = ");
  vSol.Display();
  vSolution.Set(m_pfSolution);

  printf("  END: SolveCDAIntersection\n");

  return TRUE;
}
#endif // __INTEGRATED_WITH_CDA__

BOOL LPSolver::BoundedLP(UINT_32 uiDim, UINT_32 uiHalfSpaces, 
			 const LPVector &vC, LPVector &vSolution)
{
  UINT_32 i, j;
  UINT_32 uiStart;
  UINT_32 uiHmin, uiHpar, uiHminmax, uiHparmin;
  FLOAT fDot, fMag;
  LPVector vHalfSpace;
  LPVector vNormal, vNormalCurr, vNormalProj;
  LPVector vCProj;
  BOOL bNormalized, bFeasible, bResult;
	      
  bResult = TRUE;

  ASSERT( uiDim > 0 );
 
  // Deal with the recursion
  uiStart = m_uiDimMax - uiDim;
/*
  printf("\n***** START: BoundedLP d = %ld: %ld => %ld *****\n\n", 
	 uiDim, uiStart, uiHalfSpaces);
  Display();
*/
  ASSERT( uiStart <= uiHalfSpaces );

  bFeasible = UnboundedLP(uiDim, uiHalfSpaces, vC, vSolution);
  if ( uiDim == 1 )
    {
      // UnboundedLP Found the solution for us
      bResult = bFeasible;
      goto end;
    }

  if ( vSolution[m_uiDimMax] == 0.0 )
    {
      // Unbounded
      bResult = TRUE;
      goto end;
    }
  else
    {
      // Compute Random Permutation

      ASSERT( m_uiDimMax <= uiHalfSpaces );
      if ( m_uiDimMax < uiHalfSpaces )
	{
	  for ( i = 0; i < (uiHalfSpaces-m_uiDimMax); i++ )
	    {
	      // Pick a random position from the unset position and 
	      // swap its value setting the current position
	      j = (rand()%((uiHalfSpaces-m_uiDimMax)-i)) + i;
	      
	      // Do the swap
	      Swap(uiDim, m_uiDimMax+i, m_uiDimMax+j);
	    }
	}

      // Iterate through the half spaces
      
      for ( i = m_uiDimMax; i < uiHalfSpaces; i++ )
	{
	  vHalfSpace.Init(m_uiDimMax + 1, GetValues(uiDim, i));	  
	  if ( vHalfSpace.Dot(vSolution) > 0.0 )
	    {
	      // The partial solution point does not lie with in this 
	      // half space so we must recurse on dimension to solve
	      // for a new solution point.

	      //////////////////////////////////////////////////
	      // We are going to have to project the Hyperplanes
	      // that we have already touched down onto the current
	      // Hyperplane which our Current Solution is violating

	      // Swap the current Hyperplane to the front like in
	      // UnboundedLP
	      Swap(uiDim, i, uiStart);
	      vNormal.Init(m_uiDimMax, GetValues(uiDim, uiStart));
      
	      // Find the set of Half Spaces with the same normal
	      uiHmin = 0;
	      for ( j = i - uiHmin; j > uiStart; j-- )
		{
		  vNormalCurr.Init(m_uiDimMax, GetValues(uiDim, j));
		  fDot = vNormal.Dot(vNormalCurr);
		  if ( fDot >= 1.0 - CDA_EPSILON && fDot <= 1.0 + CDA_EPSILON )
		    {
		      // The Half Space we are projecting on to
		      // should be the highest of the Min set so far
		      ASSERT( !(GetValues(uiDim, j)[m_uiDimMax] >
				GetValues(uiDim, uiStart)[m_uiDimMax]) );
		      
		      // Swap this Half Space to the end of the set of
		      // Half Spaces which have already been visited
		      // in the random permutation, so that we can
		      // exclude it from our computations in the 
		      // recursion
		      Swap(uiDim, j, i-uiHmin);
		      
		      uiHmin++;
		    }
		}
	      
	      // Find the set of Half Spaces with the opposite normal
	      uiHpar = 0;
	      for ( j = i - uiHmin; j > uiStart; j-- )
		{
		  vNormalCurr.Init(m_uiDimMax, GetValues(uiDim, j));
		  fDot = vNormal.Dot(vNormalCurr);
		  if ( fDot >= -1.0 - CDA_EPSILON && 
		       fDot <= -1.0 + CDA_EPSILON )
		    {
		      // Swap this Half Space to the end of the set of
		      // Half Spaces which have already been visited
		      // in the random permutation, so that we can
		      // exclude it from our computations in the 
		      // recursion
		      Swap(uiDim, j, i-(uiHmin+uiHpar));
		      
		      uiHpar++;
		    }
		}
	      
	      //////////////////////////////////////////////////
	      // Find the intersection of Hmin and Hpar

	      // The Highest minimum bound should be the Half Space
	      // we are projecting on to
	      uiHminmax = uiStart;
	      
	      // Find the Lowest maximum bound
	      uiHparmin = i - uiHmin;
	      for ( j = i - uiHmin; 
		    j > i - (uiHmin + uiHpar); 
		    j-- )
		{
		  if ( GetValues(uiDim, j)[m_uiDimMax] > 
		       GetValues(uiDim, uiHparmin)[m_uiDimMax] )
		    {
		      uiHparmin = j;
		    }
		}

	      // Check for infeasibility
	      if ( (uiHpar != 0) && 
		   (-GetValues(uiDim, uiHparmin)[m_uiDimMax] < 
		    GetValues(uiDim, uiHminmax)[m_uiDimMax]) )
		{
		  // The intersection is infeasible
		  bResult = FALSE;
		  goto end;
		}

	      // End 
	      //////////////////////////////////////////////////

	      for ( j = uiStart + 1; j < (i+1) - (uiHmin + uiHpar); j++ )
		{
		  vNormalCurr.Init(m_uiDimMax, GetValues(uiDim, j));
		  vNormalProj.Init(m_uiDimMax, GetValues(uiDim-1, j));
		  
		  fDot = vNormal.Dot(vNormalCurr);
		  
		  vNormalProj = vNormal;
		  vNormalProj *= -fDot;
		  vNormalProj += vNormalCurr;	      
		  
		  GetValues(uiDim-1, j)[m_uiDimMax] = 
		    GetValues(uiDim, j)[m_uiDimMax] - 
		    fDot*GetValues(uiDim, uiStart)[m_uiDimMax];

		  // Normalize the Hyperplane equation so that the normal
		  // is unit length
		  fMag = vNormalProj.Magnitude();
		  ASSERT( fMag != 0.0 );
		  
		  vNormalProj.Init(m_uiDimMax+1, GetValues(uiDim-1, j));
		  vNormalProj /= fMag;
		}
	      
	      // Project the Objective Function C to this Hyperplane
	      vCProj.Init(m_uiDimMax, GetC(uiDim-1));
	      
	      vCProj = vNormal;
	      fDot = -(vNormal.Dot(vC));
	      vCProj *= fDot;
	      vCProj += vC;	      
	  
	      bNormalized = vCProj.Normalize();
	      
	      if ( !bNormalized || 
		   (fDot >= 1.0 - CDA_EPSILON && fDot <= 1.0 + CDA_EPSILON) ||
		   (fDot >= -1.0 - CDA_EPSILON && fDot <= -1.0 + CDA_EPSILON) )
		{
		  ASSERT( uiStart < (i+1) - (uiHmin + uiHpar) );
		  vNormalProj.Init(m_uiDimMax, GetValues(uiDim-1,0));
		  vCProj = vNormalProj;
		}
/*
	      printf("BoundedLP Recursing\n");
	      printf("Half Space %ld does not include our current solution\n", i);
	      printf("Curr Solution = ");
	      vSolution.Display();
	      printf("Curr Half Space = ");
	      vHalfSpace.Init(m_uiDimMax + 1, GetValues(uiDim, uiStart));
	      vHalfSpace.Display();
*/
	      bFeasible = BoundedLP(uiDim-1, (i+1) - (uiHmin + uiHpar), 
				    vCProj, vSolution);
#ifdef CLEAN_UP_AFTER
	      // Debugging only wipe the memory to zeroes on exiting
	      for ( UINT_32 uiJordan = m_uiDimMax - uiDim + 1; uiJordan < (i+1) - (uiHmin + uiHpar); uiJordan++ )
		{
		  vNormalCurr.Init(m_uiDimMax+1, GetValues(uiDim-1, uiJordan));
		  vNormalCurr.Null();
		  for ( UINT_32 uiLarry = 0; uiLarry < m_uiDimMax+1; uiLarry++ )
		    {
		      vNormalCurr[uiLarry] = 77.0;
		    }
		}
/*	      
	      printf("After Cleaning Up BoundedLP:\n");
	      Display();
*/
#endif // CLEAN_UP_AFTER
	      if ( !bFeasible )
		{
		  // Infeasible
		  bResult = FALSE;
		  goto end;
		}
	      else
		{
		  ASSERT( vSolution[m_uiDimMax] != 0.0 );
		}
	    }
	  else
	    {
	      // Just continue to iterate through the other half spaces
	    }
	}
    }

end:
  return bResult;
}

BOOL LPSolver::UnboundedLP(UINT_32 uiDim, UINT_32 uiHalfSpaces, 
			   const LPVector &vC, LPVector &vSolution)
{
  UINT_32 i;
  UINT_32 uiStart;
  UINT_32 uiHmin, uiHpar, uiHminmax, uiHparmin;
  FLOAT fDot, fDotMax, fMag;
  LPVector vNormal;
  LPVector vNormalCurr, vNormalProj;
  LPVector vCProj;
  BOOL bNormalized, bFeasible, b;

  BOOL bResult;

  ASSERT( uiDim > 0 );
 
  bResult = TRUE;
  bFeasible = TRUE;

  // Deal with the recursion
  uiStart = m_uiDimMax - uiDim;

  if ( uiStart == uiHalfSpaces )
    {
      // Unbounded 
      bResult = TRUE;
      goto end;
    }

  // Find the Half Space from H who's normal makes the minimum angle with
  // the direction C
  // In other words, where the dot product is the biggest, i.e. closest 
  // to 1.0
  fDotMax = -INFINITY;
  uiHmin = uiStart;
  for ( i = uiStart; i < uiHalfSpaces; i++ )
    {
      vNormalCurr.Init(m_uiDimMax, GetValues(uiDim, i));
      fDot = vC.Dot(vNormalCurr);
      if ( fDot > fDotMax )
	{
	  fDotMax = fDot;

	  // Record this Half Space as the minimum slope Half Space
	  uiHmin = i;
	}
    }
  // Swap this minimum slope Half Space with the first Half Space
  Swap(uiDim, uiHmin, uiStart);

  // Find the set of Half Planes with the same normal
  uiHmin = 1;
  vNormal.Init(m_uiDimMax, GetValues(uiDim, uiStart));
  for ( i = uiHalfSpaces - uiHmin; i > uiStart; i-- )
    {
      vNormalCurr.Init(m_uiDimMax, GetValues(uiDim, i));
      fDot = vNormal.Dot(vNormalCurr);
      if ( fDot >= 1.0 - CDA_EPSILON && fDot <= 1.0 + CDA_EPSILON )
	{
	  // Swap this fellow minimum slope Half Space to end of
	  // the set of Half Spaces so that we will not consider it
	  // when we recurse
	  Swap(uiDim, i, uiHalfSpaces-uiHmin);
	  
	  uiHmin++;
	}
    }

  // Find the set of Half Planes with the opposite normal
  uiHpar = 0;
  for ( i = uiHalfSpaces - uiHmin; i > uiStart; i-- )
    {
      vNormalCurr.Init(m_uiDimMax, GetValues(uiDim, i));
      fDot = vNormal.Dot(vNormalCurr);
      if ( fDot >= -1.0 - CDA_EPSILON && fDot <= -1.0 + CDA_EPSILON )
	{
	  // Swap this parallel slope Half Space with opposite
	  // orientation to the end of the set of Half Spaces so 
	  // that we will not consider it when we recurse
	  Swap(uiDim, i, uiHalfSpaces - (uiHmin + uiHpar));
	  
	  uiHpar++;
	}
    }

  //////////////////////////////////////////////////////////////////////
  // Find the intersection of Hmin and Hpar

  // Find the Highest minimum bound
  uiHminmax = uiStart;
  for ( i = uiHalfSpaces - 1; i > uiHalfSpaces-uiHmin; i-- )
    {
      if ( GetValues(uiDim, i)[m_uiDimMax] >
	   GetValues(uiDim, uiHminmax)[m_uiDimMax] )
	{
	  uiHminmax = i;
	}
    }
  // Swap this Highest Half Space to the front it is the first
  // Half Space necessary for finding our initial solution
  Swap(uiDim, uiHminmax, uiStart);
  uiHminmax = uiStart;

  // Find the Lowest maximum bound
  uiHparmin = i;
  for ( i = uiHalfSpaces - uiHmin; 
	i > uiHalfSpaces - (uiHmin + uiHpar); 
	i-- )
    {
      if ( GetValues(uiDim, i)[m_uiDimMax] > 
	   GetValues(uiDim, uiHparmin)[m_uiDimMax] )
	{
	  uiHparmin = i;
	}
    }

  // It is not appropriate for this procedure to decide that the 
  // problem is infeasible here, we must continue on to find some 
  // starting point solution which we will improve on
 
  // Check for infeasibility
  if ( (uiHpar != 0) && 
       (-GetValues(uiDim, uiHparmin)[m_uiDimMax] < 
	GetValues(uiDim, uiHminmax)[m_uiDimMax]) )
    {
      bFeasible = FALSE;
    }


    {
      if ( fDotMax <= 0.0 )
	{
	  // It is unbounded
	  
	  // I need to fix this
	  vSolution.Null();

	  bResult = bFeasible;	  
	  goto end;
	}

      if ( uiDim == 1 )
	{
	  LPVector vConstants, vCoeffs;

	  // The LP is bounded and feasible

	  // We are now solving A*x = b for the d left most half spaces.
	  // The special thing about these d half spaces is that they
	  // are orthonormal based on how we produced them by projecting
	  // them on to each other one at a time.
	  // This means that the solution to the equation is
	  // x = INV(A) * b = TRANSPOSE(A) * b
	  // So to get x[i] = A[*,i] * b

	  // This is the vector of the d constants of the 
	  // d Half Spaces' equations
	  vConstants.Init(m_uiDimMax, 
			  (m_uiDimMax-1)*(m_uiDimMax+1),
			  &(m_pfWorkSpace[(m_uiDimMax-1)*(m_uiDimMax+1)+m_uiDimMax]));
	  for ( i = 0; i < m_uiDimMax; i++ )
	    {
	      // This is the vector of the d ith coefficients (A[*,i])
	      // of the d Half Spaces' equations
	      vCoeffs.Init(m_uiDimMax, 
			   (m_uiDimMax-1)*(m_uiDimMax+1),
			   &(m_pfWorkSpace[(m_uiDimMax-1)*(m_uiDimMax+1)+i]));
	      vSolution[i] = -vCoeffs.Dot(vConstants);
	    }
	  // This makes it a homogeneous point instead of a direction
	  vSolution[i] = 1.0; 

	  bResult =  bFeasible;
	}
      else
	{
	  // Project the problem to a lower dimension and recurse

	  // This is the lower dimension subspace which we are
	  // projecting to
	  vNormal.Init(m_uiDimMax, GetValues(uiDim, uiStart));

	  uiHalfSpaces -= (uiHmin - 1 + uiHpar);
	  for ( i = uiStart + 1; i < uiHalfSpaces; i++ )
	    {
	      vNormalCurr.Init(m_uiDimMax, GetValues(uiDim, i));
	      vNormalProj.Init(m_uiDimMax, GetValues(uiDim-1, i));

	      fDot = vNormal.Dot(vNormalCurr);

	      vNormalProj = vNormal;
	      vNormalProj *= -fDot;
	      vNormalProj += vNormalCurr;	      
	      
	      GetValues(uiDim-1, i)[m_uiDimMax] = 
		GetValues(uiDim, i)[m_uiDimMax] - 
		fDot*GetValues(uiDim, uiStart)[m_uiDimMax];

	      // Normalize the Hyperplane equation so that the normal
	      // is unit length
	      fMag = vNormalProj.Magnitude();
	      ASSERT( fMag != 0.0 );
	   
	      vNormalProj.Init(m_uiDimMax+1, GetValues(uiDim-1, i));
	      vNormalProj /= fMag;
	    }
  
	  // Project the Objective Function C to this Hyperplane
	  vCProj.Init(m_uiDimMax, GetC(uiDim-1));

	  vCProj = vNormal;
	  fDot = -(vNormal.Dot(vC));
	  vCProj *= fDot;
	  vCProj += vC;	      
	  
	  bNormalized = vCProj.Normalize();
  
	  if ( !bNormalized || 
	       (fDot >= 1.0 - CDA_EPSILON && fDot <= 1.0 + CDA_EPSILON) ||
	       (fDot >= -1.0 - CDA_EPSILON && fDot <= -1.0 + CDA_EPSILON) )
	    {
	      ASSERT( uiStart + 1 < uiHalfSpaces );
	      vNormalProj.Init(m_uiDimMax, GetValues(uiDim-1,uiStart+1));
	      vCProj = vNormalProj;
	    }

	  b = UnboundedLP(uiDim-1, uiHalfSpaces, vCProj, vSolution);
#ifdef CLEAN_UP_AFTER
	// Debugging only wipe the memory to zeroes on exiting
	for ( UINT_32 uiJordan = m_uiDimMax - uiDim + 1; uiJordan < uiHalfSpaces; uiJordan++ )
	  {
	    vNormalCurr.Init(m_uiDimMax+1, GetValues(uiDim-1, uiJordan));
	    vNormalCurr.Null();
	    for ( UINT_32 uiLarry = 0; uiLarry < m_uiDimMax+1; uiLarry++ )
	      {
		vNormalCurr[uiLarry] = 33.0;
	      }
	  }

	printf("After Cleaning Up UnboundedLP:\n");
	Display();
#endif // CLEAN_UP_AFTER

	  bResult = bFeasible && b;
	}
    }

end:
  return bResult;
}

VOID LPSolver::RandomPermutation(UINT_32 uiSize, UINT_32 *puiPermutation)
{
  UINT_32 i, j, uiTemp;

  ASSERT( puiPermutation != NULL );

  for ( i = 0; i < uiSize; i++ )
    {
      puiPermutation[i] = i;
    }

  for ( i = 0; i < uiSize; i++ ) 
    {
      // Pick a random position from the unset position and 
      // swap its value setting the current position
      j = (rand()%(uiSize-i)) + i;

      // Do the swap
      uiTemp = puiPermutation[j];
      puiPermutation[j] = puiPermutation[i];
      puiPermutation[i] = uiTemp;
    }
}

VOID LPSolver::AllocateWorkSpace(UINT_32 uiDim, UINT_32 uiHalfSpaces)
{
  UINT_32 uiWorkSpaceSize;
  UINT_32 uiSwapSpaceSize;
  UINT_32 uiDimSpaceSize;
  UINT_32 uiHalfSpacesSize;

  uiWorkSpaceSize = uiDim*uiHalfSpaces*(uiDim+1);
  uiSwapSpaceSize = uiDim*(uiDim+1);
  uiDimSpaceSize = uiDim;
  uiHalfSpacesSize = uiHalfSpaces;

  if ( uiWorkSpaceSize > m_uiWorkSpaceSize ||
       uiSwapSpaceSize > m_uiSwapSpaceSize ||
       uiDimSpaceSize > m_uiDimSpaceSize ||
       uiHalfSpacesSize > m_uiHalfSpacesSize )
    {
      DeallocateWorkSpace();

      m_uiWorkSpaceSize = uiWorkSpaceSize;
      m_uiSwapSpaceSize = uiSwapSpaceSize;
      m_uiDimSpaceSize = uiDimSpaceSize;
      m_uiHalfSpacesSize = uiHalfSpacesSize;

      m_pfWorkSpace = new FLOAT[m_uiWorkSpaceSize];
      ASSERT( m_pfWorkSpace != NULL );
      memset(m_pfWorkSpace, 0, m_uiWorkSpaceSize * sizeof(FLOAT));

      m_pfSwapSpace = new FLOAT[m_uiSwapSpaceSize];
      ASSERT( m_pfSwapSpace != NULL );
      memset(m_pfSwapSpace, 0, m_uiSwapSpaceSize * sizeof(FLOAT));

      m_pfCSpace = new FLOAT[m_uiSwapSpaceSize];
      ASSERT( m_pfCSpace != NULL );
      memset(m_pfCSpace, 0, m_uiSwapSpaceSize * sizeof(FLOAT));

      m_pfNormalNeg = new FLOAT[m_uiDimSpaceSize];
      ASSERT( m_pfNormalNeg != NULL );
      memset(m_pfNormalNeg, 0, m_uiDimSpaceSize * sizeof(FLOAT));

      m_pfSolution = new FLOAT[m_uiDimSpaceSize+1];
      ASSERT( m_pfSolution != NULL );
      memset(m_pfSolution, 0, (m_uiDimSpaceSize+1) * sizeof(FLOAT));

      m_puiRandomPermutation = new UINT_32[m_uiHalfSpacesSize];
      ASSERT( m_puiRandomPermutation != NULL );
      memset(m_puiRandomPermutation, 0, 
	     m_uiHalfSpacesSize*sizeof(UINT_32));
    }

  m_uiDimMax = uiDim;
  m_uiHalfSpacesMax = uiHalfSpaces;
}

VOID LPSolver::DeallocateWorkSpace()
{
  if ( m_pfWorkSpace != NULL )
    {
      delete[] m_pfWorkSpace;
      m_pfWorkSpace = NULL;
    }

  if ( m_pfSwapSpace != NULL )
    {
      delete[] m_pfSwapSpace;
      m_pfSwapSpace = NULL;
    }

  if ( m_pfCSpace != NULL )
    {
      delete[] m_pfCSpace;
      m_pfCSpace = NULL;
    }
  
  if ( m_pfNormalNeg != NULL )
    {
      delete[] m_pfNormalNeg;
      m_pfNormalNeg = NULL;
    }

  if ( m_pfSolution != NULL )
    {
      delete[] m_pfSolution;
      m_pfSolution = NULL;
    }

  if ( m_puiRandomPermutation != NULL )
    {
      delete[] m_puiRandomPermutation;
      m_puiRandomPermutation = NULL;
    }

  m_uiWorkSpaceSize = 0;
  m_uiSwapSpaceSize = 0;
  m_uiDimSpaceSize = 0;
  m_uiHalfSpacesSize = 0;
}

VOID LPSolver::Display()
{
  UINT_32 i, j, k, m;

  printf("< ");
  for ( i = 0; i <= m_uiDimMax; i++ )
    {
      printf("%.3f ", m_pfSolution[i]);
    }
  printf(">\n\n");

  k = 0;
  for ( i = 0; i < m_uiDimMax; i++ )
    {
      printf("[ ");
      for ( j = 0; j <= m_uiDimMax; j++ )
	{
	  printf("%.3f ", m_pfCSpace[k]);
	  k++;
	}
      printf("]  ");
    }
  printf("\n\n");

  m = 0;
  for ( i = 0; i < m_uiHalfSpacesMax; i++ )
    {
      for ( j = 0; j < m_uiDimMax; j++ )
	{
	  printf("< ");
	  for ( k = 0; k <= m_uiDimMax; k++ )
	    {
	      printf("%.3f ", m_pfWorkSpace[m]);
	      m++;
	    }
	  printf(">  ");
	}
      printf("\n");
    }
}
