#ifndef __MATHLIBX_H__
#define __MATHLIBX_H__

//////////////////////////////////////////////////////////////////////////////
// Standard Include Files
//

#include "types.h"
//#include "genlib.h"

#include <math.h>
#include <limits.h>
#include <float.h>

//#include "dynamics.h"

//////////////////////////////////////////////////////////////////////////////
// Macro Functions
//

#ifndef MIN
#define MIN(a,b) (((a)<(b)) ? (a) : (b))
#endif // MIN

#ifndef MAX
#define MAX(a,b) (((a)>(b)) ? (a) : (b))
#endif // MAX

#ifndef ABS
#define ABS(a) (((a)<0) ? (-(a)) : (a))
#endif // ABS

#ifndef PI
#define PI            3.14159265358979323846
#endif // PI

#ifndef DEGTORAD
#define DEGTORAD(x) (FLOAT)((PI/180.0)*(x))
#endif // DEGTORAD

#ifndef RADTODEG
#define RADTODEG(x) (FLOAT)((180.0/PI)*(x))
#endif // RADTODEG

#ifndef ODD
#define ODD(x) (x & 1)
#endif // ODD

#ifndef EVEN
#define EVEN(x) (!ODD(x))
#endif // EVEN

//////////////////////////////////////////////////////////////////////////////
// Constant Definitions
//

enum CartesianCoordType { X, Y, Z, W };
enum ColorCoordType { R, G, B, A };

const FLOAT EPSILON = 0.0001f;
const FLOAT INFINITY = FLT_MAX;
//#ifdef __OS_SunOS__
//#define INFINITY 3.40282347E+38F
//#else // __OS_SunOS__
//#define INFINITY FLT_MAX
//#endif // __OS_SunOS__
//#define MAX_UINT 0xffffffff

typedef FLOAT POINT4D[4];
typedef FLOAT VECTOR4D[4];
typedef FLOAT MATRIX4D[16];

#endif // __MATHLIBX_H__





