#ifndef __QE_H__
#define __QE_H__

#include "genlib.h"
#include "mathlib.h"
#include "datalib.h"

//////////////////////////////////////////////////////////////////////
// QE Class
//

class QE
{
//////////////////////////////////////////////////
// Friends
//
public:

//////////////////////////////////////////////////
// Enumerated Types
//
public:
  enum SubdivisionType { stCornerCutting, stCornerRounding, stTriangle, 
			 stDooSabin, stCatmullClark, stCatmullClarkC2, 
			 stTesselate, 
			 stLoop, stLoopEdgeRule, stSharpLoop, 
			 stButterfly, stZorin, 
			 stSphere, 
			 stSize }; 
  enum SharpVertexType { svtSmooth, svtDart, svtRegularCrease, 
			 svtBoundaryCrease, svtNonregularCrease, svtCorner, svtSize };
  enum DelaunayType { dtIncremental, dtIncrementalSlow, dtIncrementalNoBound, 
		      dtDivideAndConquer, dtDivideAndConquerAlternating, 
		      dtConvexHull, dtSize };
  enum VoronoiType { vtDelaunay, vtDivideAndConquer, vtDivideAndConquerAlternating, 
                     vtCones, vtPlanes, vtSize };
  enum OffsetType { otStart, otSplit, otClose, otConnect, otSize };
  enum AccuracyType { atFloatNaive, atFloat, atExact, atSize };

  enum ErrorMetricType { emtBestFitPlane, emtLimitDistance, emtSize };

//////////////////////////////////////////////////
// Initialization
//
public:
  QE();
  virtual ~QE();
  virtual VOID Init();
  virtual VOID Uninit() = 0;

//////////////////////////////////////////////////
// Output Functions
//
public:

//////////////////////////////////////////////////
// Accessor Functions
//
public:

//////////////////////////////////////////////////
// Class Accessor Functions
//
public:

//////////////////////////////////////////////////
// Class Variables
//
protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

#endif // __QE_H__
