#ifndef __QEEDGECOLLAPSE_H__
#define __QEEDGECOLLAPSE_H__

#include "qemem.h"

//////////////////////////////////////////////////////////////////////
// QEEdgeCollapse Class
//

class QEEdgeCollapse
{
//////////////////////////////////////////////////
// Friends
//
public:

//////////////////////////////////////////////////
// Enumerated Types
//
public:

//////////////////////////////////////////////////
// Initialization
//
public:
  QEEdgeCollapse();
  virtual ~QEEdgeCollapse();
  virtual VOID Init();
  virtual VOID Uninit();

  virtual BOOL Initialized();
  virtual BOOL Valid();

//////////////////////////////////////////////////
// Iteration Functions
//
public:

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output Functions
//
public:
  VOID Display();

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  inline BOOL GetEdgeExists();
  inline VOID SetEdgeExists(BOOL bEdgeExists);
  inline QEEdge *GetEdge();
  inline VOID SetEdge(QEEdge *pe);
  inline QEVertex *GetVertex();
  inline VOID SetVertex(QEVertex *pvx);
  inline QEEdge *GetNeighborEdge(UINT_32 uiIndex);
  inline VOID SetNeighborEdge(UINT_32 uiIndex, QEEdge *pe);
  inline QEEdge *GetRemovedEdge(UINT_32 uiIndex);
  inline VOID SetRemovedEdge(UINT_32 uiIndex, QEEdge *pe);
  inline QEFacet *GetRemovedFacet(UINT_32 uiIndex);
  inline VOID SetRemovedFacet(UINT_32 uiIndex, QEFacet *pfa);

  inline QEEdgeCollapse *GetPrevLink();
  inline VOID SetPrevLink(QEEdgeCollapse *pec);
  inline QEEdgeCollapse *GetNextLink();
  inline VOID SetNextLink(QEEdgeCollapse *pec);

//////////////////////////////////////////////////
// Class Variables
//
protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  BOOL m_bEdgeExists;
  QEEdge *m_pe;
  QEVertex *m_pvx;
  QEEdge *m_ppeNeighbor[2];
  QEEdge *m_ppeRemoved[2];
  QEFacet *m_ppfaRemoved[2];

  // Listing in a QEMesh or on a Free List
  QEEdgeCollapse *m_pecLink[2];
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline BOOL QEEdgeCollapse::GetEdgeExists()
{
  return m_bEdgeExists;
}

inline VOID QEEdgeCollapse::SetEdgeExists(BOOL bEdgeExists)
{
  m_bEdgeExists = bEdgeExists;
}

inline QEEdge *QEEdgeCollapse::GetEdge()
{
  return m_pe;
}

inline VOID QEEdgeCollapse::SetEdge(QEEdge *pe)
{
  m_pe = pe;
}

inline QEVertex *QEEdgeCollapse::GetVertex()
{
  return m_pvx;
}

inline VOID QEEdgeCollapse::SetVertex(QEVertex *pvx)
{
  m_pvx = pvx;
}

inline QEEdge *QEEdgeCollapse::GetNeighborEdge(UINT_32 uiIndex)
{
  ASSERT( uiIndex < 2 );
  return m_ppeNeighbor[uiIndex];
}

inline VOID QEEdgeCollapse::SetNeighborEdge(UINT_32 uiIndex, QEEdge *pe)
{
  ASSERT( uiIndex < 2 );
  m_ppeNeighbor[uiIndex] = pe;
}

inline QEEdge *QEEdgeCollapse::GetRemovedEdge(UINT_32 uiIndex)
{
  ASSERT( uiIndex < 2 );
  return m_ppeRemoved[uiIndex];
}

inline VOID QEEdgeCollapse::SetRemovedEdge(UINT_32 uiIndex, QEEdge *pe)
{
  ASSERT( uiIndex < 2 );
  m_ppeRemoved[uiIndex] = pe;
}

inline QEFacet *QEEdgeCollapse::GetRemovedFacet(UINT_32 uiIndex)
{
  ASSERT( uiIndex < 2 );
  return m_ppfaRemoved[uiIndex];
}

inline VOID QEEdgeCollapse::SetRemovedFacet(UINT_32 uiIndex, QEFacet *pfa)
{
  ASSERT( uiIndex < 2 );
  m_ppfaRemoved[uiIndex] = pfa;
}

inline QEEdgeCollapse *QEEdgeCollapse::GetPrevLink()
{
  return m_pecLink[0];
}

inline VOID QEEdgeCollapse::SetPrevLink(QEEdgeCollapse *pec)
{
  m_pecLink[0] = pec;
}

inline QEEdgeCollapse *QEEdgeCollapse::GetNextLink()
{
  return m_pecLink[1];
}

inline VOID QEEdgeCollapse::SetNextLink(QEEdgeCollapse *pec)
{
  m_pecLink[1] = pec;
}

#endif // __QEEDGECOLLAPSE_H__

