#ifndef __QEMEM_H__
#define __QEMEM_H__

#include "genlib.h"
#include "mathlib.h"
#include "datalib.h"

// QE Memory Management

class QEEdgeCollapse;
class QEEdgeNode;
class QEFacetNode;

class QEVertex;
class QEEdge;
class QEWedge;
class QEFacet;

class QEMesh;


QEEdgeCollapse *AllocateQEEdgeCollapse();
VOID DeallocateQEEdgeCollapse(QEEdgeCollapse *pQEEdgeCollapse);

QEEdgeNode *AllocateQEEdgeNode();
VOID DeallocateQEEdgeNode(QEEdgeNode *pQEEdgeNode);

QEFacetNode *AllocateQEFacetNode();
VOID DeallocateQEFacetNode(QEFacetNode *pQEFacetNode);

QEVertex *AllocateQEVertex();
VOID DeallocateQEVertex(QEVertex *pQEVertex);

QEEdge *AllocateQEEdge();
VOID DeallocateQEEdge(QEEdge *pQEEdge);

QEWedge *AllocateQEWedge();
VOID DeallocateQEWedge(QEWedge *pQEWedge);

QEFacet *AllocateQEFacet();
VOID DeallocateQEFacet(QEFacet *pQEFacet);

QEMesh *AllocateQEMesh();
VOID DeallocateQEMesh(QEMesh *pQEMesh);

#endif // __QEMEM_H__
