#include "qenode.h"

#include "qemesh.h"
#include "qevertex.h"
#include "qeedge.h"
#include "qefacet.h"

//////////////////////////////////////////////////////////////////////
// QENode Class
//

QENode::QENode()
{
}

QENode::~QENode()
{
  Uninit();
}

VOID QENode::Init()
{
}

VOID QENode::Uninit()
{
}

BOOL QENode::Initialized()
{
  return TRUE;
}

BOOL QENode::Valid()
{
  return TRUE;
}

VOID QENode::Display()
{
}

//////////////////////////////////////////////////////////////////////
// QEEdgeNode Class
//

QEEdgeNode::QEEdgeNode()
{
  UINT_32 i;

  for ( i = 0; i < 2; i++ )
    {
      m_ppQENode[i] = NULL;
      m_penLink[i] = NULL;
    }
}

QEEdgeNode::~QEEdgeNode()
{
}

VOID QEEdgeNode::Init(const Point &pt0, const Point &pt1)
{
  Vector v, vZ;
  UINT_32 i;

  QENode::Init();

  m_ppt[0] = pt0;
  m_ppt[1] = pt1;
  for ( i = 0; i < 2; i++ )
    {
      m_ppQENode[i] = NULL;
      ASSERT( m_penLink[i] == NULL );
    }
}

VOID QEEdgeNode::Uninit()
{
  UINT_32 i;

  QENode::Uninit();

  for ( i = 0; i < 2; i++ )
    {
      m_ppQENode[i] = NULL;
      m_penLink[i] = NULL;
    }
}

QEFacet *QEEdgeNode::FindFacet(const Point &pt)
{
  ASSERT( m_ppQENode[0] != NULL );
  ASSERT( m_ppQENode[1] != NULL );

  if ( QEMesh::Counterclockwise(pt, m_ppt[0], m_ppt[1]) )
    {
      return m_ppQENode[0]->FindFacet(pt);
    }
  else
    {
      return m_ppQENode[1]->FindFacet(pt);
    }
}

VOID QEEdgeNode::Display()
{
}

//////////////////////////////////////////////////////////////////////
// QEFacetNode Class
//

QEFacetNode::QEFacetNode()
{
  UINT_32 i;

  m_pQEFacet = NULL;

  for ( i = 0; i < 2; i++ )
    {
      m_ppParent[i] = NULL;
      m_pfnLink[i] = NULL;
    }
}

QEFacetNode::~QEFacetNode()
{
}

VOID QEFacetNode::Init()
{
  UINT_32 i;

  QENode::Init();

  m_pQEFacet = NULL;
  for ( i = 0; i < 2; i++ )
    {
      m_ppParent[i] = NULL;
      ASSERT( m_pfnLink[i] == NULL );
    }
}

VOID QEFacetNode::Uninit()
{
  UINT_32 i;

  QENode::Uninit();

  m_pQEFacet = NULL;

  for ( i = 0; i < 2; i++ )
    {
      m_ppParent[i] = NULL;
      m_pfnLink[i] = NULL;
    }
}
/*
VOID QEFacetNode::InsertVertex(QEMesh *pQEMesh, QEVertex *pvx,
			       CListInt *plistQEEdgeQueue)
{
  ASSERT( pQEMesh != NULL );
  ASSERT( pvx != NULL );
  ASSERT( plistQEEdgeQueue != NULL );
  ASSERT( m_pQEFacet != NULL );

  QEVertex *ppvx[3];
  QEEdge *ppe[3], *pe, *peCurr;
  QEFacet *ppfa[3];
  QEEdgeNode *ppen[3];
  QEFacetNode *ppfn[3];
  UINT_32 i;

  pQEMesh->InsertVertex(m_pQEFacet, pvx, plistQEEdgeQueue);

  pe = pvx->GetEdge();
  i = 0;
  peCurr = pe;
  do
    {
      ASSERT( i < 3 );
      ppe[i] = peCurr;
      ppvx[i] = ppe[i]->GetEdge()->GetVertex();
      ppfa[i] = ppe[i]->GetFacet();

      // Allocate the new search DAG nodes
      ppen[i] = AllocateQEEdgeNode();
      ASSERT( ppen[i] != NULL ); 
      ppen[i]->Init(pvx->GetPoint(), ppvx[i]->GetPoint());

      peCurr = peCurr->GetEdgeNext(1);
      i++;
    }
  while ( peCurr != pe );
  ASSERT( i == 3 );

  // Update the search DAG structure
  ASSERT( m_ppParent[0] != NULL );
  for ( i = 0; i < 2 && m_ppParent[i] != NULL; i++ )
    {
      if ( this == m_ppParent[i]->GetChild(0) )
	{
	  m_ppParent[i]->SetChild(0, ppen[0]);
	}
      else
	{
	  ASSERT( this == m_ppParent[i]->GetChild(1) );
	  m_ppParent[i]->SetChild(1, ppen[0]);
	}
    }

  ppen[0]->SetChild(0, ppen[1]);
  ppen[0]->SetChild(1, ppen[2]);

  ppfn[0] = this;
  ASSERT( ppfa[0] == m_pQEFacet );
  ASSERT( ppfn[0]->GetFacet() == ppfa[0] );

  for ( i = 1; i < 3; i++ )
    {
      ppfn[i] = AllocateQEFacetNode();
      ASSERT( ppfn[i] != NULL ); 
      ppfn[i]->Init();
      ppfn[i]->SetFacet(ppfa[i]);
      ppfa[i]->SetFacetNode(ppfn[i]);
    }
      
  ppen[1]->SetChild(0, ppfn[1]);
  ppen[1]->SetChild(1, ppfn[0]);

  ppen[2]->SetChild(0, ppfn[2]);
  ppen[2]->SetChild(1, ppfn[1]);

  ppfn[0]->SetParents(ppen[1], NULL);
  ppfn[1]->SetParents(ppen[1], ppen[2]);
  ppfn[2]->SetParents(ppen[2], NULL);
}
*/
QEFacet *QEFacetNode::FindFacet(const Point &/*pt*/)
{
  return GetFacet();
}

VOID QEFacetNode::Display()
{
}




