#ifndef __QERENDER_H__
#define __QERENDER_H__

#include "qe.h"
#include "qemem.h"

//////////////////////////////////////////////////
// Normal Mesh Rendering
//
VOID RenderGeometry(QEMesh *pme, BOOL bFaceted = TRUE, BOOL bLimitSurface = FALSE, 
		    BOOL bCalculateNormals = FALSE, BOOL bSelective = FALSE);
VOID RenderNormals(QEMesh *pme, BOOL bFaceted = TRUE, BOOL bLimitSurface = FALSE,
		    BOOL bCalculateNormals = FALSE, BOOL bSelective = FALSE);

//////////////////////////////////////////////////
// Voronoi and Offset Rendering
//
VOID RenderVoronoi(QEMesh *pmeDelaunay, QEMesh *pmeVoronoi, QE::VoronoiType eType);
VOID RenderVoronoiPolygon(QEMesh *pmeCDT, QEMesh *pmeVoronoi, QE::VoronoiType eType, 
			  UINT_32 uiSubdivisionLevelMax, FLOAT fTolerance, 
			  BOOL bDrawHeight); 
VOID RenderOffsetContour(QEMesh *pmeOffset, BOOL bDrawHeight);

#endif // __QERENDER_H__


