#ifndef __QEWEDGE_H__
#define __QEWEDGE_H__

#include "qemem.h"

//////////////////////////////////////////////////////////////////////
// QEWedge Class
//

class QEWedge
{
//////////////////////////////////////////////////
// Friends
//
public:

//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  QEWedge();
  virtual ~QEWedge();
  virtual VOID Init();
  virtual VOID Uninit();

  virtual BOOL Initialized();
  virtual BOOL Valid();

//////////////////////////////////////////////////
// Iteration Functions
//
public:

//////////////////////////////////////////////////
// Geometric Computations
//
public:
  VOID Preprocess();

protected:

//////////////////////////////////////////////////
// Rendering
//
public:
  //virtual VOID Render();

//////////////////////////////////////////////////
// Output Functions
//
public:
  VOID Display();

//////////////////////////////////////////////////
// Ordering Operators
//
public:

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  inline const Point &GetTexture() const;
  inline VOID SetTexture(const Point &pt);
  inline const Vector &GetNormal() const;
  inline VOID SetNormal(const Vector &v);

  inline QEWedge *GetPrevLink();
  inline VOID SetPrevLink(QEWedge *pwe);
  inline QEWedge *GetNextLink();
  inline VOID SetNextLink(QEWedge *pwe);

//////////////////////////////////////////////////
// Class Variables
//
protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  Point m_ptTexture;
  Vector m_vNormal;

  // Listing in a QEMesh or on a Free List
  QEWedge *m_pweLink[2];
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline const Point &QEWedge::GetTexture() const
{
  return m_ptTexture;
}

inline VOID QEWedge::SetTexture(const Point &pt)
{
  m_ptTexture = pt;
}

inline const Vector &QEWedge::GetNormal() const
{
  return m_vNormal;
}

inline VOID QEWedge::SetNormal(const Vector &v)
{
  m_vNormal = v;
}

inline QEWedge *QEWedge::GetPrevLink()
{
  return m_pweLink[0];
}

inline VOID QEWedge::SetPrevLink(QEWedge *pwe)
{
  m_pweLink[0] = pwe;
}

inline QEWedge *QEWedge::GetNextLink()
{
  return m_pweLink[1];
}

inline VOID QEWedge::SetNextLink(QEWedge *pwe)
{
  m_pweLink[1] = pwe;
}

#endif // __QEWEDGE_H__





