#include "sif.h"

CHAR *gcppcSIFReservedWords[sifrwtSize] =
{
  "SIF_SFF",
  "units",
  "mm",
  "inches",
  "desired_accuracy",
  "constellation",
  "solid",
  "shell",
  "union",
  "intersection",
  "difference",
  "surface",
  "triangles",
  "t",
  "vertices",
  "v",
  "color",
  "rgb"
};

VOID WriteSIFIndent(FILE *fpOutputFile, UINT_32 uiIndentLevel)
{
  UINT_32 i;

  for ( i = 0; i < uiIndentLevel; i++ )
    {
      fprintf(fpOutputFile, "  ");
    }
}

VOID WriteSIFVertex(FILE *fpOutputFile, UINT_32 uiIndentLevel, const Point &pt)
{
  WriteSIFIndent(fpOutputFile, uiIndentLevel);

  fprintf(fpOutputFile, "(%s %f %f %f)\n", gcppcSIFReservedWords[sifrwtVertex], pt(X), pt(Y), pt(Z));
}

VOID WriteSIFTriangle(FILE *fpOutputFile, UINT_32 uiIndentLevel, UINT_32 uiID0, UINT_32 uiID1, UINT_32 uiID2)
{
  WriteSIFIndent(fpOutputFile, uiIndentLevel);

  fprintf(fpOutputFile, "(%s %ld %ld %ld)\n", gcppcSIFReservedWords[sifrwtTriangle], uiID0, uiID1, uiID2);
}

