#ifndef __SLIDE_H__
#define __SLIDE_H__

#include "genlib.h"

enum SLIDEReservedWordType 
{
  sliderwtSLF_INHERIT, 
  sliderwtTclInit, 
  sliderwtTclUpdate, 
  sliderwtTclTag, 
  sliderwtMergeEpsilon, 
  sliderwtRIBBegin, 
  sliderwtRIBEnd, 
  sliderwtGraphPosition,
  sliderwtGUIID,
  sliderwtRender, 
  sliderwtBlend,
  sliderwtEndRender, 
  sliderwtWindow, 
  sliderwtEndWindow, 
  sliderwtOrigin, 
  sliderwtWinSize, 
  sliderwtResize, 
  sliderwtAspectRatio, 
  sliderwtBackground, 
  sliderwtViewport, 
  sliderwtEndViewport, 
  sliderwtCamera, 
  sliderwtEndCamera, 
  sliderwtProjection, 
  sliderwtFrustum, 
  sliderwtLight, 
  sliderwtEndLight,
  sliderwtType, 
  sliderwtDeadDistance, 
  sliderwtFallOff, 
  sliderwtAngularFallOff, 
  sliderwtAreaLight, 
  sliderwtEndAreaLight, 
  sliderwtSamples, 
  sliderwtGroup, 
  sliderwtEndGroup, 
  sliderwtInstance, 
  sliderwtEndInstance,
  sliderwtSeam, 
  sliderwtEndSeam,
  sliderwtContour, 
  sliderwtEndContour, 
  sliderwtSegment, 
  sliderwtEndSegment, 
  sliderwtSide,
  sliderwtReverse,
  sliderwtCameraInstance, 
  sliderwtEndCameraInstance, 
  sliderwtLightInstance, 
  sliderwtEndLightInstance, 
  sliderwtTransform, 
  sliderwtEndTransform, 
  sliderwtTranslate, 
  sliderwtScale, 
  sliderwtRotate, 
  sliderwtLookAt, 
  sliderwtEndLookAt, 
  sliderwtEye, 
  sliderwtTarget, 
  sliderwtUp, 
//  sliderwtGeneral, 
  sliderwtObject, 
  sliderwtEndObject, 
  sliderwtFace, 
  sliderwtEndFace, 
  sliderwtPoint, 
  sliderwtEndPoint, 
  sliderwtControlPoint, 
  sliderwtEndControlPoint, 
  sliderwtSurface, 
  sliderwtEndSurface, 
  sliderwtColor, 
  sliderwtReflectivity, 
  sliderwtExponent, 
  sliderwtMetallic,
  sliderwtFog, 
  sliderwtEndFog, 
  sliderwtDensity, 
  sliderwtStart, 
  sliderwtEnd, 
  sliderwtID, 
  sliderwtStencil, 
  sliderwtShading, 
  sliderwtLOD, 
  sliderwtSolid, 
  sliderwtNormal, 
  sliderwtTexture, 

  sliderwtSphere,
  sliderwtEndSphere,
  sliderwtCylinder,
  sliderwtEndCylinder,
  sliderwtCone,
  sliderwtEndCone,
  sliderwtTorus,
  sliderwtEndTorus,
  sliderwtCyclide,
  sliderwtEndCyclide,
  sliderwtHeight,
  sliderwtWidth,
  sliderwtRadius,
  sliderwtMajorRadius,
  sliderwtMinorRadius,
  sliderwtZMin,
  sliderwtZMax,
  sliderwtPhiMin,
  sliderwtPhiMax,
  sliderwtThetaMin,
  sliderwtThetaMax,
  sliderwtZSlices,
  sliderwtPhiSlices,
  sliderwtThetaSlices,
  sliderwtStringLength,
  sliderwtDrawEllipse,
  sliderwtDrawHyperbola,

  sliderwtHeightfield,
  sliderwtEndHeightfield,
  sliderwtUMin,
  sliderwtUMax,
  sliderwtVMin,
  sliderwtVMax,
  sliderwtFunc,

  sliderwtBSplinePatch,
  sliderwtEndBSplinePatch,
  sliderwtNurbPatch,
  sliderwtEndNurbPatch,
  sliderwtBezierPatch,
  sliderwtEndBezierPatch,
  sliderwtUOrder,
  sliderwtUKnots,
  sliderwtUKnotList,
  sliderwtVOrder,
  sliderwtVKnots,
  sliderwtVKnotList,
  sliderwtControlPointList,
  sliderwtUSlices,
  sliderwtVSlices,
  sliderwtDrawControls,

  sliderwtBSplineCurve,
  sliderwtEndBSplineCurve,
  sliderwtBezierCurve,
  sliderwtEndBezierCurve,
  sliderwtOrder,
  sliderwtKnots,
  sliderwtKnotList,
  sliderwtSlices,
  sliderwtMinimizeTorsion,
  sliderwtClosed,
  sliderwtAzimuth,
  sliderwtTwist,

  sliderwtPolyline,
  sliderwtEndPolyline,
  sliderwtPointList,
  sliderwtDrawPoints,

  sliderwtSweepMorph,
  sliderwtEndSweepMorph,
  sliderwtSweep,
  sliderwtEndSweep,
  sliderwtPath,
  sliderwtEndPath,
  sliderwtCrossSection,
  sliderwtEndCrossSection,
  sliderwtDrawPath,
  sliderwtDrawSweep,
  sliderwtCircle,
  sliderwtCresent,
  sliderwtStar,
  sliderwtMeshType,

  sliderwtThickness,
  sliderwtTheta,
  sliderwtInnerRadius,
  sliderwtOuterRadius,
  sliderwtSymmetry,
  sliderwtOrientation,
  sliderwtEndCap,
  sliderwtBeginCap,

  sliderwtMesh,
  sliderwtEndMesh,
  sliderwtMeshVertex,
  sliderwtEndMeshVertex,
  sliderwtMeshFacet,
  sliderwtEndMeshFacet,
  sliderwtMeshEdge,
  sliderwtEndMeshEdge,
  sliderwtMeshEdgeProperty,
  sliderwtEndMeshEdgeProperty,
  sliderwtMeshVertexProperty,
  sliderwtEndMeshVertexProperty,
  sliderwtSharpness,

  sliderwtConvexHull,
  sliderwtEndConvexHull,
  sliderwtGeneralFace,
  sliderwtEndGeneralFace,
  sliderwtCleanUpContour,
  sliderwtMillingContour,
  sliderwtOffsets,
  sliderwtOffsetMin,
  sliderwtOffsetMax,
  sliderwtIndividualVoronoiMin,
  sliderwtIndividualVoronoiMax,
  sliderwtTerrain,
  sliderwtEndTerrain,
  sliderwtVoronoi,
  sliderwtAccuracy,
  sliderwtRandom,
  sliderwtDrawDelaunay,
  sliderwtDrawVertices,
  sliderwtDrawContours,
  sliderwtDrawCDT,
  sliderwtDrawIndividualVoronoi,
  sliderwtDrawVoronoi,
  sliderwtDrawHeight,
  sliderwtDrawOffset,
  sliderwtDrawMillingContour,
  sliderwtSubdivision,
  sliderwtEndSubdivision,
  sliderwtDrawCurrent,
  sliderwtTolerance,
  sliderwtFacetsMax,
  sliderwtOffset, 
  sliderwtEndOffset, 
  sliderwtDual, 
  sliderwtEndDual, 
  sliderwtEvolver, 
  sliderwtEndEvolver, 
  sliderwtMirror, 
  sliderwtEndMirror, 
  sliderwtGeodesic, 
  sliderwtEndGeodesic, 

  sliderwtUnion,
  sliderwtEndUnion,
  sliderwtIntersection,
  sliderwtEndIntersection,
  sliderwtDifference,
  sliderwtEndDifference,

  sliderwtSGRoot,
  sliderwtEndSGRoot,

  sliderwtCameraUI,
  sliderwtCameraUISpeed,

  sliderwtWormwarp,
  sliderwtPathOnOff,
  sliderwtEndWormwarp,
  sliderwtSize
};

extern CHAR *gcppcSLIDEReservedWords[sliderwtSize];

enum SLIDETextureType
{
  slidetexturetSLF_ENVMAP,
  slidetexturetSLF_TEXMAP,
  slidetexturetSize
};

extern CHAR *gcppcSLIDETextureReservedWords[slidetexturetSize];

enum SLIDEOnOffType 
{
  slideoftSLF_OFF, 
  slideoftSLF_ON, 
  slideoftSize
};

extern CHAR *gcppcSLIDEOnOffReservedWords[slideoftSize];

enum SLIDESolidType 
{
  slidestSLF_SOLID, 
  slidestSLF_HOLLOW, 
  slidestSize
};

extern CHAR *gcppcSLIDESolidReservedWords[slidestSize];

enum SLIDEShadingType 
{
  slideshtSLF_INHERIT, 
  slideshtSLF_WIRE, 
  slideshtSLF_FLAT, 
  slideshtSLF_GOURAUD, 
  slideshtSLF_PHONG, 
  slideshtSize
};

extern CHAR *gcppcSLIDEShadingReservedWords[slideshtSize];

enum SLIDELODType 
{
  slidelodtSLF_OFF, 
  slidelodtSLF_BOUND, 
  slidelodtSLF_EDGES, 
  slidelodtSLF_FULL, 
  slidelodtSize
};

extern CHAR *gcppcSLIDELODReservedWords[slidelodtSize];

enum SLIDEProjectionType 
{
  slidepjtSLF_PARALLEL, 
  slidepjtSLF_PERSPECTIVE, 
  slidepjtSize
};

extern CHAR *gcppcSLIDEProjectionReservedWords[slidepjtSize];

enum SLIDELightType 
{
  slideltSLF_AMBIENT, 
  slideltSLF_DIRECTIONAL, 
  slideltSLF_POINT, 
  slideltSLF_SPOT, 
  slideltSize
};

extern CHAR *gcppcSLIDELightReservedWords[slideltSize];

enum SLIDEFogType 
{
  slidefogtSLF_LINEAR, 
  slidefogtSLF_EXP, 
  slidefogtSLF_EXP2, 
  slidefogtSize
};

extern CHAR *gcppcSLIDEFogReservedWords[slidefogtSize];

enum SLIDEStencilType 
{
  slidesttSLF_BOTH, 
  slidesttSLF_ODD, 
  slidesttSLF_EVEN, 
  slidesttSize
};

extern CHAR *gcppcSLIDEStencilReservedWords[slidesttSize];

enum SLIDEAspectRatioType 
{
  slideartSLF_FIXED, 
  slideartSLF_ANY, 
  slideartSLF_FULL_SCREEN, 
  slideartSize
};

extern CHAR *gcppcSLIDEAspectRatioReservedWords[slideartSize];

enum SLIDECameraUserInterfaceType
{
  slidecuitSLF_RESET_CUI,
  slidecuitSLF_PAUSE_CUI,
  slidecuitSLF_CAD_CUI,
  slidecuitSLF_FLY_CUI,
  slidecuitSLF_EXPLORE_CUI,
  slidecuitSize
};

extern CHAR *gcppcSLIDECameraUserInterfaceReservedWords[slidecuitSize];

/*
* CB Indicates World Centered (Crystal Ball)
* CAM Indicates Camera Centered
*/
enum SLIDEMouseUserInterfaceType
{
  slidemuitSLF_NO_MUI,
  slidemuitSLF_CB_GENERAL_ROTATION,
  slidemuitSLF_CB_SCALE,
  slidemuitSLF_CB_Z_ROTATION,
  slidemuitSLF_CAM_Z_TRANSLATE,
  slidemuitSLF_CAM_PAN,
  slidemuitSLF_CAM_GENERAL_ROTATION,
  slidemuitSLF_CAM_INTEGRAL,
  slidemuitSize
};

extern CHAR *gcppcSLIDEMouseUserInterfaceReservedWords[slidemuitSize];

enum SLIDESubdivisionType 
{
  slidesubtSLF_SUBDIVISION_DOO_SABIN, 
  slidesubtSLF_SUBDIVISION_DOO_SABIN_SELECTIVE, 
  slidesubtSLF_SUBDIVISION_DOO_SABIN_SELECTIVE_LIMIT, 
  slidesubtSLF_SUBDIVISION_CATMULL_CLARK, 
  slidesubtSLF_SUBDIVISION_SHARP_CATMULL_CLARK, 
  slidesubtSLF_SUBDIVISION_CATMULL_CLARK_TESSELATE, 
  slidesubtSLF_SUBDIVISION_CATMULL_CLARK_INTERPOLATE, 
  slidesubtSLF_SUBDIVISION_CATMULL_CLARK_C2, 
  slidesubtSLF_SUBDIVISION_CATMULL_CLARK_SELECTIVE, 
  slidesubtSLF_SUBDIVISION_CATMULL_CLARK_OLD, 
  slidesubtSLF_SUBDIVISION_CORNER_CUTTING, 
  slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_TESSELATE, 
  slidesubtSLF_SUBDIVISION_CORNER_ROUNDING, 
  slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_LOOP, 
  slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_SHARP_LOOP, 
  slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_BUTTERFLY, 
  slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_ZORIN, 
  slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_SELECTIVE, 
  slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_SELECTIVE_LIMIT, 
  slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_SHARP_SELECTIVE_LIMIT, 
  slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_FACET_SHARP_SELECTIVE_LIMIT, 
  slidesubtSLF_SUBDIVISION_TRIANGLE_TESSELATE, 
  slidesubtSLF_SUBDIVISION_TRIANGLE_LOOP, 
  slidesubtSLF_SUBDIVISION_TRIANGLE_LOOP_EDGE_RULE, 
  slidesubtSLF_SUBDIVISION_TRIANGLE_BUTTERFLY, 
  slidesubtSLF_SUBDIVISION_TRIANGLE_ZORIN, 
  slidesubtSLF_SUBDIVISION_TRIANGLE_SPHERE, 
  slidesubtSLF_SUBDIVISION_SQRT_3, 
  slidesubtSLF_SUBDIVISION_SQRT_3_SPHERE_BARYCENTER, 
  slidesubtSLF_SUBDIVISION_SQRT_3_SPHERE_CENTER, 
  slidesubtSLF_SUBDIVISION_SQRT_3_SPHERE_RADIUS, 
  slidesubtSLF_SUBDIVISION_SQRT_3_SPHERE_CAP_AREA, 
  slidesubtSLF_SUBDIVISION_SQRT_3_SPHERE_TRIANGLE_AREA, 
  slidesubtSLF_SUBDIVISION_SQRT_3_SPHERE_TANGENT, 
  slidesubtSLF_SUBDIVISION_SQRT_3_SELECTIVE, 
  slidesubtSLF_SUBDIVISION_SQRT_3_SELECTIVE_FACET, 
  slidesubtSLF_SUBDIVISION_SQRT_4, 
  slidesubtSLF_SUBDIVISION_SQRT_4_SELECTIVE, 
  slidesubtSLF_SUBDIVISION_PROGRESSIVE, 
  slidesubtSLF_SUBDIVISION_HETEROGENEOUS, 
  slidesubtSLF_SUBDIVISION_HETEROGENEOUS_STAM_LOOP, 
  slidesubtSLF_SUBDIVISION_HETEROGENEOUS_OLD, 
  slidesubtSLF_SUBDIVISION_HETEROGENEOUS_TESSELATE, 
  slidesubtSLF_SUBDIVISION_PENTAGON, 
  slidesubtSLF_SUBDIVISION_PENTAGON_TESSELATE, 
  slidesubtSLF_SUBDIVISION_GEOMETRIC, 
  slidesubtSLF_SUBDIVISION_GEOMETRIC_TESSELATE, 
  slidesubtSize
};

extern CHAR *gcppcSLIDESubdivisionReservedWords[slidesubtSize];

enum SLIDEErrorMetricType 
{
  slideemtSLF_ERROR_METRIC_BEST_FIT_PLANE, 
  slideemtSLF_ERROR_METRIC_LIMIT_DISTANCE, 
  slideemtSize
};

extern CHAR *gcppcSLIDEErrorMetricReservedWords[slideemtSize];

enum SLIDEVertexType 
{
  slidevxtSLF_VERTEX_SMOOTH, 
  slidevxtSLF_VERTEX_CORNER, 
  slidevxtSize, 
};

extern CHAR *gcppcSLIDEVertexReservedWords[slidevxtSize];

enum SLIDEOffsetType 
{
  slideofftSLF_OFFSET_ANGULAR, 
  slideofftSLF_OFFSET_ROUNDED, 
  slideofftSLF_OFFSET_PERFORATED, 
  slideofftSize
};

extern CHAR *gcppcSLIDEOffsetReservedWords[slideofftSize];

enum SLIDETerrainType 
{
  slidetertSLF_TERRAIN_DELAUNAY_INCREMENTAL, 
  slidetertSLF_TERRAIN_DELAUNAY_INCREMENTAL_SLOW, 
  slidetertSLF_TERRAIN_DELAUNAY_INCREMENTAL_NO_BOUND, 
  slidetertSLF_TERRAIN_DELAUNAY_DIVIDE_AND_CONQUER, 
  slidetertSLF_TERRAIN_DELAUNAY_DIVIDE_AND_CONQUER_ALTERNATING, 
  slidetertSLF_TERRAIN_DELAUNAY_CONVEX_HULL, 
  slidetertSize
};

extern CHAR *gcppcSLIDETerrainReservedWords[slidetertSize];

enum SLIDEVoronoiType 
{
  slidevtSLF_VORONOI_OFF, 
  slidevtSLF_VORONOI_DELAUNAY, 
  slidevtSLF_VORONOI_DIVIDE_AND_CONQUER, 
  slidevtSLF_VORONOI_DIVIDE_AND_CONQUER_ALTERNATING, 
  slidevtSLF_VORONOI_CONES, 
  slidevtSLF_VORONOI_PLANES, 
  slidevtSize
};

extern CHAR *gcppcSLIDEVoronoiReservedWords[slidevtSize];

enum SLIDEAccuracyType 
{
  slideatSLF_FLOAT_NAIVE, 
  slideatSLF_FLOAT, 
  slideatSLF_EXACT,
  slideatSize
};

extern CHAR *gcppcSLIDEAccuracyReservedWords[slideatSize];

enum SLIDEWormwarpType
{
  slidewtSLF_BEAD,
  slidewtSLF_AXIS,
  slidewtSLF_BERNSTEIN,
  slidewtSize
};

extern CHAR *gcppcSLIDEWormwarpReservedWords[slidewtSize];

enum SLIDEMeshType
{
  slidemtSLF_TRIANGLES,
  slidemtSLF_QUADRILATERALS,
  slidemtSize
};

extern CHAR *gcppcSLIDEMeshTypeReservedWords[slidemtSize];


/////////////////////////////////////////////////////////////////////////////
// GUI - Jane

extern CHAR *gcppcSLIDEGUISolidReservedWords[slidestSize];
extern CHAR *gcppcSLIDEGUIShadingReservedWords[slideshtSize];
extern CHAR *gcppcSLIDEGUILODReservedWords[slidelodtSize];

#endif // __SLIDE_H__

