%{
    // Parser assignment template grammar file for Bison
#define __GRAM_TAB_H__
#include "slideparser.h"
%}

%{
	// Semantic Stack Definition
%}
%union {
  CHAR c;
  INT_32 i;
  UINT_32 ui;
  FLOAT f;
  CHAR *str;
  CListInt *pCListInt;
  DynInt *dyni;
  DynFloat *dynf;
  DynVector *dynv;
  DynPoint *dynpt;
}

%{
#define yylloc slide_lloc
#define yyerror slide_error
void slide_error(char* s);

#define yylex slide_lex
extern int slide_lex();

extern YYLTYPE slide_lloc;
extern int yyparse(void);
extern CScanner *slide_gpCScanner;

extern int slide_leng;
extern VOID slide_BeginInitial();
extern YY_BUFFER_STATE slide_GetCurrentBuffer();
extern YY_BUFFER_STATE slide_CreateBuffer(FILE *fpFile);
extern VOID slide_DeleteBuffer(YY_BUFFER_STATE yyBufferState);
extern VOID slide_SwitchToBuffer(YY_BUFFER_STATE yyBufferState);
extern VOID slide_SetValueInt(int i);
extern VOID slide_SetValueFloat(FLOAT f);
extern VOID slide_SetValueString(CHAR *pc);

CSLIDEParser *slide_gpCSLIDEParser = NULL;

%}

%{
	// Reserved Word Definitions
%}

%token rwTCL_INIT rwTCL_UPDATE rwTCL_TAG rwMERGE_EPSILON
%token rwRIB_BEGIN rwRIB_END rwGRAPH_POSITION
%token rwWINDOW rwEND_WINDOW rwVIEWPORT rwEND_VIEWPORT
%token rwORIGIN rwSIZE rwBACKGROUND rwRESIZE 
%token rwASPECT_RATIO rwSLF_FIXED rwSLF_ANY rwSLF_FULL_SCREEN
%token rwDISPLAY
%token rwCAMERA rwEND_CAMERA
%token rwPROJECTION rwFRUSTUM
%token rwLIGHT rwEND_LIGHT rwTYPE rwDEAD_DISTANCE rwFALL_OFF rwANGULAR_FALL_OFF
%token rwSLF_AMBIENT rwSLF_DIRECTIONAL rwSLF_POINT rwSLF_SPOT
%token rwRENDER rwEND_RENDER
%token rwAREA_LIGHT rwEND_AREA_LIGHT rwSAMPLES
%token rwGROUP rwEND_GROUP rwINSTANCE rwEND_INSTANCE
%token rwSEAM rwEND_SEAM rwCONTOUR rwEND_CONTOUR rwSIDE rwSEGMENT rwEND_SEGMENT rwREVERSE
%token rwTRANSFORM rwEND_TRANSFORM
%token rwTRANSLATE rwSCALE rwROTATE rwLOOK_AT rwEND_LOOK_AT rwEYE rwTARGET rwUP
%{
//%token rwGENERAL
%}
%token rwOBJECT rwEND_OBJECT rwFACE rwEND_FACE rwPOINT rwEND_POINT
%token rwCONTROLPOINT rwEND_CONTROLPOINT 
%token rwSURFACE rwEND_SURFACE 
%token rwCOLOR rwREFLECTIVITY rwEXPONENT rwMETALLIC
%token rwFOG rwEND_FOG 
%token rwDENSITY rwSTART rwEND rwSLF_LINEAR rwSLF_EXP rwSLF_EXP2
%token rwSLF_INHERIT rwID
%token rwSLF_OFF rwSLF_ON
%token rwSOLID rwSLF_SOLID rwSLF_HOLLOW 
%token rwSHADING rwSLF_WIRE rwSLF_FLAT rwSLF_GOURAUD rwSLF_PHONG
%token rwLOD rwSLF_BOUND rwSLF_EDGES rwSLF_FULL
%token rwSTENCIL rwSLF_BOTH rwSLF_ODD rwSLF_EVEN
%token rwSLF_PARALLEL rwSLF_PERSPECTIVE
%token rwBITMAP rwSLF_ENVMAP rwSLF_TEXMAP
%token rwNORMAL rwTEXTURE

%token rwMESH rwEND_MESH
%token rwVERTEX rwEND_VERTEX
%token rwFACET rwEND_FACET
%token rwEDGE rwEND_EDGE
%token rwEDGE_PROPERTY rwEND_EDGE_PROPERTY
%token rwSHARPNESS rwSLF_INFINITY
%token rwVERTEX_PROPERTY rwEND_VERTEX_PROPERTY
%token rwSLF_VERTEX_SMOOTH rwSLF_VERTEX_CORNER

%token rwCONVEX_HULL rwEND_CONVEX_HULL
%token rwGENERAL_FACE rwEND_GENERAL_FACE
%token rwCLEAN_UP_CONTOUR
%token rwMILLING_CONTOUR
%token rwOFFSETS rwOFFSET_MIN rwOFFSET_MAX
%token rwINDIVIDUAL_VORONOI_MIN rwINDIVIDUAL_VORONOI_MAX
%token rwTERRAIN rwEND_TERRAIN
%token rwVORONOI rwACCURACY rwRANDOM
%token rwDRAW_DELAUNAY rwDRAW_VERTICES
%token rwDRAW_CONTOURS rwDRAW_CDT rwDRAW_INDIVIDUAL_VORONOI rwDRAW_VORONOI rwDRAW_HEIGHT
%token rwDRAW_OFFSET rwDRAW_MILLING_CONTOUR
%token rwSLF_TERRAIN_DELAUNAY_INCREMENTAL
%token rwSLF_TERRAIN_DELAUNAY_INCREMENTAL_SLOW
%token rwSLF_TERRAIN_DELAUNAY_INCREMENTAL_NO_BOUND
%token rwSLF_TERRAIN_DELAUNAY_DIVIDE_AND_CONQUER
%token rwSLF_TERRAIN_DELAUNAY_DIVIDE_AND_CONQUER_ALTERNATING
%token rwSLF_TERRAIN_DELAUNAY_CONVEX_HULL
%token rwSLF_VORONOI_OFF
%token rwSLF_VORONOI_DELAUNAY
%token rwSLF_VORONOI_DIVIDE_AND_CONQUER
%token rwSLF_VORONOI_DIVIDE_AND_CONQUER_ALTERNATING
%token rwSLF_VORONOI_CONES
%token rwSLF_VORONOI_PLANES
%token rwSLF_FLOAT_NAIVE
%token rwSLF_FLOAT
%token rwSLF_EXACT

%token rwSPHERE rwEND_SPHERE rwCYLINDER rwEND_CYLINDER 
%token rwCONE rwEND_CONE rwTORUS rwEND_TORUS rwCYCLIDE rwEND_CYCLIDE
%token rwHEIGHTFIELD rwEND_HEIGHTFIELD
%token rwU_MIN rwU_MAX rwV_MIN rwV_MAX rwHEIGHTFIELD_FUNC
%token rwBSPLINEPATCH rwEND_BSPLINEPATCH rwBEZIERPATCH rwEND_BEZIERPATCH 
%token rwNURBPATCH rwEND_NURBPATCH
%token rwU_ORDER rwU_KNOTS rwU_KNOT_LIST rwV_ORDER rwV_KNOTS rwV_KNOT_LIST 
%token rwCONTROL_POINT_LIST rwU_SLICES rwV_SLICES rwDRAW_CONTROLS

%token rwBSPLINECURVE rwEND_BSPLINECURVE rwBEZIERCURVE rwEND_BEZIERCURVE
%token rwORDER rwKNOTS rwKNOT_LIST rwSLICES
%token rwPOLYLINE rwEND_POLYLINE rwDRAW_POINTS

%token rwSWEEP_MORPH rwEND_SWEEP_MORPH
%token rwSWEEP rwEND_SWEEP rwPATH rwEND_PATH rwCROSS_SECTION rwEND_CROSS_SECTION 
%token rwMINIMIZE_TORSION rwCLOSED rwPOINT_LIST rwDRAW_PATH rwDRAW_SWEEP 
%token rwAZIMUTH rwTWIST 
%token rwCIRCLE rwCRESENT rwSTAR
%token rwMESH_TYPE rwSLF_TRIANGLES rwSLF_QUADRILATERALS
%token rwTHICKNESS rwTHETA rwINNER_RADIUS rwOUTER_RADIUS rwSYMMETRY rwORIENTATION
%token rwEND_CAP rwBEGIN_CAP

%token rwHEIGHT rwWIDTH rwRADIUS rwMAJOR_RADIUS rwMINOR_RADIUS 
%token rwZ_MIN rwZ_MAX rwPHI_MIN rwPHI_MAX rwTHETA_MIN rwTHETA_MAX
%token rwZ_SLICES rwPHI_SLICES rwTHETA_SLICES
%token rwSTRING_LENGTH rwDRAW_ELLIPSE rwDRAW_HYPERBOLA

%token rwSUBDIVISION rwEND_SUBDIVISION
%token rwSUBDIVISIONS
%token rwUSE_DISPLAY_LISTS
%token rwDRAW_CURRENT
%token rwERROR_METRIC
%token rwTOLERANCE
%token rwFACETS_MAX
%token rwSLF_SUBDIVISION_DOO_SABIN
%token rwSLF_SUBDIVISION_DOO_SABIN_SELECTIVE
%token rwSLF_SUBDIVISION_DOO_SABIN_SELECTIVE_LIMIT
%token rwSLF_SUBDIVISION_CATMULL_CLARK
%token rwSLF_SUBDIVISION_CATMULL_CLARK_TESSELATE
%token rwSLF_SUBDIVISION_CATMULL_CLARK_INTERPOLATE
%token rwSLF_SUBDIVISION_CATMULL_CLARK_C2
%token rwSLF_SUBDIVISION_CATMULL_CLARK_SELECTIVE
%token rwSLF_SUBDIVISION_CATMULL_CLARK_OLD
%token rwSLF_SUBDIVISION_CORNER_CUTTING
%token rwSLF_SUBDIVISION_CORNER_ROUNDING_TESSELATE
%token rwSLF_SUBDIVISION_CORNER_ROUNDING
%token rwSLF_SUBDIVISION_CORNER_ROUNDING_LOOP
%token rwSLF_SUBDIVISION_CORNER_ROUNDING_SHARP_LOOP
%token rwSLF_SUBDIVISION_CORNER_ROUNDING_BUTTERFLY
%token rwSLF_SUBDIVISION_CORNER_ROUNDING_ZORIN
%token rwSLF_SUBDIVISION_CORNER_ROUNDING_SELECTIVE
%token rwSLF_SUBDIVISION_CORNER_ROUNDING_SELECTIVE_LIMIT
%token rwSLF_SUBDIVISION_CORNER_ROUNDING_SHARP_SELECTIVE_LIMIT
%token rwSLF_SUBDIVISION_CORNER_ROUNDING_FACET_SHARP_SELECTIVE_LIMIT
%token rwSLF_SUBDIVISION_TRIANGLE_TESSELATE
%token rwSLF_SUBDIVISION_TRIANGLE_LOOP
%token rwSLF_SUBDIVISION_TRIANGLE_LOOP_EDGE_RULE
%token rwSLF_SUBDIVISION_TRIANGLE_BUTTERFLY
%token rwSLF_SUBDIVISION_TRIANGLE_ZORIN
%token rwSLF_SUBDIVISION_TRIANGLE_SPHERE
%token rwSLF_SUBDIVISION_SQRT_3
%token rwSLF_SUBDIVISION_SQRT_3_SPHERE_BARYCENTER
%token rwSLF_SUBDIVISION_SQRT_3_SPHERE_CENTER
%token rwSLF_SUBDIVISION_SQRT_3_SPHERE_RADIUS
%token rwSLF_SUBDIVISION_SQRT_3_SPHERE_CAP_AREA
%token rwSLF_SUBDIVISION_SQRT_3_SPHERE_TRIANGLE_AREA
%token rwSLF_SUBDIVISION_SQRT_3_SPHERE_TANGENT
%token rwSLF_SUBDIVISION_SQRT_3_SELECTIVE
%token rwSLF_SUBDIVISION_SQRT_3_SELECTIVE_FACET
%token rwSLF_SUBDIVISION_SQRT_4
%token rwSLF_SUBDIVISION_SQRT_4_SELECTIVE
%token rwSLF_SUBDIVISION_PROGRESSIVE
%token rwSLF_SUBDIVISION_HETEROGENEOUS
%token rwSLF_SUBDIVISION_HETEROGENEOUS_STAM_LOOP
%token rwSLF_SUBDIVISION_HETEROGENEOUS_OLD
%token rwSLF_SUBDIVISION_HETEROGENEOUS_TESSELATE
%token rwSLF_SUBDIVISION_PENTAGON
%token rwSLF_SUBDIVISION_PENTAGON_TESSELATE
%token rwSLF_SUBDIVISION_GEOMETRIC
%token rwSLF_SUBDIVISION_GEOMETRIC_TESSELATE

%token rwSLF_ERROR_METRIC_BEST_FIT_PLANE
%token rwSLF_ERROR_METRIC_LIMIT_DISTANCE

%token rwOFFSET rwEND_OFFSET
%token rwSLF_OFFSET_ANGULAR rwSLF_OFFSET_ROUNDED rwSLF_OFFSET_PERFORATED

%token rwDUAL rwEND_DUAL
%token rwEVOLVER rwEND_EVOLVER
%token rwMIRROR rwEND_MIRROR

%token rwGEODESIC rwEND_GEODESIC

%token rwUNION rwEND_UNION
%token rwINTERSECTION rwEND_INTERSECTION
%token rwDIFFERENCE rwEND_DIFFERENCE
%token rwSGROOT rwEND_SGROOT

%token rwCAMERAUI
%token rwSLF_RESET_CUI rwSLF_PAUSE_CUI
%token rwSLF_CAD_CUI
%token rwSLF_FLY_CUI rwSLF_EXPLORE_CUI
%token rwCAMERAUISPEED

%token rwWORMWARP rwPATHONOFF rwEND_WORMWARP

%{
	// Operator Definitions
%}

%token '(' ')'

%{
	// Constants and Identifier Definitions
%}

%token <c> tokCONST_CHAR
%token <i> tokCONST_INT
%token <f> tokCONST_FLOAT
%token <str> tokCONST_STRING
%token <str> tokIDENTIFIER
%token <str> tokTCL_BLOCK
%token <str> tokTCL_MACRO_BLOCK


%type <dyni> dyn_onoff_flag
%type <i> onoff_flag
%type <dyni> dyn_solid_flag
%type <i> solid_flag
%type <dyni> dyn_shading_flag
%type <i> shading_flag
%type <dyni> dyn_lod_flag
%type <i> lod_flag
%type <dyni> dyn_texture_flag
%type <i> texture_flag
%type <dyni> dyn_stencil_flag
%type <i> stencil_flag
%type <dyni> dyn_projection_flag
%type <i> projection_flag
%type <dyni> dyn_lighttype_flag
%type <i> lighttype_flag
%type <dyni> dyn_fogtype_flag
%type <i> fogtype_flag
%type <i> aspect_ratio_flag
%type <dyni> dyn_cui_flag
%type <i> cui_flag
%type <dyni> dyn_subdivisiontype_flag
%type <i> subdivisiontype_flag
%type <dyni> dyn_errormetric_flag
%type <i> errormetric_flag
%type <dyni> dyn_offsettype_flag
%type <i> offsettype_flag
%type <dyni> dyn_terraintype_flag
%type <i> terraintype_flag
%type <dyni> dyn_voronoitype_flag
%type <i> voronoitype_flag
%type <dyni> dyn_accuracy_flag
%type <i> accuracy_flag
%type <dyni> dyn_vertextype_flag
%type <i> vertextype_flag
%type <dyni> dyn_meshtype_flag
%type <i> meshtype_flag
%type <str> surface_id
%type <pCListInt> id_list
%type <pCListInt> dynvalue_list
%type <pCListInt> path
%type <f> value
%type <dyni> dynint
%type <dynf> dynvalue
%type <dynv> dynvector
%type <dynv> dynvector2d
%type <dynv> dynvector3d
%type <dynpt> dynpoint
%type <str> display_id

%%

world
	: geometry_list
		{ 
		}

geometry_list
	:
		{
		}
	| geometry_list rwTCL_INIT tokTCL_BLOCK
		{
		  slide_gpCSLIDEParser->AddGlobalInitTclBlock($3); 
		}
	| geometry_list rwTCL_UPDATE tokTCL_BLOCK
		{
		  slide_gpCSLIDEParser->AddGlobalUpdateTclBlock($3); 
		}
	| geometry_list render
		{
		}
	| geometry_list window
		{
		}
	| geometry_list viewport
		{
		}
	| geometry_list camera
		{
		}
	| geometry_list light
		{
		}
	| geometry_list group
		{
		}
	| geometry_list seam
		{
		}
	| geometry_list contour
		{
		}
	| geometry_list arealight
		{
		}
	| geometry_list subdivision
		{
		}
	| geometry_list offset
		{
		}
	| geometry_list dual
		{
		}
	| geometry_list evolver
		{
		}
	| geometry_list mirror
		{
		}
	| geometry_list geodesic
		{
		}
	| geometry_list union
		{
		}
	| geometry_list intersection
		{
		}
	| geometry_list difference
		{
		}
	| geometry_list sgroot
		{
		}
	| geometry_list instance
		{
		}
	| geometry_list object
		{
		}
	| geometry_list mesh
		{
		}
	| geometry_list convex_hull
		{
		}
	| geometry_list general_face
		{
		}
	| geometry_list terrain
		{
		}
	| geometry_list sphere
		{
		}
	| geometry_list cylinder
		{
		}
	| geometry_list cone
		{
		}
	| geometry_list torus
		{
		}
        | geometry_list cyclide
		{
		}
        | geometry_list bsplinepatch
		{
		}
        | geometry_list heightfield
                {
                }
        | geometry_list bezierpatch
		{
		}
        | geometry_list nurbpatch
		{
		}
        | geometry_list bsplinecurve
		{
		}
        | geometry_list beziercurve
		{
		}
        | geometry_list polyline
		{
		}
        | geometry_list sweep
		{
		}
        | geometry_list sweepmorph
		{
		}
	| geometry_list crosssection
		{
		}
	| geometry_list face
		{
		}
	| geometry_list point
		{
		}
	| geometry_list controlpoint
		{
		}
	| geometry_list surface
		{
		}
	| geometry_list fog
		{
		}
        | geometry_list wormwarp
                {
                }
	;

window
	: window_start window_middle rwEND_WINDOW
		{
		  slide_gpCSLIDEParser->EndWindow();
		}
	;

window_start
	: rwWINDOW tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddWindow(@1.text, @1.first_line, 
						   @1.first_column, $2);
		}
	;

window_middle
	: 
		{
		}
	| window_middle rwORIGIN '(' value value ')'
		{
		  slide_gpCSLIDEParser->SetWindowOrigin($4, $5);
		}
	| window_middle rwSIZE '(' value value ')'
		{
		  slide_gpCSLIDEParser->SetWindowSize($4, $5);
		}
	| window_middle rwRESIZE onoff_flag
		{
		  slide_gpCSLIDEParser->SetWindowResize($3);
		}
	| window_middle rwASPECT_RATIO aspect_ratio_flag 
		{
		  slide_gpCSLIDEParser->SetWindowAspectRatio($3);
		}
	| window_middle rwBACKGROUND dynvector
		{
		  slide_gpCSLIDEParser->SetWindowBackground($3);
		}
	| window_middle rwDISPLAY display_id
		{
		  slide_gpCSLIDEParser->SetWindowDisplay($3);
		}
	;

display_id
	: tokCONST_STRING
		{
		  $$ = $1;
		}
	;


viewport
	: viewport_start viewport_middle rwEND_VIEWPORT
		{
		  slide_gpCSLIDEParser->EndViewport();
		}
	;

viewport_start
	: rwVIEWPORT tokIDENTIFIER tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddViewport(@1.text, 
						    @1.first_line, 
						    @1.first_column, 
						    $2, $3);
		}
	;

viewport_middle
	: 
		{
		}
	| viewport_middle primitive_flag
		{
		}
	| viewport_middle rwORIGIN dynvector2d
		{
		  slide_gpCSLIDEParser->SetViewportOrigin($3);
		}
	| viewport_middle rwSIZE dynvector2d
		{
		  slide_gpCSLIDEParser->SetViewportSize($3);
		}
	;

camera
	: camera_start camera_middle rwEND_CAMERA
		{
		  slide_gpCSLIDEParser->EndCamera();
		}
	;

camera_start
	: rwCAMERA tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddCamera(@1.text, @1.first_line,
						  @1.first_column, $2);
		}
	;

camera_middle
	: 
		{
		}
	| camera_middle primitive_flag
		{
		}
	| camera_middle rwPROJECTION dyn_projection_flag
		{
		  slide_gpCSLIDEParser->SetCameraProjection($3);
		}
	| camera_middle rwFRUSTUM dynvector dynvector
		{
		  slide_gpCSLIDEParser->SetCameraFrustum($3, $4);
		}
	;

light
	: light_start light_middle rwEND_LIGHT
		{
		  slide_gpCSLIDEParser->EndLight();
		}
	;

light_start
	: rwLIGHT tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddLight(@1.text, @1.first_line,
						  @1.first_column, $2);
		}
	;

light_middle
	: 
		{
		}
	| light_middle primitive_flag
		{
		}
	| light_middle rwTYPE dyn_lighttype_flag
		{
		  slide_gpCSLIDEParser->SetLightType($3);
		}       
	| light_middle rwCOLOR dynvector
		{
		  slide_gpCSLIDEParser->SetLightColor($3);
		}
	| light_middle rwDEAD_DISTANCE dynvalue
		{
		  slide_gpCSLIDEParser->SetLightDeadDistance($3);
		}
	| light_middle rwFALL_OFF dynvalue
		{
		  slide_gpCSLIDEParser->SetLightFallOff($3);
		}
	| light_middle rwANGULAR_FALL_OFF dynvalue
		{
		  slide_gpCSLIDEParser->SetLightAngularFallOff($3);
		}
	;

render
	: render_start render_middle rwEND_RENDER
		{
		  slide_gpCSLIDEParser->EndRender();
		}
	;

render_start
	: rwRENDER tokIDENTIFIER path tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddRender(@1.text, @1.first_line,
						  @1.first_column,
						  $2, $3, $4);
		}
	;

render_middle
	: 
		{
		}
	| render_middle rwMERGE_EPSILON dynvalue
		{
		  slide_gpCSLIDEParser->SetRenderMergeEpsilon($3);
		}
	| render_middle rwTCL_TAG tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->SetRenderTclTag($3);
		}
	| render_middle primitive_flag
		{
		}
	| render_middle rwLOD dyn_lod_flag
		{
		  slide_gpCSLIDEParser->SetRenderLOD($3);
		}
	| render_middle rwSTENCIL dyn_stencil_flag
		{
		  slide_gpCSLIDEParser->SetRenderStencil($3);
		}
	| render_middle rwFOG tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->SetRenderFogID($3, NULL);
		}
	| render_middle rwFOG tokIDENTIFIER dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetRenderFogID($3, $4);
		}
	| render_middle rwLIGHT path
		{
		  slide_gpCSLIDEParser->AddRenderLightPath(@2.text, @2.first_line,
							   @2.first_column, $3, 
							   NULL);
		}
	| render_middle rwLIGHT path dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->AddRenderLightPath(@2.text, @2.first_line,
							   @2.first_column, $3,
							   $4);
		}
	| render_middle rwAREA_LIGHT path
		{
		  slide_gpCSLIDEParser->AddRenderAreaLightPath(@2.text, @2.first_line,
							   @2.first_column, $3, 
							   NULL);
		}
	| render_middle rwAREA_LIGHT path dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->AddRenderAreaLightPath(@2.text, @2.first_line,
							   @2.first_column, $3,
							   $4);
		}
	| render_middle rwCAMERAUI dyn_cui_flag
		{
		  slide_gpCSLIDEParser->SetRenderCUIType($3);
		}
	| render_middle rwCAMERAUISPEED dynvalue
		{
		  slide_gpCSLIDEParser->SetRenderCUISpeed($3);
		}
	;

path
	: tokIDENTIFIER
		{
		  $$ = slide_gpCSLIDEParser->CreateIDList();
		  $$ = slide_gpCSLIDEParser->InsertIDList($$, $1);
		}
	| path '.' tokIDENTIFIER
		{
		  $$ = slide_gpCSLIDEParser->InsertIDList($1, $3);
		}
	;

group
	: group_start group_middle rwEND_GROUP
		{
		  slide_gpCSLIDEParser->EndGroup();
		}
	;

group_start
	: rwGROUP tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddGroup(@1.text, @1.first_line,
						 @1.first_column,
						 $2);
		}
	;

group_middle
	:
		{
		}
	| group_middle node_flag
		{
		}
	| group_middle instance
		{
		}
	;

arealight
	: arealight_start arealight_middle rwEND_AREA_LIGHT
		{
		  slide_gpCSLIDEParser->EndAreaLight();
		}
	;

arealight_start
	: rwAREA_LIGHT tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddAreaLight(@1.text, @1.first_line,
						 @1.first_column,
						 $2);
		}
	;

arealight_middle
	:
		{
		}
	| arealight_middle node_flag
		{
		}
	| arealight_middle instance
		{
		}
	| arealight_middle rwCOLOR dynvector
		{
		  slide_gpCSLIDEParser->SetAreaLightColor($3);
		}
	| arealight_middle rwSAMPLES dynint
		{
		  slide_gpCSLIDEParser->SetAreaLightSamples($3);
		}
	;

seam
	: seam_start seam_middle rwEND_SEAM
		{
		  slide_gpCSLIDEParser->EndSeam();
		}
	;

seam_start
	: rwSEAM tokIDENTIFIER tokIDENTIFIER tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddSeam(@1.text, @1.first_line, 
		                                @1.first_column, $2, $3, $4);
		}
	;

seam_middle
	:
		{
		}
	| seam_middle atom_node_flag
		{
		}
	;

contour
	: contour_start contour_middle rwEND_CONTOUR
		{
		  slide_gpCSLIDEParser->EndContour();
		}
	;

contour_start
	: rwCONTOUR tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddContour(@1.text, @1.first_line,
						   @1.first_column, $2);
		}
	;

contour_middle
	:
		{
		}
	| contour_middle segment
		{
		}
        | contour_middle atom_node_flag
		{
		}
	;

segment
	: rwSEGMENT tokIDENTIFIER rwSIDE dynint rwEND_SEGMENT
		{
		  slide_gpCSLIDEParser->AddContourSegment($2, $4, FALSE);
		}
	| rwSEGMENT tokIDENTIFIER rwSIDE dynint rwREVERSE rwEND_SEGMENT
		{
		  slide_gpCSLIDEParser->AddContourSegment($2, $4, TRUE);
		}
	;

subdivision
	: subdivision_start subdivision_middle rwEND_SUBDIVISION
		{
		  slide_gpCSLIDEParser->EndSubdivision();
		}
	;

subdivision_start
	: rwSUBDIVISION tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddSubdivision(@1.text, @1.first_line,
							@1.first_column,
							$2);
		}
	;

subdivision_middle
	:
		{
		}
	| subdivision_middle node_flag
		{
		}
	| subdivision_middle instance
		{
		}
	| subdivision_middle rwUSE_DISPLAY_LISTS dynint
		{
		  slide_gpCSLIDEParser->SetSubdivisionUseDisplayLists($3);
		}
	| subdivision_middle rwDRAW_CONTROLS dynint
		{
		  slide_gpCSLIDEParser->SetSubdivisionDrawControlMesh($3);
		}
	| subdivision_middle rwDRAW_CURRENT dynint
		{
		  slide_gpCSLIDEParser->SetSubdivisionDrawCurrentMesh($3);
		}
	| subdivision_middle rwDRAW_VERTICES dynint
		{
		  slide_gpCSLIDEParser->SetSubdivisionDrawVertices($3);
		}
	| subdivision_middle rwTYPE dyn_subdivisiontype_flag
		{
		  slide_gpCSLIDEParser->SetSubdivisionType($3);
		}
	| subdivision_middle rwERROR_METRIC dyn_errormetric_flag
		{
		  slide_gpCSLIDEParser->SetSubdivisionErrorMetric($3);
		}
	| subdivision_middle rwSUBDIVISIONS dynint
		{
		  slide_gpCSLIDEParser->SetSubdivisionSubdivisionLevel($3);
		}
	| subdivision_middle rwFACETS_MAX dynint
		{
		  slide_gpCSLIDEParser->SetSubdivisionFacetsMax($3);
		}
	| subdivision_middle rwU_KNOTS dynint
		{
		  slide_gpCSLIDEParser->SetSubdivisionWeightedEdges($3);
		}
	| subdivision_middle rwU_ORDER dynvalue
		{
		  slide_gpCSLIDEParser->SetSubdivisionWeight($3);
		}
	| subdivision_middle rwV_KNOTS dynint
		{
		  slide_gpCSLIDEParser->SetSubdivisionA($3);
		}
	| subdivision_middle rwV_ORDER dynint
		{
		  slide_gpCSLIDEParser->SetSubdivisionB($3);
		}
	| subdivision_middle rwTOLERANCE dynvalue
		{
		  slide_gpCSLIDEParser->SetSubdivisionTolerance($3);
		}
	;

offset
	: offset_start offset_middle rwEND_OFFSET
		{
		  slide_gpCSLIDEParser->EndOffset();
		}
	;

offset_start
	: rwOFFSET tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddOffset(@1.text, @1.first_line,
							@1.first_column,
							$2);
		}
	;

offset_middle
	:
		{
		}
	| offset_middle node_flag
		{
		}
	| offset_middle instance
		{
		}
	| offset_middle rwDRAW_CONTROLS dynint
		{
		  slide_gpCSLIDEParser->SetOffsetDrawControlMesh($3);
		}
	| offset_middle rwTYPE dyn_offsettype_flag
		{
		  slide_gpCSLIDEParser->SetOffsetType($3);
		}
	| offset_middle rwHEIGHT dynvalue
		{
		  slide_gpCSLIDEParser->SetOffsetRadius($3);
		}
	| offset_middle rwWIDTH dynvalue
		{
		  slide_gpCSLIDEParser->SetOffsetWidth($3);
		}
	;

dual
	: dual_start dual_middle rwEND_DUAL
		{
		  slide_gpCSLIDEParser->EndDual();
		}
	;

dual_start
	: rwDUAL tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddDual(@1.text, @1.first_line,
							@1.first_column,
							$2);
		}
	;

dual_middle
	:
		{
		}
	| dual_middle node_flag
		{
		}
	| dual_middle instance
		{
		}
	| dual_middle rwDRAW_CONTROLS dynint
		{
		  slide_gpCSLIDEParser->SetDualDrawControlMesh($3);
		}
	;

evolver
	: evolver_start evolver_middle rwEND_EVOLVER
		{
		  slide_gpCSLIDEParser->EndEvolver();
		}
	;

evolver_start
	: rwEVOLVER tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddEvolver(@1.text, @1.first_line,
							@1.first_column,
							$2);
		}
	;

evolver_middle
	:
		{
		}
	| evolver_middle node_flag
		{
		}
	| evolver_middle instance
		{
		}
	| evolver_middle rwDRAW_CONTROLS dynint
		{
		  slide_gpCSLIDEParser->SetEvolverDrawControlMesh($3);
		}
	| evolver_middle rwDRAW_CURRENT dynint
		{
		  slide_gpCSLIDEParser->SetEvolverDrawCurrentMesh($3);
		}
	| evolver_middle rwSUBDIVISIONS dynint
		{
		  slide_gpCSLIDEParser->SetEvolverSubdivisionLevel($3);
		}
	;

mirror
	: mirror_start mirror_middle rwEND_MIRROR
		{
		  slide_gpCSLIDEParser->EndMirror();
		}
	;

mirror_start
	: rwMIRROR tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddMirror(@1.text, @1.first_line,
							@1.first_column,
							$2);
		}
	;

mirror_middle
	:
		{
		}
	| mirror_middle node_flag
		{
		}
	| mirror_middle instance
		{
		}
	| mirror_middle rwDRAW_CONTROLS dynint
		{
		  slide_gpCSLIDEParser->SetMirrorDrawControlMesh($3);
		}
	;

geodesic
	: geodesic_start geodesic_middle rwEND_GEODESIC
		{
		  slide_gpCSLIDEParser->EndGeodesic();
		}
	;

geodesic_start
	: rwGEODESIC tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddGeodesic(@1.text, @1.first_line,
							@1.first_column,
							$2);
		}
	;

geodesic_middle
	:
		{
		}
	| geodesic_middle node_flag
		{
		}
	| geodesic_middle instance
		{
		}
	| geodesic_middle rwDRAW_CONTROLS dynint
		{
		  slide_gpCSLIDEParser->SetGeodesicDrawControlMesh($3);
		}
	| geodesic_middle rwTHETA dynvalue
		{
		  slide_gpCSLIDEParser->SetGeodesicTheta($3);
		}
	| geodesic_middle rwU_MAX dynint
		{
		  slide_gpCSLIDEParser->SetGeodesicIntersections($3);
		}
	;

union
	: union_start union_middle rwEND_UNION
		{
		  slide_gpCSLIDEParser->EndUnion();
		}
	;

union_start
	: rwUNION tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddUnion(@1.text, @1.first_line,
							@1.first_column,
							$2);
		}
	;

union_middle
	:
		{
		}
	| union_middle node_flag
		{
		}
	| union_middle instance
		{
		}
	;

intersection
	: intersection_start intersection_middle rwEND_INTERSECTION
		{
		  slide_gpCSLIDEParser->EndIntersection();
		}
	;

intersection_start
	: rwINTERSECTION tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddIntersection(@1.text, @1.first_line,
							@1.first_column,
							$2);
		}
	;

intersection_middle
	:
		{
		}
	| intersection_middle node_flag
		{
		}
	| intersection_middle instance
		{
		}
	;

difference
	: difference_start difference_middle rwEND_DIFFERENCE
		{
		  slide_gpCSLIDEParser->EndDifference();
		}
	;

difference_start
	: rwDIFFERENCE tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddDifference(@1.text, @1.first_line,
							@1.first_column,
							$2);
		}
	;

difference_middle
	:
		{
		}
	| difference_middle node_flag
		{
		}
	| difference_middle instance
		{
		}
	;

sgroot
	: sgroot_start sgroot_middle rwEND_SGROOT
		{
		  slide_gpCSLIDEParser->EndSGRoot();
		}
	;

sgroot_start
	: rwSGROOT tokIDENTIFIER tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddSGRoot(@1.text, @1.first_line,
						  @1.first_column,
						  $2, $3);
		}
	;

sgroot_middle
	:
		{
		}
	;

instance
	: instance_start instance_middle rwEND_INSTANCE
		{
		  slide_gpCSLIDEParser->EndInstance();
		}
	;

instance_start
	: rwINSTANCE tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddInstance(@1.text, @1.first_line,
						    @1.first_column, $2);
		}
	;

instance_middle
	:
		{
		}
	| instance_middle instance_flag
		{
		}
	| instance_middle transform
		{
		}
	;


instance_flag
	: rwID tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->SetInstanceID($2);
		}
	| node_flag
		{
		}
	;

transform
	: rwTRANSLATE dynvector
		{
		  slide_gpCSLIDEParser->AddTranslate(@1.text, 
						     @1.first_line,
						     @1.first_column,
						     $2);
		}
	| rwSCALE dynvector
		{
		  slide_gpCSLIDEParser->AddScale(@1.text, @1.first_line,
						 @1.first_column,
						 $2);
		}
	| rwROTATE dynvector '(' dynvalue ')'
		{
		  slide_gpCSLIDEParser->AddRotate(@1.text, @1.first_line,
						  @1.first_column,
						  $2, $4);
		}
	| lookat
		{
		}
	;

lookat
	: lookat_start lookat_middle rwEND_LOOK_AT
		{
		  slide_gpCSLIDEParser->EndLookAt();
		}
	;

lookat_start
	: rwLOOK_AT
		{
		  slide_gpCSLIDEParser->AddLookAt(@1.text, @1.first_line,
						  @1.first_column);
		}
	;

lookat_middle
	:
		{
		}
	| lookat_middle rwEYE dynvector
		{
		  slide_gpCSLIDEParser->SetLookAtEye($3);
		}
	| lookat_middle rwTARGET dynvector
		{
		  slide_gpCSLIDEParser->SetLookAtTarget($3);
		}
	| lookat_middle rwUP dynvector
		{
		  slide_gpCSLIDEParser->SetLookAtUp($3);
		}
	;

object
	: object_start object_middle rwEND_OBJECT
		{
		  slide_gpCSLIDEParser->EndObject();
		}
	;

object_start
	: rwOBJECT tokIDENTIFIER id_list
		{ 
		  slide_gpCSLIDEParser->AddObject(@1.text, @1.first_line,
						  @1.first_column,
						  $2, $3);
		}
	;

object_middle
	:
		{
		}
	| object_middle atom_node_flag
		{
		}
	;

mesh
	: mesh_start mesh_middle rwEND_MESH
		{
		  slide_gpCSLIDEParser->EndMesh();
		}
	;

mesh_start
	: rwMESH tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddMesh(@1.text, @1.first_line,
						@1.first_column,
						$2);
		}
	;

mesh_middle
	:
		{
		}
	| mesh_middle atom_node_flag
		{
		}
	| mesh_middle mesh_vertex_property
		{
		}
	| mesh_middle mesh_edge_property
		{
		}
	| mesh_middle mesh_vertex
		{
		}
	| mesh_middle mesh_facet
		{
		}
	| mesh_middle mesh_edge
		{
		}
	;

mesh_vertex_property
	: mesh_vertex_property_start mesh_vertex_property_middle rwEND_VERTEX_PROPERTY
		{
		  slide_gpCSLIDEParser->EndMeshVertexProperty();
		}
	;

mesh_vertex_property_start
	: rwVERTEX_PROPERTY tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddMeshVertexProperty(@1.text, @1.first_line,
							      @1.first_column,
							      $2);
		}
	;

mesh_vertex_property_middle
	:
		{
		}
	| mesh_edge_property_middle rwTYPE dyn_vertextype_flag
		{
		  slide_gpCSLIDEParser->SetMeshVertexPropertyType($3);
		}
	;

mesh_edge_property
	: mesh_edge_property_start mesh_edge_property_middle rwEND_EDGE_PROPERTY
		{
		  slide_gpCSLIDEParser->EndMeshEdgeProperty();
		}
	;

mesh_edge_property_start
	: rwEDGE_PROPERTY tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddMeshEdgeProperty(@1.text, @1.first_line,
						            @1.first_column,
						            $2);
		}
	;

mesh_edge_property_middle
	:
		{
		}
	| mesh_edge_property_middle rwSHARPNESS dynvalue
		{
		  slide_gpCSLIDEParser->SetMeshEdgePropertySharpness($3);
		}
	| mesh_edge_property_middle rwSHARPNESS rwSLF_INFINITY
		{
		  DynFloat *pdynf; 
		  pdynf = new DynFloat; 
		  ASSERT( pdynf != NULL ); 
		  pdynf->SetValue(-1.0);
		  slide_gpCSLIDEParser->SetMeshEdgePropertySharpness(pdynf);
		}
	;

mesh_vertex
	: mesh_vertex_start mesh_vertex_middle rwEND_VERTEX
		{
		  slide_gpCSLIDEParser->EndMeshVertex();
		}
	;

mesh_vertex_start
	: rwVERTEX tokIDENTIFIER dynpoint
		{ 
		  slide_gpCSLIDEParser->AddMeshVertex(@1.text, @1.first_line,
						      @1.first_column,
						      $2, $3);
		}
	;

mesh_vertex_middle
	:
		{
		}
	| mesh_vertex_middle rwVERTEX_PROPERTY tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->SetMeshVertexVertexPropertyID($3);
		}
	| mesh_vertex_middle rwNORMAL dynvector
		{
		  slide_gpCSLIDEParser->SetMeshVertexNormal($3);
		}
	| mesh_vertex_middle rwTEXTURE dynpoint
		{
		  slide_gpCSLIDEParser->SetMeshVertexTexture($3);
		}
	;

mesh_facet
	: mesh_facet_start rwEND_FACET
		{
		  slide_gpCSLIDEParser->EndMeshFacet();
		}
	;

mesh_facet_start
	: rwFACET tokIDENTIFIER id_list
		{ 
		  slide_gpCSLIDEParser->AddMeshFacet(@1.text, @1.first_line,
						     @1.first_column,
						     $2, $3);
		}
	;

mesh_edge
	: mesh_edge_start mesh_edge_middle rwEND_EDGE
		{
		  slide_gpCSLIDEParser->EndMeshEdge();
		}
	;

mesh_edge_start
	: rwEDGE tokIDENTIFIER '(' tokIDENTIFIER tokIDENTIFIER ')'
		{ 
		  slide_gpCSLIDEParser->AddMeshEdge(@1.text, @1.first_line,
						      @1.first_column,
						      $2, $4, $5);
		}
	;

mesh_edge_middle
	:
		{
		}
	| mesh_edge_middle rwEDGE_PROPERTY tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->SetMeshEdgeEdgePropertyID($3);
		}
	;

convex_hull
	: convex_hull_start convex_hull_middle rwEND_CONVEX_HULL
		{
		  slide_gpCSLIDEParser->EndConvexHull();
		}
	;

convex_hull_start
	: rwCONVEX_HULL tokIDENTIFIER id_list
		{ 
		  slide_gpCSLIDEParser->AddConvexHull(@1.text, @1.first_line,
						  @1.first_column,
						  $2, $3);
		}
	;

convex_hull_middle
	:
		{
		}
	| convex_hull_middle atom_node_flag
		{
		}
	;

general_face
	: general_face_start general_face_middle rwEND_GENERAL_FACE
		{
		  slide_gpCSLIDEParser->EndGeneralFace();
		}
	;

general_face_start
	: rwGENERAL_FACE tokIDENTIFIER id_list
		{ 
		  slide_gpCSLIDEParser->AddGeneralFace(@1.text, @1.first_line,
						  @1.first_column,
						  $2, $3);
		}
	;

general_face_middle
	:
		{
		}
	| general_face_middle rwCONTOUR id_list
		{
		  slide_gpCSLIDEParser->InsertGeneralFaceContour($3);
		}
	| general_face_middle atom_node_flag
		{
		}
	| general_face_middle rwTYPE dyn_terraintype_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceType($3);
		}
	| general_face_middle rwVORONOI dyn_voronoitype_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceVoronoi($3);
		}
	| general_face_middle rwACCURACY dyn_accuracy_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceAccuracy($3);
		}
	| general_face_middle rwRANDOM dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceRandom($3);
		}
	| general_face_middle rwDRAW_CONTOURS dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceDrawContours($3);
		}
	| general_face_middle rwDRAW_VERTICES dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceDrawVertices($3);
		}
	| general_face_middle rwDRAW_CDT dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceDrawCDT($3);
		}
	| general_face_middle rwDRAW_INDIVIDUAL_VORONOI dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceDrawIndividualVoronoi($3);
		}
	| general_face_middle rwDRAW_VORONOI dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceDrawVoronoi($3);
		}
	| general_face_middle rwDRAW_HEIGHT dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceDrawHeight($3);
		}
	| general_face_middle rwDRAW_OFFSET dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceDrawOffset($3);
		}
	| general_face_middle rwDRAW_MILLING_CONTOUR dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceDrawMillingContour($3);
		}
	| general_face_middle rwMILLING_CONTOUR dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceMillingContour($3);
		}
	| general_face_middle rwCLEAN_UP_CONTOUR dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetGeneralFaceCleanUpContour($3);
		}
	| general_face_middle rwOFFSETS dynint
		{
		  slide_gpCSLIDEParser->SetGeneralFaceOffsets($3);
		}
	| general_face_middle rwOFFSET_MIN dynvalue
		{
		  slide_gpCSLIDEParser->SetGeneralFaceOffsetMin($3);
		}
	| general_face_middle rwOFFSET_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetGeneralFaceOffsetMax($3);
		}
	| general_face_middle rwINDIVIDUAL_VORONOI_MIN dynint
		{
		  slide_gpCSLIDEParser->SetGeneralFaceIndividualVoronoiMin($3);
		}
	| general_face_middle rwINDIVIDUAL_VORONOI_MAX dynint
		{
		  slide_gpCSLIDEParser->SetGeneralFaceIndividualVoronoiMax($3);
		}
	| general_face_middle rwSUBDIVISIONS dynint
		{
		  slide_gpCSLIDEParser->SetGeneralFaceSubdivisionLevel($3);
		}
	| general_face_middle rwTOLERANCE dynvalue
		{
		  slide_gpCSLIDEParser->SetGeneralFaceTolerance($3);
		}
	;

terrain
	: terrain_start terrain_middle rwEND_TERRAIN
		{
		  slide_gpCSLIDEParser->EndTerrain();
		}
	;

terrain_start
	: rwTERRAIN tokIDENTIFIER id_list
		{ 
		  slide_gpCSLIDEParser->AddTerrain(@1.text, @1.first_line,
						  @1.first_column,
						  $2, $3);
		}
	;

terrain_middle
	:
		{
		}
	| terrain_middle atom_node_flag
		{
		}
	| terrain_middle rwTYPE dyn_terraintype_flag
		{
		  slide_gpCSLIDEParser->SetTerrainType($3);
		}
	| terrain_middle rwVORONOI dyn_voronoitype_flag
		{
		  slide_gpCSLIDEParser->SetTerrainVoronoi($3);
		}
	| terrain_middle rwACCURACY dyn_accuracy_flag
		{
		  slide_gpCSLIDEParser->SetTerrainAccuracy($3);
		}
	| terrain_middle rwRANDOM dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetTerrainRandom($3);
		}
	| terrain_middle rwDRAW_DELAUNAY dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetTerrainDrawDelaunay($3);
		}
	| terrain_middle rwDRAW_VERTICES dyn_onoff_flag
		{
		  slide_gpCSLIDEParser->SetTerrainDrawVertices($3);
		}
	;

sphere
	: sphere_start sphere_middle rwEND_SPHERE
		{
		  slide_gpCSLIDEParser->EndSphere();
		}
	;

sphere_start
	: rwSPHERE tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddSphere(@1.text, @1.first_line,
						  @1.first_column,
						  $2);
		}
	;

sphere_middle
	:
		{
		}
	| sphere_middle rwRADIUS dynvalue
		{
		  slide_gpCSLIDEParser->SetSphereRadius($3);
		}
	| sphere_middle rwZ_MIN dynvalue
		{
		  slide_gpCSLIDEParser->SetSphereZMin($3);
		}
	| sphere_middle rwZ_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetSphereZMax($3);
		}
	| sphere_middle rwTHETA_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetSphereThetaMax($3);
		}
	| sphere_middle rwZ_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetSphereZSlices($3);
		}
	| sphere_middle rwTHETA_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetSphereThetaSlices($3);
		}
	| sphere_middle rwTEXTURE dynvector dynvector dynvector dynvector
		{
		  slide_gpCSLIDEParser->SetSphereTexture($3, $4, $5, $6);
		}
	| sphere_middle rwTEXTURE dynvector dynvector
		{
		  DynVector *pdynv1, *pdynv3;

		  pdynv1 = new DynVector;
		  ASSERT( pdynv1 != NULL );
		  pdynv1->Set((*($4))(0), (*($3))(1), 0.0);
		  pdynv1->SetDynExprs($4->GetDynExpr(0), $3->GetDynExpr(1), NULL);
		  pdynv3 = new DynVector;
		  ASSERT( pdynv3 != NULL );
		  pdynv3->Set((*($3))(0), (*($4))(1), 0.0);
		  pdynv3->SetDynExprs($3->GetDynExpr(0), $4->GetDynExpr(1), NULL);
		  slide_gpCSLIDEParser->SetSphereTexture($3, pdynv1, $4, pdynv3);
		}
	| sphere_middle atom_node_flag
		{
		}
	;

cylinder
	: cylinder_start cylinder_middle rwEND_CYLINDER
		{
		  slide_gpCSLIDEParser->EndCylinder();
		}
	;

cylinder_start
	: rwCYLINDER tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddCylinder(@1.text, @1.first_line,
						  @1.first_column,
						  $2);
		}
	;

cylinder_middle
	:
		{
		}
	| cylinder_middle rwRADIUS dynvalue
		{
		  slide_gpCSLIDEParser->SetCylinderRadius($3);
		}
	| cylinder_middle rwZ_MIN dynvalue
		{
		  slide_gpCSLIDEParser->SetCylinderZMin($3);
		}
	| cylinder_middle rwZ_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetCylinderZMax($3);
		}
	| cylinder_middle rwTHETA_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetCylinderThetaMax($3);
		}
	| cylinder_middle rwZ_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetCylinderZSlices($3);
		}
	| cylinder_middle rwTHETA_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetCylinderThetaSlices($3);
		}
        | cylinder_middle rwEND_CAP dynint
                {
		  slide_gpCSLIDEParser->SetCylinderEndCap($3);
		}
        | cylinder_middle rwBEGIN_CAP dynint
                {
		  slide_gpCSLIDEParser->SetCylinderBeginCap($3);
		}
	| cylinder_middle rwTEXTURE dynvector dynvector dynvector dynvector
		{
		  slide_gpCSLIDEParser->SetCylinderTexture($3, $4, $5, $6);
		}
	| cylinder_middle rwTEXTURE dynvector dynvector
		{
		  DynVector *pdynv1, *pdynv3;

		  pdynv1 = new DynVector;
		  ASSERT( pdynv1 != NULL );
		  pdynv1->Set((*($4))(0), (*($3))(1), 0.0);
		  pdynv1->SetDynExprs($4->GetDynExpr(0), $3->GetDynExpr(1), NULL);
		  pdynv3 = new DynVector;
		  ASSERT( pdynv3 != NULL );
		  pdynv3->Set((*($3))(0), (*($4))(1), 0.0);
		  pdynv3->SetDynExprs($3->GetDynExpr(0), $4->GetDynExpr(1), NULL);
		  slide_gpCSLIDEParser->SetCylinderTexture($3, pdynv1, $4, pdynv3);
		}
	| cylinder_middle atom_node_flag
		{
		}
	;

cone
	: cone_start cone_middle rwEND_CONE
		{
		  slide_gpCSLIDEParser->EndCone();
		}
	;

cone_start
	: rwCONE tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddCone(@1.text, @1.first_line,
						  @1.first_column,
						  $2);
		}
	;

cone_middle
	:
		{
		}
	| cone_middle rwRADIUS dynvalue
		{
		  slide_gpCSLIDEParser->SetConeRadius($3);
		}
	| cone_middle rwHEIGHT dynvalue
		{
		  slide_gpCSLIDEParser->SetConeHeight($3);
		}
	| cone_middle rwZ_MIN dynvalue
		{
		  slide_gpCSLIDEParser->SetConeZMin($3);
		}
	| cone_middle rwZ_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetConeZMax($3);
		}
	| cone_middle rwTHETA_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetConeThetaMax($3);
		}
	| cone_middle rwZ_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetConeZSlices($3);
		}
	| cone_middle rwTHETA_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetConeThetaSlices($3);
		}
        | cone_middle rwBEGIN_CAP dynint
                {
		  slide_gpCSLIDEParser->SetConeBeginCap($3);
		}
	| cone_middle rwTEXTURE dynvector dynvector dynvector dynvector
		{
		  slide_gpCSLIDEParser->SetConeTexture($3, $4, $5, $6);
		}
	| cone_middle rwTEXTURE dynvector dynvector
		{
		  DynVector *pdynv1, *pdynv3;

		  pdynv1 = new DynVector;
		  ASSERT( pdynv1 != NULL );
		  pdynv1->Set((*($4))(0), (*($3))(1), 0.0);
		  pdynv1->SetDynExprs($4->GetDynExpr(0), $3->GetDynExpr(1), NULL);
		  pdynv3 = new DynVector;
		  ASSERT( pdynv3 != NULL );
		  pdynv3->Set((*($3))(0), (*($4))(1), 0.0);
		  pdynv3->SetDynExprs($3->GetDynExpr(0), $4->GetDynExpr(1), NULL);
		  slide_gpCSLIDEParser->SetConeTexture($3, pdynv1, $4, pdynv3);
		}
	| cone_middle atom_node_flag
		{
		}
	;

torus
	: torus_start torus_middle rwEND_TORUS
		{
		  slide_gpCSLIDEParser->EndTorus();
		}
	;

torus_start
	: rwTORUS tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddTorus(@1.text, @1.first_line,
						  @1.first_column,
						  $2);
		}
	;

torus_middle
	:
		{
		}
	| torus_middle rwMAJOR_RADIUS dynvalue
		{
		  slide_gpCSLIDEParser->SetTorusMajorRadius($3);
		}
	| torus_middle rwMINOR_RADIUS dynvalue
		{
		  slide_gpCSLIDEParser->SetTorusMinorRadius($3);
		}
	| torus_middle rwPHI_MIN dynvalue
		{
		  slide_gpCSLIDEParser->SetTorusPhiMin($3);
		}
	| torus_middle rwPHI_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetTorusPhiMax($3);
		}
	| torus_middle rwTHETA_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetTorusThetaMax($3);
		}
	| torus_middle rwPHI_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetTorusPhiSlices($3);
		}
	| torus_middle rwTHETA_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetTorusThetaSlices($3);
		}
	| torus_middle rwTEXTURE dynvector dynvector dynvector dynvector
		{
		  slide_gpCSLIDEParser->SetTorusTexture($3, $4, $5, $6);
		}
	| torus_middle rwTEXTURE dynvector dynvector
		{
		  DynVector *pdynv1, *pdynv3;

		  pdynv1 = new DynVector;
		  ASSERT( pdynv1 != NULL );
		  pdynv1->Set((*($4))(0), (*($3))(1), 0.0);
		  pdynv1->SetDynExprs($4->GetDynExpr(0), $3->GetDynExpr(1), NULL);
		  pdynv3 = new DynVector;
		  ASSERT( pdynv3 != NULL );
		  pdynv3->Set((*($3))(0), (*($4))(1), 0.0);
		  pdynv3->SetDynExprs($3->GetDynExpr(0), $4->GetDynExpr(1), NULL);
		  slide_gpCSLIDEParser->SetTorusTexture($3, pdynv1, $4, pdynv3);
		}
	| torus_middle atom_node_flag
		{
		}
	;

cyclide
	: cyclide_start cyclide_middle rwEND_CYCLIDE
		{
		  slide_gpCSLIDEParser->EndCyclide();
		}
	;

cyclide_start
	: rwCYCLIDE tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddCyclide(@1.text, @1.first_line,
		                                   @1.first_column,
		                                   $2);
		}
	;

cyclide_middle
	:
		{
		}
	| cyclide_middle rwMAJOR_RADIUS dynvalue
		{
		  slide_gpCSLIDEParser->SetCyclideXMajorA($3);
		}
	| cyclide_middle rwMINOR_RADIUS dynvalue
		{
		  slide_gpCSLIDEParser->SetCyclideYMinorB($3);
		}
	| cyclide_middle rwSTRING_LENGTH dynvalue
		{
		  slide_gpCSLIDEParser->SetCyclideStringLength($3);
		}
	| cyclide_middle rwPHI_MIN dynvalue
		{
		  slide_gpCSLIDEParser->SetCyclidePhiMin($3);
		}
	| cyclide_middle rwPHI_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetCyclidePhiMax($3);
		}
	| cyclide_middle rwTHETA_MIN dynvalue
		{
		  slide_gpCSLIDEParser->SetCyclideThetaMin($3);
		}
	| cyclide_middle rwTHETA_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetCyclideThetaMax($3);
		}
	| cyclide_middle rwPHI_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetCyclidePhiSlices($3);
		}
	| cyclide_middle rwTHETA_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetCyclideThetaSlices($3);
		}
	| cyclide_middle rwDRAW_ELLIPSE dynint
		{
		  slide_gpCSLIDEParser->SetCyclideDrawEllipse($3);
		}
	| cyclide_middle rwDRAW_HYPERBOLA dynint
		{
		  slide_gpCSLIDEParser->SetCyclideDrawHyperbola($3);
		}
        | cyclide_middle rwTEXTURE dynvector dynvector dynvector dynvector
		{
		  slide_gpCSLIDEParser->SetCyclideTexture($3, $4, $5, $6);
		}
	| cyclide_middle rwTEXTURE dynvector dynvector
		{
		  DynVector *pdynv1, *pdynv3;

		  pdynv1 = new DynVector;
		  ASSERT( pdynv1 != NULL );
		  pdynv1->Set((*($4))(0), (*($3))(1), 0.0);
		  pdynv1->SetDynExprs($4->GetDynExpr(0), $3->GetDynExpr(1), NULL);
		  pdynv3 = new DynVector;
		  ASSERT( pdynv3 != NULL );
		  pdynv3->Set((*($3))(0), (*($4))(1), 0.0);
		  pdynv3->SetDynExprs($3->GetDynExpr(0), $4->GetDynExpr(1), NULL);
		  slide_gpCSLIDEParser->SetCyclideTexture($3, pdynv1, $4, pdynv3);
		}
	| cyclide_middle atom_node_flag
		{
		}
	;

bsplinepatch
	: bsplinepatch_start bsplinepatch_middle rwEND_BSPLINEPATCH
		{
		  slide_gpCSLIDEParser->EndBSplinePatch();
		}
	;

bsplinepatch_start
	: rwBSPLINEPATCH tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddBSplinePatch(@1.text, @1.first_line,
		                                   @1.first_column,
		                                   $2);
		}
	;

bsplinepatch_middle
	:
		{
		}
	| bsplinepatch_middle rwU_ORDER dynint
		{
		  slide_gpCSLIDEParser->SetBSplinePatchUOrder($3);
		}
	| bsplinepatch_middle rwU_KNOTS dynint
		{
		  slide_gpCSLIDEParser->SetBSplinePatchUKnots($3);
		}
	| bsplinepatch_middle rwU_KNOT_LIST dynvalue_list
		{
		  slide_gpCSLIDEParser->SetBSplinePatchUKnotList($3);
		}
	| bsplinepatch_middle rwV_ORDER dynint
		{
		  slide_gpCSLIDEParser->SetBSplinePatchVOrder($3);
		}
	| bsplinepatch_middle rwV_KNOTS dynint
		{
		  slide_gpCSLIDEParser->SetBSplinePatchVKnots($3);
		}
	| bsplinepatch_middle rwV_KNOT_LIST dynvalue_list
		{
		  slide_gpCSLIDEParser->SetBSplinePatchVKnotList($3);
		}
	| bsplinepatch_middle rwCONTROL_POINT_LIST id_list
		{
		  slide_gpCSLIDEParser->SetBSplinePatchControlPointList($3);
		}
	| bsplinepatch_middle rwU_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetBSplinePatchUSlices($3);
		}
        | bsplinepatch_middle rwV_SLICES dynint
	        {
		  slide_gpCSLIDEParser->SetBSplinePatchVSlices($3);
		}
	| bsplinepatch_middle rwDRAW_CONTROLS dynint
		{
		  slide_gpCSLIDEParser->SetBSplinePatchDrawControls($3);
		}
        | bsplinepatch_middle rwTEXTURE dynvector dynvector dynvector dynvector
		{
		  slide_gpCSLIDEParser->SetBSplinePatchTexture($3, $4, $5, $6);
		}
	| bsplinepatch_middle rwTEXTURE dynvector dynvector
		{
		  DynVector *pdynv1, *pdynv3;

		  pdynv1 = new DynVector;
		  ASSERT( pdynv1 != NULL );
		  pdynv1->Set((*($4))(0), (*($3))(1), 0.0);
		  pdynv1->SetDynExprs($4->GetDynExpr(0), $3->GetDynExpr(1), NULL);
		  pdynv3 = new DynVector;
		  ASSERT( pdynv3 != NULL );
		  pdynv3->Set((*($3))(0), (*($4))(1), 0.0);
		  pdynv3->SetDynExprs($3->GetDynExpr(0), $4->GetDynExpr(1), NULL);
		  slide_gpCSLIDEParser->SetBSplinePatchTexture($3, pdynv1, $4, pdynv3);
		}
        | bsplinepatch_middle rwOFFSET dynvalue dynint
                {
		  slide_gpCSLIDEParser->SetBSplinePatchOffset($3, $4);
		}
	| bsplinepatch_middle atom_node_flag
		{
		}
	;

heightfield
	: heightfield_start heightfield_middle rwEND_HEIGHTFIELD
		{
		  slide_gpCSLIDEParser->EndHeightfield();
		}
	;

heightfield_start
	: rwHEIGHTFIELD tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddHeightfield(@1.text, @1.first_line,
		                                   @1.first_column,
		                                   $2);
		}
	;

heightfield_middle
	:
		{
		}
	| heightfield_middle rwU_MIN dynvalue
		{
		  slide_gpCSLIDEParser->SetHeightfieldUMin($3);
		}
	| heightfield_middle rwU_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetHeightfieldUMax($3);
		}
	| heightfield_middle rwU_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetHeightfieldUSlices($3);
		}
	| heightfield_middle rwV_MIN dynvalue
		{
		  slide_gpCSLIDEParser->SetHeightfieldVMin($3);
		}
	| heightfield_middle rwV_MAX dynvalue
		{
		  slide_gpCSLIDEParser->SetHeightfieldVMax($3);
		}
        | heightfield_middle rwV_SLICES dynint
	        {
		  slide_gpCSLIDEParser->SetHeightfieldVSlices($3);
		}
        | heightfield_middle rwHEIGHTFIELD_FUNC dynvector
	        {
		  slide_gpCSLIDEParser->SetHeightfieldFunc($3);
		}
        ;

nurbpatch
	: nurbpatch_start nurbpatch_middle rwEND_NURBPATCH
		{
		  slide_gpCSLIDEParser->EndNurbPatch();
		}
	;

nurbpatch_start
	: rwNURBPATCH tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddNurbPatch(@1.text, @1.first_line,
		                                   @1.first_column,
		                                   $2);
		}
	;

nurbpatch_middle
	:
		{
		}
	| nurbpatch_middle rwU_ORDER dynint
		{
		  slide_gpCSLIDEParser->SetNurbPatchUOrder($3);
		}
	| nurbpatch_middle rwU_KNOTS dynint
		{
		  slide_gpCSLIDEParser->SetNurbPatchUKnots($3);
		}
	| nurbpatch_middle rwU_KNOT_LIST dynvalue_list
		{
		  slide_gpCSLIDEParser->SetNurbPatchUKnotList($3);
		}
	| nurbpatch_middle rwV_ORDER dynint
		{
		  slide_gpCSLIDEParser->SetNurbPatchVOrder($3);
		}
	| nurbpatch_middle rwV_KNOTS dynint
		{
		  slide_gpCSLIDEParser->SetNurbPatchVKnots($3);
		}
	| nurbpatch_middle rwV_KNOT_LIST dynvalue_list
		{
		  slide_gpCSLIDEParser->SetNurbPatchVKnotList($3);
		}
	| nurbpatch_middle rwCONTROL_POINT_LIST id_list
		{
		  slide_gpCSLIDEParser->SetNurbPatchControlPointList($3);
		}
	| nurbpatch_middle rwU_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetNurbPatchUSlices($3);
		}
	| nurbpatch_middle rwV_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetNurbPatchVSlices($3);
		}
	| nurbpatch_middle rwDRAW_CONTROLS dynint
		{
		  slide_gpCSLIDEParser->SetNurbPatchDrawControls($3);
		}
        | nurbpatch_middle rwTEXTURE dynvector dynvector dynvector dynvector
		{
		  slide_gpCSLIDEParser->SetNurbPatchTexture($3, $4, $5, $6);
		}
	| nurbpatch_middle rwTEXTURE dynvector dynvector
		{
		  DynVector *pdynv1, *pdynv3;

		  pdynv1 = new DynVector;
		  ASSERT( pdynv1 != NULL );
		  pdynv1->Set((*($4))(0), (*($3))(1), 0.0);
		  pdynv1->SetDynExprs($4->GetDynExpr(0), $3->GetDynExpr(1), NULL);
		  pdynv3 = new DynVector;
		  ASSERT( pdynv3 != NULL );
		  pdynv3->Set((*($3))(0), (*($4))(1), 0.0);
		  pdynv3->SetDynExprs($3->GetDynExpr(0), $4->GetDynExpr(1), NULL);
		  slide_gpCSLIDEParser->SetNurbPatchTexture($3, pdynv1, $4, pdynv3);
		}
        | nurbpatch_middle rwOFFSET dynvalue dynint
                {
		  slide_gpCSLIDEParser->SetNurbPatchOffset($3, $4);
		}
	| nurbpatch_middle atom_node_flag
		{
		}
	;

bezierpatch
	: bezierpatch_start bezierpatch_middle rwEND_BEZIERPATCH
		{
		  slide_gpCSLIDEParser->EndBezierPatch();
		}
	;

bezierpatch_start
	: rwBEZIERPATCH tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddBezierPatch(@1.text, @1.first_line,
		                                   @1.first_column,
		                                   $2);
		}
	;

bezierpatch_middle
	:
		{
		}
	| bezierpatch_middle rwU_ORDER dynint
		{
		  slide_gpCSLIDEParser->SetBezierPatchUOrder($3);
		}
	| bezierpatch_middle rwV_ORDER dynint
		{
		  slide_gpCSLIDEParser->SetBezierPatchVOrder($3);
		}
	| bezierpatch_middle rwCONTROL_POINT_LIST id_list
		{
		  slide_gpCSLIDEParser->SetBezierPatchControlPointList($3);
		}
	| bezierpatch_middle rwU_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetBezierPatchUSlices($3);
		}
	| bezierpatch_middle rwV_SLICES dynint
		{
		  slide_gpCSLIDEParser->SetBezierPatchVSlices($3);
		}
	| bezierpatch_middle rwDRAW_CONTROLS dynint
		{
		  slide_gpCSLIDEParser->SetBezierPatchDrawControls($3);
		}
        | bezierpatch_middle rwTEXTURE dynvector dynvector dynvector dynvector
		{
		  slide_gpCSLIDEParser->SetBezierPatchTexture($3, $4, $5, $6);
		}
	| bezierpatch_middle rwTEXTURE dynvector dynvector
		{
		  DynVector *pdynv1, *pdynv3;

		  pdynv1 = new DynVector;
		  ASSERT( pdynv1 != NULL );
		  pdynv1->Set((*($4))(0), (*($3))(1), 0.0);
		  pdynv1->SetDynExprs($4->GetDynExpr(0), $3->GetDynExpr(1), NULL);
		  pdynv3 = new DynVector;
		  ASSERT( pdynv3 != NULL );
		  pdynv3->Set((*($3))(0), (*($4))(1), 0.0);
		  pdynv3->SetDynExprs($3->GetDynExpr(0), $4->GetDynExpr(1), NULL);
		  slide_gpCSLIDEParser->SetBezierPatchTexture($3, pdynv1, $4, pdynv3);
		}
        | bezierpatch_middle rwOFFSET dynvalue dynint
                {
		  slide_gpCSLIDEParser->SetBezierPatchOffset($3, $4);
		}
	| bezierpatch_middle atom_node_flag
		{
		}
	;

bsplinecurve
	: bsplinecurve_start bsplinecurve_middle rwEND_BSPLINECURVE
		{
		  slide_gpCSLIDEParser->EndBSplineCurve();
		}
	;

bsplinecurve_start
	: rwBSPLINECURVE tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddBSplineCurve(@1.text, @1.first_line, 
		                                        @1.first_column, $2);
		}
	;

bsplinecurve_middle
	:
		{
		}
        | bsplinecurve_middle rwORDER dynint
		{
		  slide_gpCSLIDEParser->SetBSplineCurveOrder($3);
		}
	| bsplinecurve_middle rwKNOT_LIST dynvalue_list
		{
		  slide_gpCSLIDEParser->SetBSplineCurveKnotList($3);
		}
	| bsplinecurve_middle rwCONTROL_POINT_LIST id_list
		{
		  slide_gpCSLIDEParser->SetBSplineCurveControlPointList($3);
		}
        | bsplinecurve_middle rwSLICES dynint
		{
		  slide_gpCSLIDEParser->SetBSplineCurveSlices($3);
		}
        | bsplinecurve_middle rwCLOSED dynint
		{
		  slide_gpCSLIDEParser->SetBSplineCurveClosed($3);
		}
	| bsplinecurve_middle rwDRAW_CONTROLS dynint
		{
		  slide_gpCSLIDEParser->SetBSplineCurveDrawControls($3);
		}
        | bsplinecurve_middle atom_node_flag
		{
		}
        ;

beziercurve
	: beziercurve_start beziercurve_middle rwEND_BEZIERCURVE
		{
		  slide_gpCSLIDEParser->EndBSplineCurve();
		}
	;

beziercurve_start
	: rwBEZIERCURVE tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddBSplineCurve(@1.text, @1.first_line, 
		                                        @1.first_column, $2);
		  slide_gpCSLIDEParser->SetBSplineCurveType(1);
		}
	;

beziercurve_middle
	:
		{
		}
	| beziercurve_middle rwCONTROL_POINT_LIST id_list
		{
		  slide_gpCSLIDEParser->SetBSplineCurveBezierControlPointList($3);
		}
        | beziercurve_middle rwSLICES dynint
		{
		  slide_gpCSLIDEParser->SetBSplineCurveSlices($3);
		}
	| beziercurve_middle rwDRAW_CONTROLS dynint
		{
		  slide_gpCSLIDEParser->SetBSplineCurveDrawControls($3);
		}
        | beziercurve_middle atom_node_flag
		{
		}
        ;

polyline
	: polyline_start polyline_middle rwEND_POLYLINE
		{
		  slide_gpCSLIDEParser->EndPolyline();
		}
	;

polyline_start
	: rwPOLYLINE tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddPolyline(@1.text, @1.first_line, 
		                                        @1.first_column, $2);
		}
	;

polyline_middle
	:
		{
		}
	| polyline_middle rwPOINT_LIST id_list
		{
		  slide_gpCSLIDEParser->SetPolylinePointList($3);
		}
        | polyline_middle rwDRAW_POINTS dynint
                {
		  slide_gpCSLIDEParser->SetPolylineDrawPoints($3);
		}
        | polyline_middle atom_node_flag
		{
		}
        ;

sweepmorph
	: sweepmorph_start sweepmorph_middle rwEND_SWEEP_MORPH
		{
		  slide_gpCSLIDEParser->EndSweepMorph();
		}
	;

sweepmorph_start
	: rwSWEEP_MORPH tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddSweepMorph(@1.text, @1.first_line, 
		                                      @1.first_column, 
		                                      $2);
		}
	;

sweepmorph_middle
	:
		{
		}
	| sweepmorph_middle rwPATH tokIDENTIFIER sweepmorph_path_middle rwEND_PATH 
                {
		  slide_gpCSLIDEParser->SetSweepMorphPathID($3);
                }
        | sweepmorph_middle rwEND_CAP dynint
                {
		  slide_gpCSLIDEParser->SetSweepMorphEndCap($3);
		}
        | sweepmorph_middle rwBEGIN_CAP dynint
                {
		  slide_gpCSLIDEParser->SetSweepMorphBeginCap($3);
		}
        | sweepmorph_middle rwMESH_TYPE dyn_meshtype_flag
                {
		  slide_gpCSLIDEParser->SetSweepMorphMeshType($3);
		}
	| sweepmorph_middle rwDRAW_PATH dynint
		{
		  slide_gpCSLIDEParser->SetSweepMorphDrawPath($3);
		}
	| sweepmorph_middle rwDRAW_SWEEP dynint
		{
		  slide_gpCSLIDEParser->SetSweepMorphDrawSweep($3);
		}
        | sweepmorph_middle atom_node_flag
		{
		}
        ;

sweepmorph_path_middle
	: 
		{
		}
        | sweepmorph_path_middle rwAZIMUTH dynvalue
                {
		  slide_gpCSLIDEParser->SetSweepMorphPathAzimuth($3);
		}
        | sweepmorph_path_middle rwTWIST dynvalue
                {
		  slide_gpCSLIDEParser->SetSweepMorphPathTwist($3);
		}
        | sweepmorph_path_middle rwMINIMIZE_TORSION dynint
                {
		  slide_gpCSLIDEParser->SetSweepMorphPathMinimizeTorsion($3);
		}
        | sweepmorph_path_middle rwCLOSED dynint
                {
		  slide_gpCSLIDEParser->SetSweepMorphPathClosed($3);
		}
        | sweepmorph_path_middle rwSYMMETRY dynint
                {
		  slide_gpCSLIDEParser->SetSweepMorphPathSymmetry($3);
		}
        ;

sweep
	: sweep_start sweep_middle rwEND_SWEEP
		{
		  slide_gpCSLIDEParser->EndSweep();
		}
	;

sweep_start
	: rwSWEEP tokIDENTIFIER
		{ 
		  slide_gpCSLIDEParser->AddSweep(@1.text, @1.first_line, @1.first_column, 
		                                 $2);
		}
	;

sweep_middle
	:
		{
		}
	| sweep_middle rwPATH tokIDENTIFIER sweep_path_middle rwEND_PATH 
                {
		  slide_gpCSLIDEParser->SetSweepPathID($3);
                }
        | sweep_middle sweep_crosssection_start sweep_crosssection_middle rwEND_CROSS_SECTION
                {
		  slide_gpCSLIDEParser->EndSweepCrossSection();
                }
        | sweep_middle rwMESH_TYPE dyn_meshtype_flag
                {
		  slide_gpCSLIDEParser->SetSweepMeshType($3);
		}
	| sweep_middle rwDRAW_PATH dynint
		{
		  slide_gpCSLIDEParser->SetSweepDrawPath($3);
		}
	| sweep_middle rwDRAW_SWEEP dynint
		{
		  slide_gpCSLIDEParser->SetSweepDrawSweep($3);
		}
        | sweep_middle atom_node_flag
		{
		}
        ;

sweep_path_middle
	: 
		{
		}
        | sweep_path_middle rwAZIMUTH dynvalue
                {
		  slide_gpCSLIDEParser->SetSweepPathAzimuth($3);
		}
        | sweep_path_middle rwTWIST dynvalue
                {
		  slide_gpCSLIDEParser->SetSweepPathTwist($3);
		}
        | sweep_path_middle rwMINIMIZE_TORSION dynint
                {
		  slide_gpCSLIDEParser->SetSweepPathMinimizeTorsion($3);
		}
        | sweep_path_middle rwCLOSED dynint
                {
		  slide_gpCSLIDEParser->SetSweepPathClosed($3);
		}
        | sweep_path_middle rwSYMMETRY dynint
                {
		  slide_gpCSLIDEParser->SetSweepPathSymmetry($3);
		}
        ;

sweep_crosssection_start
        : rwCROSS_SECTION tokIDENTIFIER 
                {
		  slide_gpCSLIDEParser->AddSweepCrossSectionID($2);
                }
        ;

sweep_crosssection_middle
	: 
                {
		}
        | sweep_crosssection_middle rwSURFACE surface_id
                {
		  slide_gpCSLIDEParser->SetSweepCrossSectionSurfaceID($3);
		}
        | sweep_crosssection_middle rwTEXTURE dynvector dynvector dynvector dynvector
		{
		  slide_gpCSLIDEParser->SetSweepCrossSectionTexture($3, $4, $5, $6);
		}
	| sweep_crosssection_middle rwTEXTURE dynvector dynvector
		{
		  DynVector *pdynv1, *pdynv3;

		  pdynv1 = new DynVector;
		  ASSERT( pdynv1 != NULL );
		  pdynv1->Set((*($4))(0), (*($3))(1), 0.0);
		  pdynv1->SetDynExprs($4->GetDynExpr(0), $3->GetDynExpr(1), NULL);
		  pdynv3 = new DynVector;
		  ASSERT( pdynv3 != NULL );
		  pdynv3->Set((*($3))(0), (*($4))(1), 0.0);
		  pdynv3->SetDynExprs($3->GetDynExpr(0), $4->GetDynExpr(1), NULL);
		  slide_gpCSLIDEParser->SetSweepCrossSectionTexture($3, pdynv1, $4, pdynv3);
		}
        | sweep_crosssection_middle rwEND_CAP dynint
                {
		  slide_gpCSLIDEParser->SetSweepCrossSectionEndCap($3);
		}
        | sweep_crosssection_middle rwBEGIN_CAP dynint
                {
		  slide_gpCSLIDEParser->SetSweepCrossSectionBeginCap($3);
		}
        | sweep_crosssection_middle rwORIENTATION dynint
                {
		  slide_gpCSLIDEParser->SetSweepCrossSectionOrientation($3);		  
                }
        | sweep_crosssection_middle rwTRANSFORM sweep_crosssection_transform rwEND_TRANSFORM
                {
		}
        ;

sweep_crosssection_transform
        : 
		{
		}
        | sweep_crosssection_transform rwTRANSLATE dynvector
		{
		  slide_gpCSLIDEParser->AddSweepCrossSectionTranslate(@1.text, 
		                                                      @1.first_line,
						                      @1.first_column,
						                      $3);
		}
	| sweep_crosssection_transform rwSCALE dynvector
		{
		  slide_gpCSLIDEParser->AddSweepCrossSectionScale(@1.text, @1.first_line,
						                  @1.first_column,
						                  $3);
		}
	| sweep_crosssection_transform rwROTATE dynvector '(' dynvalue ')'
		{
		  slide_gpCSLIDEParser->AddSweepCrossSectionRotate(@1.text, @1.first_line,
						                   @1.first_column,
						                   $3, $5);
		}
	;


crosssection   
	: crosssection_start crosssection_middle rwEND_CROSS_SECTION
		{ 
		  slide_gpCSLIDEParser->EndCrossSection();
		}
	;

crosssection_start     
	: rwCROSS_SECTION tokIDENTIFIER 
		{ 
		  slide_gpCSLIDEParser->AddCrossSection(@1.text, @1.first_line, 
						 @1.first_column,
						 $2);
		}
	;

crosssection_middle
        : 
                {
                }
        | crosssection_middle rwSURFACE surface_id
		{
		  slide_gpCSLIDEParser->SetCrossSectionSurfaceID($3);
		}
        | crosssection_middle primitive_flag
                {
                }
        | crosssection_middle rwTYPE rwPOLYLINE tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->SetCrossSectionType(0);
		  slide_gpCSLIDEParser->SetCrossSectionID($4);
		}
        | crosssection_middle rwTYPE rwBSPLINECURVE tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->SetCrossSectionType(1);
		  slide_gpCSLIDEParser->SetCrossSectionID($4);
		}
        | crosssection_middle rwTYPE rwBEZIERCURVE tokIDENTIFIER 
		{
		  slide_gpCSLIDEParser->SetCrossSectionType(2);
		  slide_gpCSLIDEParser->SetCrossSectionID($4);
		}
        | crosssection_middle rwTYPE rwCIRCLE crosssection_circle
                {
		  slide_gpCSLIDEParser->SetCrossSectionType(3);
                }
        | crosssection_middle rwTYPE rwCRESENT crosssection_cresent
                {
		  slide_gpCSLIDEParser->SetCrossSectionType(4);
                }
        | crosssection_middle rwTYPE rwSTAR crosssection_star
                {
		  slide_gpCSLIDEParser->SetCrossSectionType(5);
                }
        ;

crosssection_circle
        :
                {
                }
        | crosssection_circle rwRADIUS dynvalue
                {
		  slide_gpCSLIDEParser->SetCrossSectionRadius($3);
		}
        | crosssection_circle rwSLICES dynint
                {
		  slide_gpCSLIDEParser->SetCrossSectionSlices($3);
		}
        ;

crosssection_cresent
        :
                {
                }
        | crosssection_cresent rwRADIUS dynvalue
                {
		  slide_gpCSLIDEParser->SetCrossSectionRadius($3);
		}
        | crosssection_cresent rwTHICKNESS dynvalue
                {
		  slide_gpCSLIDEParser->SetCrossSectionThickness($3);
		}
        | crosssection_cresent rwTHETA dynvalue
                {
		  slide_gpCSLIDEParser->SetCrossSectionTheta($3);
		}
        | crosssection_cresent rwSLICES dynint
                {
		  slide_gpCSLIDEParser->SetCrossSectionSlices($3);
		}
        ;

crosssection_star
        :
                {
                }
        | crosssection_star rwINNER_RADIUS dynvalue
                {
		  slide_gpCSLIDEParser->SetCrossSectionInnerRadius($3);
		}
        | crosssection_star rwOUTER_RADIUS dynvalue
                {
		  slide_gpCSLIDEParser->SetCrossSectionRadius($3);
		}
        | crosssection_star rwSLICES dynint
                {
		  slide_gpCSLIDEParser->SetCrossSectionSlices($3);
		}
        ;

face    
	: face_start face_middle rwEND_FACE
		{ 
		  slide_gpCSLIDEParser->EndFace();
		}
	;

face_start      
	: rwFACE tokIDENTIFIER id_list
		{ 
		  slide_gpCSLIDEParser->AddFace(@1.text, @1.first_line, 
						@1.first_column,
						$2, $3);
		}
	;

face_middle
	:
		{
		}
	| face_middle primitive_flag
		{
		}
	| face_middle rwSURFACE surface_id
		{
		  slide_gpCSLIDEParser->SetFaceSurfaceID($3);
		}
	;

point   
	: point_start point_middle rwEND_POINT
		{ 
		  slide_gpCSLIDEParser->EndPoint();
		}
	;

point_start     
	: rwPOINT tokIDENTIFIER dynpoint
		{ 
		  slide_gpCSLIDEParser->AddPoint(@1.text, @1.first_line, 
						 @1.first_column,
						 $2, $3);
		}
	;

point_middle    
	: 
		{
		}
	| point_middle rwSURFACE surface_id
		{
		  slide_gpCSLIDEParser->SetPointSurfaceID($3);
		}
	| point_middle rwNORMAL dynvector
		{ 
		  slide_gpCSLIDEParser->SetPointNormal($3);
		}
	| point_middle rwTEXTURE dynpoint
		{ 
		  slide_gpCSLIDEParser->SetPointTexture($3);
		}
	| point_middle primitive_flag
		{
		}
	;

controlpoint   
	: controlpoint_start controlpoint_middle rwEND_CONTROLPOINT
		{ 
		  slide_gpCSLIDEParser->EndControlPoint();
		}
	;

controlpoint_start     
	: rwCONTROLPOINT tokIDENTIFIER 
		{ 
		  slide_gpCSLIDEParser->AddControlPoint(@1.text, @1.first_line, 
						 @1.first_column,
						 $2);
		}
	;

controlpoint_middle    
	: 
		{
		}
	| controlpoint_middle rwPOINT tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->SetControlPointPointID($3);
		}
	| controlpoint_middle rwCROSS_SECTION tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->SetControlPointCrossSectionID($3);
		}
	| controlpoint_middle rwSCALE dynvector3d
		{ 
		  slide_gpCSLIDEParser->SetControlPointScale($3);
		}
	| controlpoint_middle rwROTATE dynvector3d
		{ 
		  slide_gpCSLIDEParser->SetControlPointRotate($3);
		}
	| controlpoint_middle primitive_flag
		{
		}
	;


surface
	: surface_start surface_middle rwEND_SURFACE
		{
		  slide_gpCSLIDEParser->EndSurface();
		}
	;

surface_start
	: rwSURFACE tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddSurface(@1.text, @1.first_line, 
						   @1.first_column, $2);
		}
	;

surface_middle
	: 
		{
		}
	| surface_middle primitive_flag
		{
		}
	| surface_middle rwCOLOR dynvector
		{
		  slide_gpCSLIDEParser->SetSurfaceColor($3);
		}
	| surface_middle rwREFLECTIVITY dynvector
		{
		  slide_gpCSLIDEParser->SetSurfaceReflectivity($3);
		}
	| surface_middle rwEXPONENT dynvalue
		{
		  slide_gpCSLIDEParser->SetSurfaceExponent($3);
		}
	| surface_middle rwMETALLIC dynvalue
		{
		  slide_gpCSLIDEParser->SetSurfaceMetallic($3);
		}
	| surface_middle rwBITMAP tokCONST_STRING dyn_texture_flag
		{
		  slide_gpCSLIDEParser->SetSurfaceTexture($3,$4);
		}
	;

fog
	: fog_start fog_middle rwEND_FOG
		{
		  slide_gpCSLIDEParser->EndFog();
		}
	;

fog_start
	: rwFOG tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddFog(@1.text, @1.first_line, 
						   @1.first_column, $2);
		}
	;

fog_middle
	: 
		{
		}
	| fog_middle primitive_flag
		{
		}
	| fog_middle rwTYPE dyn_fogtype_flag
		{
		  slide_gpCSLIDEParser->SetFogType($3);
		}
	| fog_middle rwDENSITY dynvalue
		{
		  slide_gpCSLIDEParser->SetFogDensity($3);
		}
	| fog_middle rwSTART dynvalue
		{
		  slide_gpCSLIDEParser->SetFogStart($3);
		}
	| fog_middle rwEND dynvalue
		{
		  slide_gpCSLIDEParser->SetFogEnd($3);
		}
	| fog_middle rwCOLOR dynvector
		{
		  slide_gpCSLIDEParser->SetFogColor($3);
		}
	;

wormwarp
	: wormwarp_start wormwarp_middle rwEND_WORMWARP
		{
		  slide_gpCSLIDEParser->EndWormwarp();
		}
	;

wormwarp_start
	: rwWORMWARP tokIDENTIFIER
		{
		  slide_gpCSLIDEParser->AddWormwarp(@1.text, @1.first_line, 
						   @1.first_column, $2);
		}
	;

wormwarp_middle
	: 
		{
		}
        | wormwarp_middle rwGROUP tokIDENTIFIER
                {
		  slide_gpCSLIDEParser->SetWormwarpGroupID($3);
		}
        | wormwarp_middle rwPATH tokIDENTIFIER
                {
		  slide_gpCSLIDEParser->SetWormwarpPathID($3);
		}
	| wormwarp_middle rwINSTANCE dynvalue
		{
		  slide_gpCSLIDEParser->SetWormwarpInstances($3);
		}
        | wormwarp_middle rwTYPE dynint
                {
		  slide_gpCSLIDEParser->SetWormwarpType($3);
		}
        | wormwarp_middle rwPATHONOFF dyn_onoff_flag
                {
		  slide_gpCSLIDEParser->SetWormwarpPathOnOff($3);
		}
	| wormwarp_middle node_flag
		{
		}
	;

id_list
	: '('
		{
		  $$ = slide_gpCSLIDEParser->CreateIDList();
		}
	| id_list tokIDENTIFIER
		{
		  $$ = slide_gpCSLIDEParser->InsertIDList($1, $2);
		}
	| id_list ')'
		{
		  $$ = $1;
		}
	;               

dynvalue_list
	: '('
		{
		  $$ = slide_gpCSLIDEParser->CreateDynvalueList();
		}
	| dynvalue_list dynvalue
		{
		  $$ = slide_gpCSLIDEParser->InsertDynvalueList($1, $2);
		}
	| dynvalue_list ')'
		{
		  $$ = $1;
		}
	;       

atom_node_flag
	: node_flag
		{
		}
	| rwSOLID dyn_solid_flag
		{
		  slide_gpCSLIDEParser->SetAtomNodeSolid($2);
		}
	;

node_flag
	: primitive_flag
		{
		}
	| rwSURFACE surface_id
		{
		  slide_gpCSLIDEParser->SetNodeSurfaceID($2);
		}
	| rwSHADING dyn_shading_flag
		{
		  slide_gpCSLIDEParser->SetNodeShading($2);
		}
	| rwLOD dyn_lod_flag
		{
		  slide_gpCSLIDEParser->SetNodeLOD($2);
		}
	;
	
primitive_flag
	: rwRIB_BEGIN tokCONST_STRING
		{
		  printf("ribbegin: %s :\n", $2);
		  slide_gpCSLIDEParser->SetPrimitiveRIBBegin($2);
		}
	| rwRIB_END tokCONST_STRING
		{
		  printf("ribend  : %s :\n", $2);
		  slide_gpCSLIDEParser->SetPrimitiveRIBEnd($2);
		}
        | rwGRAPH_POSITION dynint dynint
                {
		  slide_gpCSLIDEParser->SetPrimitiveGraphPosition($2, $3);
		}
	;

surface_id
	: rwSLF_INHERIT 
		{
		  $$ = (CHAR*)(gcppcSLIDEReservedWords[sliderwtSLF_INHERIT]);
		}
	| tokIDENTIFIER
		{
		  $$ = $1;
		}
	;

dynpoint
	: '(' dynvalue dynvalue dynvalue dynvalue ')'
                {
		  $$ = new DynPoint;
		  ASSERT( $$ != NULL );
		  $$->SetAll($2, $3, $4, $5);
		  delete $2;
		  delete $3;
		  delete $4;
		  delete $5;
		}
        | '(' dynvalue dynvalue dynvalue ')'
		{
		  $$ = new DynPoint;
		  ASSERT( $$ != NULL );
		  $$->SetAll($2, $3, $4);
		  delete $2;
		  delete $3;
		  delete $4;
		}
	| '(' dynvalue dynvalue ')'
		{
		  // The Z component defaults to 0
		  DynFloat dynfZ;
		  dynfZ.SetValue(0.0);

		  $$ = new DynPoint;
		  ASSERT( $$ != NULL );
		  $$->SetAll($2, $3, &dynfZ);
		  delete $2;
		  delete $3;
		}
	;

dynvector
	: '(' dynvalue dynvalue dynvalue ')'
		{
		  $$ = new DynVector;
		  ASSERT( $$ != NULL );
		  $$->SetAll($2, $3, $4);
		  delete $2;
		  delete $3;
		  delete $4;
		}
	| '(' dynvalue dynvalue ')'
		{
		  // The Z component defaults to 0
		  DynFloat dynfZ;
		  dynfZ.SetValue(0.0);

		  $$ = new DynVector;
		  ASSERT( $$ != NULL );
		  $$->SetAll($2, $3, &dynfZ);
		  delete $2;
		  delete $3;
		}
	| '(' dynvalue dynvalue dynvalue dynvalue ')'
		{
		  $$ = new DynVector;
		  ASSERT( $$ != NULL );
		  $$->SetAll($2, $3, $4, $5);
		  delete $2;
		  delete $3;
		  delete $4;
		  delete $5;
		}
	;

dynvector2d
	: '(' dynvalue dynvalue ')'
		{
		  $$ = new DynVector;
		  ASSERT( $$ != NULL );
		  $$->SetAll($2, $3);
		  delete $2;
		  delete $3;
		}
	;

dynvector3d
	: '(' dynvalue dynvalue dynvalue ')'
		{
		  $$ = new DynVector;
		  ASSERT( $$ != NULL );
		  $$->SetAll($2, $3, $4);
		  delete $2;
		  delete $3;
		  delete $4;
		}
	;

dynvalue        
	: value
		{ 
		  $$ = new DynFloat; 
		  ASSERT( $$ != NULL ); 
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{ 
		  $$ = new DynFloat; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		}

	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynFloat; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

value   
	: tokCONST_FLOAT
		{ $$ = $1; }
	| tokCONST_INT
		{ $$ = (FLOAT)$1; }
	;

dynint  
	: tokCONST_INT
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		}

	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

dyn_onoff_flag
	: onoff_flag
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		}

	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;
	
onoff_flag
	: rwSLF_ON
		{ $$ = slideoftSLF_ON; }
	| rwSLF_OFF
		{ $$ = slideoftSLF_OFF; }
	;

dyn_solid_flag
	: solid_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}

	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

solid_flag
	: rwSLF_SOLID
		{
		  $$ = slidestSLF_SOLID;
		}
	| rwSLF_HOLLOW
		{
		  $$ = slidestSLF_HOLLOW;
		}
	;

dyn_shading_flag
	: shading_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}

	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

shading_flag
	: rwSLF_INHERIT
		{
		  $$ = slideshtSLF_INHERIT;
		}
	| rwSLF_WIRE
		{
		  $$ = slideshtSLF_WIRE;
		}
	| rwSLF_FLAT
		{
		  $$ = slideshtSLF_FLAT;
		}
	| rwSLF_GOURAUD
		{
		  $$ = slideshtSLF_GOURAUD;
		}
	| rwSLF_PHONG
		{
		  $$ = slideshtSLF_PHONG;
		}
	;

dyn_lod_flag
	: lod_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}

	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

lod_flag
	: rwSLF_OFF
		{
		  $$ = slidelodtSLF_OFF;
		}
	| rwSLF_BOUND
		{
		  $$ = slidelodtSLF_BOUND;
		}
	| rwSLF_EDGES
		{
		  $$ = slidelodtSLF_EDGES;
		}
	| rwSLF_FULL
		{
		  $$ = slidelodtSLF_FULL;
		}
	;

dyn_texture_flag
        : texture_flag
                {
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

texture_flag
        : rwSLF_ENVMAP
                { $$ = slidetexturetSLF_ENVMAP; }
        | rwSLF_TEXMAP
                { $$ = slidetexturetSLF_TEXMAP; }
        ;

dyn_stencil_flag
	: stencil_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}

	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

stencil_flag
	: rwSLF_BOTH
		{
		  $$ = slidesttSLF_BOTH;
		}
	| rwSLF_ODD
		{
		  $$ = slidesttSLF_ODD;
		}
	| rwSLF_EVEN
		{
		  $$ = slidesttSLF_EVEN;
		}
	;

dyn_projection_flag
	: projection_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

projection_flag
	: rwSLF_PARALLEL
		{
		  $$ = slidepjtSLF_PARALLEL;
		}
	| rwSLF_PERSPECTIVE
		{
		  $$ = slidepjtSLF_PERSPECTIVE;
		}
	;

dyn_lighttype_flag
	: lighttype_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

lighttype_flag
	: rwSLF_AMBIENT
		{
		  $$ = slideltSLF_AMBIENT;
		}
	| rwSLF_DIRECTIONAL
		{
		  $$ = slideltSLF_DIRECTIONAL;
		}
	| rwSLF_POINT
		{
		  $$ = slideltSLF_POINT;
		}
	| rwSLF_SPOT
		{
		  $$ = slideltSLF_SPOT;
		}
	;

dyn_fogtype_flag
	: fogtype_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

fogtype_flag
	: rwSLF_LINEAR
		{
		  $$ = slidefogtSLF_LINEAR;
		}
	| rwSLF_EXP
		{
		  $$ = slidefogtSLF_EXP;
		}
	| rwSLF_EXP2
		{
		  $$ = slidefogtSLF_EXP2;
		}
	;

aspect_ratio_flag
	: rwSLF_FIXED
		{ $$ = slideartSLF_FIXED; }
	| rwSLF_ANY
		{ $$ = slideartSLF_ANY; }
	| rwSLF_FULL_SCREEN
		{ $$ = slideartSLF_FULL_SCREEN; }
	;

dyn_cui_flag
        : cui_flag
                {
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

cui_flag
        : rwSLF_RESET_CUI
		{ $$ = slidecuitSLF_RESET_CUI; }
	| rwSLF_PAUSE_CUI
		{ $$ = slidecuitSLF_PAUSE_CUI; }
	| rwSLF_CAD_CUI
		{ $$ = slidecuitSLF_CAD_CUI; }
	| rwSLF_FLY_CUI
		{ $$ = slidecuitSLF_FLY_CUI; }
	| rwSLF_EXPLORE_CUI
		{ $$ = slidecuitSLF_EXPLORE_CUI; }
	;

dyn_subdivisiontype_flag
	: subdivisiontype_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

subdivisiontype_flag
	: rwSLF_SUBDIVISION_DOO_SABIN
		{
		  $$ = slidesubtSLF_SUBDIVISION_DOO_SABIN;
		}
	| rwSLF_SUBDIVISION_DOO_SABIN_SELECTIVE
		{
		  $$ = slidesubtSLF_SUBDIVISION_DOO_SABIN_SELECTIVE;
		}
	| rwSLF_SUBDIVISION_DOO_SABIN_SELECTIVE_LIMIT
		{
		  $$ = slidesubtSLF_SUBDIVISION_DOO_SABIN_SELECTIVE_LIMIT;
		}
	| rwSLF_SUBDIVISION_CATMULL_CLARK
		{
		  $$ = slidesubtSLF_SUBDIVISION_CATMULL_CLARK;
		}
	| rwSLF_SUBDIVISION_CATMULL_CLARK_TESSELATE
		{
		  $$ = slidesubtSLF_SUBDIVISION_CATMULL_CLARK_TESSELATE;
		}
	| rwSLF_SUBDIVISION_CATMULL_CLARK_INTERPOLATE
		{
		  $$ = slidesubtSLF_SUBDIVISION_CATMULL_CLARK_INTERPOLATE;
		}
	| rwSLF_SUBDIVISION_CATMULL_CLARK_C2
		{
		  $$ = slidesubtSLF_SUBDIVISION_CATMULL_CLARK_C2;
		}
	| rwSLF_SUBDIVISION_CATMULL_CLARK_SELECTIVE
		{
		  $$ = slidesubtSLF_SUBDIVISION_CATMULL_CLARK_SELECTIVE;
		}
	| rwSLF_SUBDIVISION_CATMULL_CLARK_OLD
		{
		  $$ = slidesubtSLF_SUBDIVISION_CATMULL_CLARK_OLD;
		}
	| rwSLF_SUBDIVISION_CORNER_CUTTING
		{
		  $$ = slidesubtSLF_SUBDIVISION_CORNER_CUTTING;
		}
	| rwSLF_SUBDIVISION_CORNER_ROUNDING_TESSELATE
		{
		  $$ = slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_TESSELATE;
		}
	| rwSLF_SUBDIVISION_CORNER_ROUNDING
		{
		  $$ = slidesubtSLF_SUBDIVISION_CORNER_ROUNDING;
		}
	| rwSLF_SUBDIVISION_CORNER_ROUNDING_LOOP
		{
		  $$ = slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_LOOP;
		}
	| rwSLF_SUBDIVISION_CORNER_ROUNDING_SHARP_LOOP
		{
		  $$ = slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_SHARP_LOOP;
		}
	| rwSLF_SUBDIVISION_CORNER_ROUNDING_BUTTERFLY
		{
		  $$ = slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_BUTTERFLY;
		}
	| rwSLF_SUBDIVISION_CORNER_ROUNDING_ZORIN
		{
		  $$ = slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_ZORIN;
		}
	| rwSLF_SUBDIVISION_CORNER_ROUNDING_SELECTIVE
		{
		  $$ = slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_SELECTIVE;
		}
	| rwSLF_SUBDIVISION_CORNER_ROUNDING_SELECTIVE_LIMIT
		{
		  $$ = slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_SELECTIVE_LIMIT;
		}
	| rwSLF_SUBDIVISION_CORNER_ROUNDING_SHARP_SELECTIVE_LIMIT
		{
		  $$ = slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_SHARP_SELECTIVE_LIMIT;
		}
	| rwSLF_SUBDIVISION_CORNER_ROUNDING_FACET_SHARP_SELECTIVE_LIMIT
		{
		  $$ = slidesubtSLF_SUBDIVISION_CORNER_ROUNDING_FACET_SHARP_SELECTIVE_LIMIT;
		}
	| rwSLF_SUBDIVISION_TRIANGLE_TESSELATE
		{
		  $$ = slidesubtSLF_SUBDIVISION_TRIANGLE_TESSELATE;
		}
	| rwSLF_SUBDIVISION_TRIANGLE_LOOP
		{
		  $$ = slidesubtSLF_SUBDIVISION_TRIANGLE_LOOP;
		}
	| rwSLF_SUBDIVISION_TRIANGLE_LOOP_EDGE_RULE
		{
		  $$ = slidesubtSLF_SUBDIVISION_TRIANGLE_LOOP_EDGE_RULE;
		}
	| rwSLF_SUBDIVISION_TRIANGLE_BUTTERFLY
		{
		  $$ = slidesubtSLF_SUBDIVISION_TRIANGLE_BUTTERFLY;
		}
	| rwSLF_SUBDIVISION_TRIANGLE_ZORIN
		{
		  $$ = slidesubtSLF_SUBDIVISION_TRIANGLE_ZORIN;
		}
	| rwSLF_SUBDIVISION_TRIANGLE_SPHERE
		{
		  $$ = slidesubtSLF_SUBDIVISION_TRIANGLE_SPHERE;
		}
	| rwSLF_SUBDIVISION_SQRT_3
		{
		  $$ = slidesubtSLF_SUBDIVISION_SQRT_3;
		}
	| rwSLF_SUBDIVISION_SQRT_3_SPHERE_BARYCENTER
		{
		  $$ = slidesubtSLF_SUBDIVISION_SQRT_3_SPHERE_BARYCENTER;
		}
	| rwSLF_SUBDIVISION_SQRT_3_SPHERE_CENTER
		{
		  $$ = slidesubtSLF_SUBDIVISION_SQRT_3_SPHERE_CENTER;
		}
	| rwSLF_SUBDIVISION_SQRT_3_SPHERE_RADIUS
		{
		  $$ = slidesubtSLF_SUBDIVISION_SQRT_3_SPHERE_RADIUS;
		}
	| rwSLF_SUBDIVISION_SQRT_3_SPHERE_CAP_AREA
		{
		  $$ = slidesubtSLF_SUBDIVISION_SQRT_3_SPHERE_CAP_AREA;
		}
	| rwSLF_SUBDIVISION_SQRT_3_SPHERE_TRIANGLE_AREA
		{
		  $$ = slidesubtSLF_SUBDIVISION_SQRT_3_SPHERE_TRIANGLE_AREA;
		}
	| rwSLF_SUBDIVISION_SQRT_3_SPHERE_TANGENT
		{
		  $$ = slidesubtSLF_SUBDIVISION_SQRT_3_SPHERE_TANGENT;
		}
	| rwSLF_SUBDIVISION_SQRT_3_SELECTIVE
		{
		  $$ = slidesubtSLF_SUBDIVISION_SQRT_3_SELECTIVE;
		}
	| rwSLF_SUBDIVISION_SQRT_3_SELECTIVE_FACET
		{
		  $$ = slidesubtSLF_SUBDIVISION_SQRT_3_SELECTIVE_FACET;
		}
	| rwSLF_SUBDIVISION_SQRT_4
		{
		  $$ = slidesubtSLF_SUBDIVISION_SQRT_4;
		}
	| rwSLF_SUBDIVISION_SQRT_4_SELECTIVE
		{
		  $$ = slidesubtSLF_SUBDIVISION_SQRT_4_SELECTIVE;
		}
	| rwSLF_SUBDIVISION_HETEROGENEOUS
		{
		  $$ = slidesubtSLF_SUBDIVISION_HETEROGENEOUS;
		}
	| rwSLF_SUBDIVISION_HETEROGENEOUS_STAM_LOOP
		{
		  $$ = slidesubtSLF_SUBDIVISION_HETEROGENEOUS_STAM_LOOP;
		}
	| rwSLF_SUBDIVISION_HETEROGENEOUS_OLD
		{
		  $$ = slidesubtSLF_SUBDIVISION_HETEROGENEOUS_OLD;
		}
	| rwSLF_SUBDIVISION_HETEROGENEOUS_TESSELATE
		{
		  $$ = slidesubtSLF_SUBDIVISION_HETEROGENEOUS_TESSELATE;
		}
	| rwSLF_SUBDIVISION_PENTAGON
		{
		  $$ = slidesubtSLF_SUBDIVISION_PENTAGON;
		}
	| rwSLF_SUBDIVISION_PENTAGON_TESSELATE
		{
		  $$ = slidesubtSLF_SUBDIVISION_PENTAGON_TESSELATE;
		}
	| rwSLF_SUBDIVISION_GEOMETRIC
		{
		  $$ = slidesubtSLF_SUBDIVISION_GEOMETRIC;
		}
	| rwSLF_SUBDIVISION_GEOMETRIC_TESSELATE
		{
		  $$ = slidesubtSLF_SUBDIVISION_GEOMETRIC_TESSELATE;
		}
	;

dyn_errormetric_flag
	: errormetric_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

errormetric_flag
	: rwSLF_ERROR_METRIC_BEST_FIT_PLANE
		{
		  $$ = slideemtSLF_ERROR_METRIC_BEST_FIT_PLANE;
		}
	| rwSLF_ERROR_METRIC_LIMIT_DISTANCE
		{
		  $$ = slideemtSLF_ERROR_METRIC_LIMIT_DISTANCE;
		}
	;

dyn_offsettype_flag
	: offsettype_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

offsettype_flag
	: rwSLF_OFFSET_ANGULAR
		{
		  $$ = slideofftSLF_OFFSET_ANGULAR;
		}
	| rwSLF_OFFSET_ROUNDED
		{
		  $$ = slideofftSLF_OFFSET_ROUNDED;
		}
	| rwSLF_OFFSET_PERFORATED
		{
		  $$ = slideofftSLF_OFFSET_PERFORATED;
		}
	;

dyn_terraintype_flag
	: terraintype_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

terraintype_flag
	: rwSLF_TERRAIN_DELAUNAY_INCREMENTAL
		{
		  $$ = slidetertSLF_TERRAIN_DELAUNAY_INCREMENTAL;
		}
	| rwSLF_TERRAIN_DELAUNAY_INCREMENTAL_SLOW
		{
		  $$ = slidetertSLF_TERRAIN_DELAUNAY_INCREMENTAL_SLOW;
		}
	| rwSLF_TERRAIN_DELAUNAY_INCREMENTAL_NO_BOUND
		{
		  $$ = slidetertSLF_TERRAIN_DELAUNAY_INCREMENTAL_NO_BOUND;
		}
	| rwSLF_TERRAIN_DELAUNAY_DIVIDE_AND_CONQUER
		{
		  $$ = slidetertSLF_TERRAIN_DELAUNAY_DIVIDE_AND_CONQUER;
		}
	| rwSLF_TERRAIN_DELAUNAY_DIVIDE_AND_CONQUER_ALTERNATING
		{
		  $$ = slidetertSLF_TERRAIN_DELAUNAY_DIVIDE_AND_CONQUER_ALTERNATING;
		}
	| rwSLF_TERRAIN_DELAUNAY_CONVEX_HULL
		{
		  $$ = slidetertSLF_TERRAIN_DELAUNAY_CONVEX_HULL;
		}
	;

dyn_voronoitype_flag
	: voronoitype_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

voronoitype_flag
	: rwSLF_VORONOI_OFF
		{
		  $$ = slidevtSLF_VORONOI_OFF;
		}
	| rwSLF_VORONOI_DELAUNAY
		{
		  $$ = slidevtSLF_VORONOI_DELAUNAY;
		}
	| rwSLF_VORONOI_DIVIDE_AND_CONQUER
		{
		  $$ = slidevtSLF_VORONOI_DIVIDE_AND_CONQUER;
		}
	| rwSLF_VORONOI_DIVIDE_AND_CONQUER_ALTERNATING
		{
		  $$ = slidevtSLF_VORONOI_DIVIDE_AND_CONQUER_ALTERNATING;
		}
	| rwSLF_VORONOI_CONES
		{
		  $$ = slidevtSLF_VORONOI_CONES;
		}
	| rwSLF_VORONOI_PLANES
		{
		  $$ = slidevtSLF_VORONOI_PLANES;
		}
	;

dyn_accuracy_flag
	: accuracy_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

accuracy_flag
	: rwSLF_FLOAT_NAIVE
		{
		  $$ = slideatSLF_FLOAT_NAIVE;
		}
	| rwSLF_FLOAT
		{
		  $$ = slideatSLF_FLOAT;
		}
	| rwSLF_EXACT
		{
		  $$ = slideatSLF_EXACT;
		}
	;

dyn_vertextype_flag
	: vertextype_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

vertextype_flag
	: rwSLF_VERTEX_SMOOTH
		{
		  $$ = slidevxtSLF_VERTEX_SMOOTH;
		}
	| rwSLF_VERTEX_CORNER
		{
		  $$ = slidevxtSLF_VERTEX_CORNER;
		}
	;

dyn_meshtype_flag
	: meshtype_flag
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetValue($1);
		}
	| tokTCL_BLOCK
		{
		  $$ = new DynInt;
		  ASSERT( $$ != NULL );
		  $$->SetDynExpr($1);
		}
	| tokTCL_MACRO_BLOCK
		{ 
		  $$ = new DynInt; 
		  ASSERT( $$ != NULL ); 
		  $$->SetDynExpr($1);
		  $$->SetIsMacro();
		}
	;

meshtype_flag
	: rwSLF_TRIANGLES
		{
		  $$ = slidemtSLF_TRIANGLES;
		}
	| rwSLF_QUADRILATERALS
		{
		  $$ = slidemtSLF_QUADRILATERALS;
		}
	;


%%

/*
	| rwGENERAL '(' value value value value value value value value value value value value value value value value ')'
		{
		  slide_gpCSLIDEParser->AddGeneral(@1.text, @1.first_line,
						   @1.first_column,
						   $3, $4, $5, $6,
						   $7, $8, $9, $10,
						   $11, $12, $13, $14,
						   $15, $16, $17, $18);
		}
*/

CSLIDEParser *slide_InitParser(CSLIDEParser *pCSLIDEParser, CHAR *pcInput, 
			       CHAR **ppcDirectories, UINT_32 uiDirectories)
{
  ASSERT( pcInput != NULL );

  ASSERT( pCSLIDEParser != NULL );

  pCSLIDEParser->Init(pcInput, ppcDirectories, uiDirectories, 
		      &slide_gpCSLIDEParser, 
		      &slide_lloc, yyparse,
		      &slide_gpCScanner,
		      &slide_leng,
		      slide_BeginInitial,
		      slide_GetCurrentBuffer,
		      slide_CreateBuffer,
		      slide_DeleteBuffer,
		      slide_SwitchToBuffer,
		      slide_SetValueInt,
		      slide_SetValueFloat,
		      slide_SetValueString);

  slide_gpCSLIDEParser = pCSLIDEParser;

  return pCSLIDEParser;
}

// This is yyerror which is called by bison
void slide_error(char * /*s*/)
{
  slide_gpCSLIDEParser->HandleError(yylloc.first_line, yylloc.first_column, "");
}
