#ifndef __SLIDEFOG_H__
#define __SLIDEFOG_H__

#include "slideprimitive.h"

//////////////////////////////////////////////////////////////////////////////
// CSLIDEFog Class
//

class CSLIDEFog : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEFog();
  virtual ~CSLIDEFog();
  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
		    CHAR *pcID);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  inline VOID SetType(DynInt *pdyniType);
  inline VOID SetDensity(DynFloat *pdynfDensity);
  inline VOID SetStart(DynFloat *pdynfStart);
  inline VOID SetEnd(DynFloat *pdynfEnd);
  inline VOID SetColor(DynVector *pdynvColor);

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);

  virtual BOOL Valid();

  virtual VOID Remove(CSLIDEWorld *pCSLIDEWorld);

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:
  virtual VOID CheckDynamic();
  virtual VOID UpdateState();

//////////////////////////////////////////////////
// Rendering
//
public:
  virtual VOID Render();

protected:

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);
  virtual VOID WriteRIB(FILE *fpOutputFile);
  virtual VOID WritePOV(FILE *fpOutputFile);
  virtual VOID WriteDotID(FILE *fpOutputFile);
  virtual VOID WriteDotNode(FILE *fpOutputFile);
  virtual VOID WriteDotEdges(FILE *fpOutputFile);

//////////////////////////////////////////////////
// Accessor Functions
//
public:

//////////////////////////////////////////////////
// Class Variables
//
public:

protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  DynInt m_dyniType;
  DynFloat m_dynfDensity;
  DynFloat m_dynfStart;
  DynFloat m_dynfEnd;
  DynVector m_vColor;
};

//////////////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline VOID CSLIDEFog::SetType(DynInt *pdyniType)
{
  m_dyniType.Set(pdyniType);
}

inline VOID CSLIDEFog::SetDensity(DynFloat *pdynfDensity)
{
  m_dynfDensity.Set(pdynfDensity);
}

inline VOID CSLIDEFog::SetStart(DynFloat *pdynfStart)
{
  m_dynfStart.Set(pdynfStart);
}

inline VOID CSLIDEFog::SetEnd(DynFloat *pdynfEnd)
{
  m_dynfEnd.Set(pdynfEnd);
}

inline VOID CSLIDEFog::SetColor(DynVector *pdynvColor)
{
  m_vColor.SetAll(pdynvColor);
}

#endif // __SLIDEFOG_H__


