#include "slidejpeg.h"
#ifdef TIFFANDJPEG
#include "jconfig.h"
#include "jpeglib.h"

int LoadJPEG(char *pcFile, char *pcTextureFile, BitMap *pBitMap)
{
  int iResult=0;
  struct jpeg_decompress_struct cinfo;
  struct jpeg_error_mgr jerr;
  cinfo.err = jpeg_std_error(&jerr);
  jpeg_create_decompress(&cinfo);

  FILE * infile;
  if ((infile = fopen(pcTextureFile, "rb")) == NULL) {
    fprintf(stderr, "can't open %s\n", pcTextureFile);
    return iResult;
  }
  jpeg_stdio_src(&cinfo, infile);
  jpeg_read_header(&cinfo, TRUE);
  jpeg_calc_output_dimensions(&cinfo);
  
  pBitMap->iWidth= cinfo.output_width;
  pBitMap->iHeight= cinfo.output_height;

  if (cinfo.output_components != 3) {
    fprintf(stderr, "%s:  can't read %d-plane JPEG file!",
	    pcTextureFile, cinfo.output_components);
    jpeg_destroy_decompress(&cinfo);
    fclose(infile);
    return iResult;
  }

  jpeg_start_decompress(&cinfo);
  
  pBitMap->iComps=cinfo.output_components;
  pBitMap->iBitsPerComp = 8;
  BYTE* pic = (BYTE *) malloc(pBitMap->iWidth * pBitMap->iHeight * pBitMap->iComps);

  JSAMPROW rowptr[1];

  while (cinfo.output_scanline < cinfo.output_height) {
    rowptr[0] = (JSAMPROW) &pic[(cinfo.output_height-cinfo.output_scanline-1)
			       * pBitMap->iWidth * pBitMap->iComps];
    (void) jpeg_read_scanlines(&cinfo, rowptr, (JDIMENSION) 1);
  }

  pBitMap->pvBuffer=pic;

  jpeg_finish_decompress(&cinfo);
  jpeg_destroy_decompress(&cinfo);
  fclose(infile);

  iResult=1;
  return iResult;
}
#endif
