#ifndef __SLIDELOOKAT_H__
#define __SLIDELOOKAT_H__

#include "slidetransform.h"

//////////////////////////////////////////////////////////////////////
// CSLIDELookAt Class
//

class CSLIDELookAt : public CSLIDETransform
{
//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDELookAt();
  virtual ~CSLIDELookAt();
  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:
  virtual VOID CheckDynamic();
  virtual VOID UpdateState();

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);
  virtual VOID WriteRIB(FILE *fpOutputFile);
  virtual VOID WritePOV(FILE *fpOutputFile);
  virtual VOID WriteDotNode(FILE *fpOutputFile);

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  virtual inline CHAR *GetTypeString();

  inline VOID SetEye(DynVector *pdynvEye);
  inline VOID SetTarget(DynVector *pdynvTarget);
  inline VOID SetUp(DynVector *pdynvUp);

//////////////////////////////////////////////////
// Class Variables
//
public:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  DynVector m_vEye;
  DynVector m_vTarget;
  DynVector m_vUp;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline CHAR *CSLIDELookAt::GetTypeString()
{
  return gcppcSLIDEReservedWords[sliderwtLookAt];
}

inline VOID CSLIDELookAt::SetEye(DynVector *pdynvEye)
{
  m_vEye.SetAll(pdynvEye);
}

inline VOID CSLIDELookAt::SetTarget(DynVector *pdynvTarget)
{
  m_vTarget.SetAll(pdynvTarget);
}

inline VOID CSLIDELookAt::SetUp(DynVector *pdynvUp)
{
  m_vUp.SetAll(pdynvUp);
}

#endif // __SLIDELOOKAT_H__


