#ifndef __SLIDEMESHEDGE_H__
#define __SLIDEMESHEDGE_H__

#include "slideprimitive.h"

class CSLIDEMesh;
class CSLIDEMeshVertex;
class CSLIDEMeshEdgeProperty;

class QEMesh;
class QEEdge;

//////////////////////////////////////////////////////////////////////
// CSLIDEMeshEdge Class
//

class CSLIDEMeshEdge : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Friends
//
public:

//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEMeshEdge();
  virtual ~CSLIDEMeshEdge();
  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, CHAR *pcID, 
		    CHAR *pcVertexID0, CHAR *pcVertexID1);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  inline VOID SetEdgePropertyID(CHAR *pcEdgePropertyID);

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld, CSLIDEMesh *pCSLIDEMesh,
			      QEMesh *pQEMesh);

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Iteration Functions
//
public:

//////////////////////////////////////////////////
// Geometric Computations
//
public:
  VOID Preprocess();

protected:
  VOID CheckDynamic();
  VOID UpdateState();

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  virtual inline SLIDEReservedWordType GetType();

  inline CSLIDEMeshEdgeProperty *GetEdgeProperty();

//////////////////////////////////////////////////
// Class Variables
//
protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  CHAR *m_ppcMeshVertexIDs[2];
  CSLIDEMeshVertex *m_ppCSLIDEMeshVertex[2];
  CHAR *m_pcMeshEdgePropertyID;
  CSLIDEMeshEdgeProperty *m_pCSLIDEMeshEdgeProperty;

  QEEdge *m_pQEEdge;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline SLIDEReservedWordType CSLIDEMeshEdge::GetType()
{
  return sliderwtMeshEdge;
}

inline VOID CSLIDEMeshEdge::SetEdgePropertyID(CHAR *pcEdgePropertyID)
{
  m_pcMeshEdgePropertyID = pcEdgePropertyID;
}

inline CSLIDEMeshEdgeProperty *CSLIDEMeshEdge::GetEdgeProperty()
{
  return m_pCSLIDEMeshEdgeProperty;
}

#endif // __SLIDEMESHEDGE_H__




