#include "slidemeshedgeproperty.h"
#include "slideworld.h"
#include "sliderender.h"
#include "sif.h"

CSLIDEMeshEdgeProperty *CSLIDEMeshEdgeProperty::m_pCSLIDEMeshEdgePropertyDefault = NULL;

// Default Values
static const FLOAT cfSharpness = 0.0;

//////////////////////////////////////////////////////////////////////
// CSLIDEMeshEdgeProperty Class
//

CSLIDEMeshEdgeProperty::CSLIDEMeshEdgeProperty()
{
}

CSLIDEMeshEdgeProperty::~CSLIDEMeshEdgeProperty()
{
}

VOID CSLIDEMeshEdgeProperty::Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
			 CHAR *pcID)
{
  CSLIDEPrimitive::Init(pcFile, uiLine, uiColumn, pcID);

  m_dynfSharpness.SetValue(cfSharpness);
}

VOID CSLIDEMeshEdgeProperty::Uninit()
{
  CSLIDEPrimitive::Uninit();
}

BOOL CSLIDEMeshEdgeProperty::Initialized()
{
  return CSLIDEPrimitive::Initialized();
}

BOOL CSLIDEMeshEdgeProperty::CheckSemantics(CSLIDEWorld *pCSLIDEWorld)
{
  BOOL bCorrect;

  bCorrect = CSLIDEPrimitive::CheckSemantics(pCSLIDEWorld);

  return bCorrect;
}

BOOL CSLIDEMeshEdgeProperty::Valid()
{
  if ( !CSLIDEPrimitive::Valid() )
    {
      return FALSE;
    }

  return TRUE;
}

VOID CSLIDEMeshEdgeProperty::CheckDynamic()
{
  SetDynamic(m_dynfSharpness.GetDynamic());
}

VOID CSLIDEMeshEdgeProperty::UpdateState()
{
  m_dynfSharpness.Update();
  if ( m_dynfSharpness.GetValue() < 0.0 )
    {
      m_dynfSharpness.SetValue(INFINITY);
    }
}

VOID CSLIDEMeshEdgeProperty::WriteSLIDE(FILE *fpOutputFile)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "%s %s\n",
	  gcppcSLIDEReservedWords[sliderwtMeshEdgeProperty], m_pcGUIID); 

  if ( m_dynfSharpness.GetValue() < 0.0 )
    {
      fprintf(fpOutputFile, "  %s SLF_INFINITY\n",
	      gcppcSLIDEReservedWords[sliderwtSharpness]);
    }
  else
    {
      fprintf(fpOutputFile, "  %s %.3f\n",
	      gcppcSLIDEReservedWords[sliderwtSharpness], 
	      m_dynfSharpness.GetValue());
    }

  fprintf(fpOutputFile, "%s\n",
	  gcppcSLIDEReservedWords[sliderwtEndMeshEdgeProperty]);
}


