#ifndef __SLIDEMESHEDGEPROPERTY_H__
#define __SLIDEMESHEDGEPROPERTY_H__

#include "slideprimitive.h"

//////////////////////////////////////////////////////////////////////////////
// CSLIDEMeshEdgeProperty Class
//

class CSLIDEMeshEdgeProperty : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEMeshEdgeProperty();
  virtual ~CSLIDEMeshEdgeProperty();
  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
		    CHAR *pcID);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  inline VOID SetSharpness(DynFloat *pdynfSharpness);

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:
  virtual VOID CheckDynamic();
  virtual VOID UpdateState();

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  inline VOID SetSharpness(FLOAT fSharpness);
  inline FLOAT GetSharpness() const;

  static inline CSLIDEMeshEdgeProperty *GetSLF_INHERIT();

//////////////////////////////////////////////////
// Class Variables
//
public:
  static CSLIDEMeshEdgeProperty *m_pCSLIDEMeshEdgePropertyDefault;

//////////////////////////////////////////////////
// Member Variables
//
protected:
  DynFloat m_dynfSharpness;
};

//////////////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline VOID CSLIDEMeshEdgeProperty::SetSharpness(FLOAT fSharpness)
{
  m_dynfSharpness.SetValue(fSharpness);
}

inline VOID CSLIDEMeshEdgeProperty::SetSharpness(DynFloat *pdynfSharpness)
{
  m_dynfSharpness.Set(pdynfSharpness);
}

inline FLOAT CSLIDEMeshEdgeProperty::GetSharpness() const
{
  return m_dynfSharpness.GetValue();
}

inline CSLIDEMeshEdgeProperty *CSLIDEMeshEdgeProperty::GetSLF_INHERIT()
{
  return m_pCSLIDEMeshEdgePropertyDefault;
}

#endif // __SLIDEMESHEDGEPROPERTY_H__


