#ifndef __SLIDEMESHFACET_H__
#define __SLIDEMESHFACET_H__

#include "slideprimitive.h"

class CSLIDEMesh;
class CSLIDEMeshVertex;

class QEMesh;
class QEFacet;

//////////////////////////////////////////////////////////////////////
// CSLIDEMeshFacet Class
//

class CSLIDEMeshFacet : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Friends
//
public:

//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEMeshFacet();
  virtual ~CSLIDEMeshFacet();
  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, CHAR *pcID, 
		    CListInt *plistMeshVertexIDs);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld, CSLIDEMesh *pCSLIDEMesh,
			      QEMesh *pQEMesh);

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Iteration Functions
//
public:

//////////////////////////////////////////////////
// Geometric Computations
//
public:
  VOID Preprocess();

protected:
  VOID CheckDynamic();
  VOID UpdateState();

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  virtual inline SLIDEReservedWordType GetType();

//////////////////////////////////////////////////
// Class Variables
//
protected:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  CListInt *m_plistMeshVertexIDs;
  CListInt m_listCSLIDEMeshVertex;

  QEFacet *m_pQEFacet;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline SLIDEReservedWordType CSLIDEMeshFacet::GetType()
{
  return sliderwtMeshFacet;
}

#endif // __SLIDEMESHFACET_H__




