#include "slidemeshvertexproperty.h"
#include "slideworld.h"
#include "sliderender.h"
#include "sif.h"

CSLIDEMeshVertexProperty *CSLIDEMeshVertexProperty::m_pCSLIDEMeshVertexPropertyDefault = NULL;

// Default Values
static const INT_32 ciType = 0;

//////////////////////////////////////////////////////////////////////
// CSLIDEMeshVertexProperty Class
//

CSLIDEMeshVertexProperty::CSLIDEMeshVertexProperty()
{
}

CSLIDEMeshVertexProperty::~CSLIDEMeshVertexProperty()
{
}

VOID CSLIDEMeshVertexProperty::Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
			 CHAR *pcID)
{
  CSLIDEPrimitive::Init(pcFile, uiLine, uiColumn, pcID);

  m_dyniType.SetValue(ciType);
}

VOID CSLIDEMeshVertexProperty::Uninit()
{
  CSLIDEPrimitive::Uninit();
}

BOOL CSLIDEMeshVertexProperty::Initialized()
{
  return CSLIDEPrimitive::Initialized();
}

BOOL CSLIDEMeshVertexProperty::CheckSemantics(CSLIDEWorld *pCSLIDEWorld)
{
  BOOL bCorrect;

  bCorrect = CSLIDEPrimitive::CheckSemantics(pCSLIDEWorld);

  return bCorrect;
}

BOOL CSLIDEMeshVertexProperty::Valid()
{
  if ( !CSLIDEPrimitive::Valid() )
    {
      return FALSE;
    }

  return TRUE;
}

VOID CSLIDEMeshVertexProperty::CheckDynamic()
{
  SetDynamic(m_dyniType.GetDynamic());
}

VOID CSLIDEMeshVertexProperty::UpdateState()
{
  m_dyniType.Update();
  if ( m_dyniType.GetValue() < 0 )
    {
      m_dyniType.SetValue(INFINITY);
    }
}

VOID CSLIDEMeshVertexProperty::WriteSLIDE(FILE *fpOutputFile)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "%s %s\n",
	  gcppcSLIDEReservedWords[sliderwtMeshVertexProperty], m_pcGUIID); 

  if ( m_dyniType.GetValue() < 0.0 )
    {
      fprintf(fpOutputFile, "  %s SLF_INFINITY\n",
	      gcppcSLIDEReservedWords[sliderwtType]);
    }
  else
    {
      fprintf(fpOutputFile, "  %s %.3f\n",
	      gcppcSLIDEReservedWords[sliderwtType], 
	      m_dyniType.GetValue());
    }

  fprintf(fpOutputFile, "%s\n",
	  gcppcSLIDEReservedWords[sliderwtEndMeshVertexProperty]);
}


