#ifndef __SLIDEMESHVERTEXPROPERTY_H__
#define __SLIDEMESHVERTEXPROPERTY_H__

#include "slideprimitive.h"

//////////////////////////////////////////////////////////////////////////////
// CSLIDEMeshVertexProperty Class
//

class CSLIDEMeshVertexProperty : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEMeshVertexProperty();
  virtual ~CSLIDEMeshVertexProperty();
  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
		    CHAR *pcID);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  inline VOID SetType(DynInt *pdyniType);

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:
  virtual VOID CheckDynamic();
  virtual VOID UpdateState();

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  inline VOID SetType(INT_32 iType);
  inline INT_32 GetType() const;

  static inline CSLIDEMeshVertexProperty *GetSLF_INHERIT();

//////////////////////////////////////////////////
// Class Variables
//
public:
  static CSLIDEMeshVertexProperty *m_pCSLIDEMeshVertexPropertyDefault;

//////////////////////////////////////////////////
// Member Variables
//
protected:
  DynInt m_dyniType;
};

//////////////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline VOID CSLIDEMeshVertexProperty::SetType(INT_32 iType)
{
  m_dyniType.SetValue(iType);
}

inline VOID CSLIDEMeshVertexProperty::SetType(DynInt *pdyniType)
{
  m_dyniType.Set(pdyniType);
}

inline INT_32 CSLIDEMeshVertexProperty::GetType() const
{
  return m_dyniType.GetValue();
}

inline CSLIDEMeshVertexProperty *CSLIDEMeshVertexProperty::GetSLF_INHERIT()
{
  return m_pCSLIDEMeshVertexPropertyDefault;
}

#endif // __SLIDEMESHVERTEXPROPERTY_H__


