#include "slidenode.h"
#include "slideworld.h"

//////////////////////////////////////////////////////////////////////
// CSLIDENode Class
//

CSLIDENode::CSLIDENode()
{
}

CSLIDENode::~CSLIDENode()
{
}

VOID CSLIDENode::Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, CHAR *pcID)
{
  CSLIDEPrimitive::Init(pcFile, uiLine, uiColumn, pcID);
}

VOID CSLIDENode::Uninit()
{
  CSLIDEPrimitive::Uninit();
}

BOOL CSLIDENode::Initialized()
{
  return CSLIDEPrimitive::Initialized();
}

BOOL CSLIDENode::CheckSemantics(CSLIDEWorld *pCSLIDEWorld)
{
  return CSLIDEPrimitive::CheckSemantics(pCSLIDEWorld);
}

BOOL CSLIDENode::Valid()
{
  return CSLIDEPrimitive::Valid();
}

VOID CSLIDENode::Remove(CSLIDEWorld *pCSLIDEWorld)
{
  CSLIDEPrimitive::Remove(pCSLIDEWorld);

  pCSLIDEWorld->RemoveNode(this);
  Uninit();
}

VOID CSLIDENode::GetSide(CListInt */*plistPoint*/,  CListInt */*plistNormal*/, 
			 UINT_32 /*uiSide*/, const Matrix &/*mTransform*/, 
			 const Matrix &/*mInverse*/, BOOL /*bReversed*/)
{
}

VOID CSLIDENode::PreprocessGraph()
{
}

VOID CSLIDENode::UpdateGraph()
{
}

VOID CSLIDENode::InsertIntoBound(const Matrix &/*m*/, CBound &/*bound*/)
{
  // This is the right thing to do for nodes with no bounds
  // like cameras and lights
}

#ifdef __USE_CDA__
VOID CSLIDENode::CalculateCDA()
{
}

VOID CSLIDENode::CalculateCDAVertices(CListInt * /*plistCDAVertex*/, 
				      const Matrix & /*mGroot_obj*/)
{
}
#endif // __USE_CDA__

VOID CSLIDENode::Prerender()
{
}

VOID CSLIDENode::RecallGeometry(SLIDEShadingType /*eShading*/)
{
}

VOID CSLIDENode::RecallNormals(SLIDEShadingType /*eShading*/)
{
}

VOID CSLIDENode::RecallBounds()
{
}

VOID CSLIDENode::Render(const Matrix &/*mGproj_obj*/, 
			CBound * /*pCBoundClip*/, 
			SLIDEShadingType /*eShading*/, 
			SLIDELODType /*eLOD*/)
{
}

VOID CSLIDENode::RenderGeometry(const Matrix &/*mGproj_obj*/, 
				CBound * /*pCBoundClip*/, 
				SLIDEShadingType /*eShading*/, 
				SLIDELODType /*eLOD*/,
				CSLIDEWormwarp * /*pCSLIDEWarp = NULL*/)
{
}

VOID CSLIDENode::RenderSelect(const Matrix &/*mGproj_obj*/, 
			      CBound * /*pCBoundClip*/, 
			      SLIDEShadingType /*eShading*/, 
			      SLIDELODType /*eLOD*/)
{
}

VOID CSLIDENode::RenderBound()
{
}

VOID CSLIDENode::RenderGUISelectedBound()
{
}

VOID CSLIDENode::RenderGraphSelectedBound()
{
}

VOID CSLIDENode::RenderGUISelectedAxes(BOOL /*bSelected*/, BOOL /*bXAxisSelected*/,
				       BOOL /*bYAxisSelected*/, BOOL /*bZAxisSelected*/)
{
}

VOID CSLIDENode::WriteRIB(FILE * /*fpOutputFile*/,
			  const Matrix &/*mGproj_obj*/,
			  CBound * /*pCBoundClip*/, 
			  SLIDEShadingType /*eShading*/,
			  SLIDELODType /*eLOD*/)
{
}

VOID CSLIDENode::WritePOV(FILE * /*fpOutputFile*/, 
			  CListInt * /*plistTransformIDs*/,
			  CListInt * /*plistColors*/) 
{
}

VOID CSLIDENode::WriteWRLZ(FILE * /*fpOutputFile*/, const Matrix &/*mTransform*/,
			   CSLIDESurface */*pCSLIDESurface*/)
{
}

VOID CSLIDENode::WriteSTL(FILE * /*fpOutputFile*/, const Matrix &/*mTransform*/)
{
}

QEMesh *CSLIDENode::WriteSIF(FILE * /*fpOutputFile*/, UINT_32 /*uiIndentLevel*/, 
			     const Matrix &/*mGroot_obj*/, const Matrix &/*mGobj_root*/,
			     QEMesh * /*pmeBoundaryEdges*/)

{
  return NULL;
}

VOID CSLIDENode::WriteLSIF(FILE * /*fpOutputFile*/, UINT_32 /*uiIndentLevel*/)
{
}

VOID CSLIDENode::WriteLSIFOffset(FILE * /*fpOutputFile*/, UINT_32 /*uiIndentLevel*/)
{
}

QEMesh *CSLIDENode::GetQEMesh()
{
  return NULL;
}

VOID CSLIDENode::CalculateLeafQEMesh()
{
}

VOID CSLIDENode::DeallocateLeafQEMesh()
{
}
