#ifndef __SLIDEPATH_H__
#define __SLIDEPATH_H__

#include "slideprimitive.h"
#include "slidenode.h"

class CSLIDENode;

//////////////////////////////////////////////////////////////////////
// CSLIDEPath Class
//

class CSLIDEPath : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDEPath();
  virtual ~CSLIDEPath();

  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn, 
		    CListInt *plistPathIDs);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);
  virtual CSLIDENode *FindNode(CSLIDENode *pRoot, CListIterInt *piterIDs, 
			       CListInt *plistCSLIDEInstance) = 0;

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Geometric Computations
//
public:

protected:
  virtual VOID CheckDynamic();
  virtual VOID UpdateState();

//////////////////////////////////////////////////
// Rendering
//
public:
//  virtual VOID Render(const Matrix &m);

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);
  virtual VOID WriteDotEdges(FILE *fpOutputFile);

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  inline const Matrix &GetObjectToRoot() const;
  inline const Matrix &GetRootToObject() const;

  inline CHAR *GetRootID();
  inline UINT_32 GetInstanceLength();

//////////////////////////////////////////////////
// Class Variables
//
public:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  CListInt *m_plistPathIDs;
  
  CSLIDENode *m_pRoot;
  CListInt m_listCSLIDEInstance;
  CSLIDENode *m_pNode;

  Matrix m_mGroot_obj;
  Matrix m_mGobj_root;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline const Matrix &CSLIDEPath::GetObjectToRoot() const
{
  return m_mGroot_obj;
}

inline const Matrix &CSLIDEPath::GetRootToObject() const
{
  return m_mGobj_root;
}

inline CHAR *CSLIDEPath::GetRootID()
{
  return m_pRoot->GetID();
}

inline UINT_32 CSLIDEPath::GetInstanceLength()
{
  return m_listCSLIDEInstance.GetLength();
}

#endif // __SLIDEPATH_H__


