#include "slidetiff.h"
#ifdef TIFFANDJPEG
#include "tiff.h"
#include "tiffio.h"

int LoadTIFF(char *pcFile, char *pcTextureFile, BitMap *pBitMap)
{
  int iResult=0;
  TIFF* tif = TIFFOpen(pcTextureFile, "r");
  if (tif) {
    uint32 w, h;
    size_t npixels;
    uint32* raster;
    
    TIFFGetField(tif, TIFFTAG_IMAGEWIDTH, &w);
    TIFFGetField(tif, TIFFTAG_IMAGELENGTH, &h);
    npixels = w * h;
    raster = (uint32*) _TIFFmalloc(npixels * sizeof (uint32));
    if (raster != NULL) {
      if (TIFFReadRGBAImage(tif, w, h, raster, 0)) {
	ColorEntry* pceBuffer=new ColorEntry[npixels];
	//uint32* rSource=raster;
	//(int)rSource+=1; // byte offset to get rid of A comp
	uint32* rSource = (uint32*)(((char*)raster)+1); // byte offset to get rid of A comp
	ColorEntry* ceDest=pceBuffer;
	for(int i=0; i<npixels; i++){
	  memcpy(ceDest, rSource, sizeof(ColorEntry));
	  ceDest+=1;
	  rSource+=1;
	}
	_TIFFfree(raster);
	pBitMap->pvBuffer=pceBuffer;
	pBitMap->iComps=3;
	pBitMap->iBitsPerComp=8;
	pBitMap->iWidth=w;
	pBitMap->iHeight=h;
	iResult=1;
      }
    }
    TIFFClose(tif);
  }
  return iResult;
}
#endif
