#ifndef __SLIDETRANSFORM_H__
#define __SLIDETRANSFORM_H__

#include "slideprimitive.h"

//////////////////////////////////////////////////////////////////////
// CSLIDETransform Class
//

class CSLIDETransform : public CSLIDEPrimitive
{
//////////////////////////////////////////////////
// Enumerated Types
//

//////////////////////////////////////////////////
// Initialization
//
public:
  CSLIDETransform();
  virtual ~CSLIDETransform();
  virtual VOID Init(CHAR *pcFile, UINT_32 uiLine, UINT_32 uiColumn);
  virtual VOID Uninit();

  virtual BOOL Initialized();

  virtual BOOL CheckSemantics(CSLIDEWorld *pCSLIDEWorld);

  virtual BOOL Valid();

//////////////////////////////////////////////////
// Geometric Computations
//
public:
  virtual inline VOID ComposeWith(CSLIDETransform *pCSLIDETransform);
  virtual inline VOID Set(CSLIDETransform *pCSLIDETransform);
  virtual inline VOID Modify(CSLIDETransform *pCSLIDETransformLast, 
			     CSLIDETransform *pCSLIDETransformNew);

protected:

//////////////////////////////////////////////////
// Rendering
//
public:

//////////////////////////////////////////////////
// Output Functions
//
public:
  virtual VOID WriteSLIDE(FILE *fpOutputFile);
  virtual VOID WriteRIB(FILE *fpOutputFile);
  virtual VOID WritePOV(FILE *fpOutputFile);
  virtual VOID WriteDotNode(FILE *fpOutputFile) = 0;

//////////////////////////////////////////////////
// Accessor Functions
//
public:
  inline const Matrix &GetMatrix();
  inline const Matrix &GetInverse();
//  inline VOID SetMatrix(const Matrix &m);

//////////////////////////////////////////////////
// Class Variables
//
public:

//////////////////////////////////////////////////
// Member Variables
//
protected:
  Matrix m_m;
  Matrix m_mInverse;
};

//////////////////////////////////////////////////////////////////////
// Inlined Functions
//

inline const Matrix &CSLIDETransform::GetMatrix()
{
  return m_m;
}

inline const Matrix &CSLIDETransform::GetInverse()
{
  return m_mInverse;
}
/*
inline VOID CSLIDETransform::SetMatrix(const Matrix &m)
{
  m_m = m;
}
*/

inline VOID CSLIDETransform::ComposeWith(CSLIDETransform */*pCSLIDETransform*/)
{
  ASSERT(FALSE);
}

inline VOID CSLIDETransform::Set(CSLIDETransform */*pCSLIDETransform*/)
{
  ASSERT(FALSE);
}

inline VOID CSLIDETransform::Modify(CSLIDETransform */*pCSLIDETransformLast*/, 
				    CSLIDETransform */*pCSLIDETransformNew*/)
{
  ASSERT(FALSE);
}

#endif // __SLIDETRANSFORM_H__


