#include "slidetranslate.h"

//////////////////////////////////////////////////////////////////////
// CSLIDETranslate Class
//

CSLIDETranslate::CSLIDETranslate()
{
  m_vTranslate.Set(1.0, 1.0, 1.0);
}

CSLIDETranslate::~CSLIDETranslate()
{
}

VOID CSLIDETranslate::Init(CHAR *pcFile, UINT_32 uiLine, 
			   UINT_32 uiColumn, 
			   DynVector *pdynv)
{
  ASSERT( pdynv != NULL );

  CSLIDETransform::Init(pcFile, uiLine, uiColumn);

  m_vTranslate.SetAll(pdynv);

  m_m.SetTranslate(m_vTranslate);
  m_mInverse.SetTranslate(-m_vTranslate);
}

VOID CSLIDETranslate::Uninit()
{
  CSLIDETransform::Uninit();
}

BOOL CSLIDETranslate::Initialized()
{
  return CSLIDETransform::Initialized();
}

BOOL CSLIDETranslate::CheckSemantics(CSLIDEWorld *pCSLIDEWorld)
{
  if ( !CSLIDETransform::CheckSemantics(pCSLIDEWorld) )
    {
      return FALSE;
    }

  return TRUE;
}

BOOL CSLIDETranslate::Valid()
{
  if ( !CSLIDETransform::Valid() )
    {
      return FALSE;
    }

  return TRUE;
}

VOID CSLIDETranslate::CheckDynamic()
{
  SetDynamic(m_vTranslate.GetDynamic());
}

VOID CSLIDETranslate::UpdateState()
{
  m_vTranslate.Update();
  m_m.SetTranslate(m_vTranslate);
  m_mInverse.SetTranslate(-m_vTranslate);
}

VOID CSLIDETranslate::WriteSLIDE(FILE *fpOutputFile)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "    %s ( %.3f %.3f %.3f )\n", 
	  gcppcSLIDEReservedWords[sliderwtTranslate],
	  m_vTranslate[X], m_vTranslate[Y], m_vTranslate[Z]);
}

VOID CSLIDETranslate::WriteRIB(FILE *fpOutputFile)
{
  ASSERT( fpOutputFile != NULL );

  RiTranslate(m_vTranslate[X], m_vTranslate[Y], m_vTranslate[Z]);
}

VOID CSLIDETranslate::WritePOV(FILE *fpOutputFile)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "  %s <%.3f, %.3f, %.3f> \n",
	  gcppcSLIDEReservedWords[sliderwtTranslate], 
	  m_vTranslate[X], m_vTranslate[Y], m_vTranslate[Z]);	  
}

VOID CSLIDETranslate::WriteDotNode(FILE *fpOutputFile)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "T");
}
